Dim Shared As Double auxvar
#Include "windows.bi"
#include "win/mmsystem.bi"
#Include "partition.bi"

Dim Shared As Integer quit=0
Sub guinotice(ByRef msg As string,ByRef title As String ="notice")
Dim As HWND hwin
'ScreenControl(2, Cast(Integer,hwin)) 'get screen handle
	messagebox(hwin,msg,title,MB_TASKMODAL Or 0)
   Sleep 200
End Sub


Type STATUSBYTE
  As Ubyte channel:4
  As Ubyte status :4
End Type

Type MIDIMESSAGE
  Union
  Type
  Union
  As STATUSBYTE Byte
  As Ubyte      byte0
  End Union
  As Ubyte      byte1
  As Ubyte      byte2
  As Ubyte      byte3
  End Type
  As Uinteger   value
  End Union
End Type

Dim Shared As Integer imidi,ichannel
Dim Shared As String ficin
Const As String ficini="displaymidi_chung.ini"
Dim Shared As Integer File
file=FreeFile
Open ficini For Input As #file
imidi=0
If Not Eof(file) Then Line Input #file,ficin:imidi=Val(ficin)
ichannel=0
If Not Eof(file) Then Line Input #file,ficin:ichannel=Val(ficin)
Close #file


Dim Shared As Integer wx,wy,depth            
ScreenInfo wx,wy,depth
	 	         'Screen 0
	 	         Var dx=1018,dy=600
               ScreenRes dx,dy,depth,1,4
               ScreenControl(100,wx/2-dx/2,wy/2-24-dy/2) 'set window position
               Color RGB(155, 255, 255), RGB(0, 0, 100)
               partitionimage=bmp_load("media/partition1.bmp")
               cls
               Put(1,ymax+15),partitionimage,PSet
               Put(1,ymax+255),partitionimage,PSet
               partitionx=0:partitiony=0

Dim Shared As Integer imidi,ichannel
Sub MidiInProc(Byval hDevice   As HMIDIIN, _
               Byval DriverMsg As Uinteger, _   
               Byval UserArg   As HMIDIOUT, _
               Byval MidiMsg   As MIDIMESSAGE, _   
               Byval Param2    As Uinteger)
  'Locate 0'Cls
  Select Case As Const DriverMsg
    Case MIM_DATA     
      If UserArg Then
         midiOutShortMsg(UserArg,MidiMsg.value)
         '? "send data to MIDI out time=" & Param2/1000
      Else
         '? "got MIDI in data time=" & Param2/1000
      End If
      
      With MidiMsg
        Select Case As Const .byte.status
          Case &H8
            '? "channel=" & .byte.channel _
            '& " note off key/note=" & .byte1 
          Case &H9
            If .byte2=0 Then ' if velocity=0
              '? "channel=" & .byte.channel _
              '& " note off key/note=" & .byte1
            Else
              '? "channel=" & .byte.channel _
              '& " note on  key/note=" & .byte1 _
              '& " velocity=" & .byte2
              'PSet (Timer-t1,MidiMsg.byte1)
              If ichannel=0 Or midimsg.byte.channel=(ichannel) Then drawnote(midimsg.byte1) 
            End If
          Case &HA:'? "Polyphonic Aftertouch"
          Case &HB:'? "Control Mode Change " & .byte1 & "," & .byte2
          Case &HC:'? "Program Change "      & .byte1
          Case &HD:'? "Channel Aftertouch"
          Case &HE:'? "Pitch Wheel Control " & .byte1 & "," & .byte2*128
          Case &HF:'? "System Exclusive Message (SysEx)"
          Case Else
            '? "param1=" & Hex(.value,8) & " param2=" & Hex(Param2,8)
      End Select
    End With
    Case MIM_OPEN     : '? "MIDIIN open"
    Case MIM_CLOSE    : '? "MIDIIN close"
    Case MIM_LONGDATA
    Case MIM_ERROR
    Case MIM_LONGERROR
    Case MIM_MOREDATA 
    Case Else: '? "MIDIIN unknow message &H[" & Hex(DriverMsg) & "] !"
  End Select
End Sub


Dim As MMRESULT ret
ret=midiInGetNumDevs()
If ret<1 Then
  ? "error: sorry no MIDI input on this system!"
  Beep:Sleep':ImageDestroy partitionimage
  'End
end If
Dim As HMIDIIN hDevice
ret=midiInOpen(@hDevice,0, _
                cast(Uinteger,@MidiInProc), _
                0, _
                CALLBACK_FUNCTION)
If ret Then
  ? "error can't open first MIDI input !"
  Beep:Sleep':ImageDestroy partitionimage
  'End
end If

ret=midiInStart(hDevice)
If ret Then
  midiInClose hDevice
  ? "error can't start MIDI input !"
  Beep:Sleep':ImageDestroy partitionimage
  'End
end If

Sub drawtext0()
	Locate 5,10
	?"[M]midiin("+Str(imidi)+")   "
	Locate 5,30
	?"[C]channel("+Str(ichannel)+")  ";
End Sub
Sub drawtext00()
	drawtext0()
   Put(1,ymax+15),partitionimage,PSet
   Put(1,ymax+255),partitionimage,PSet
End Sub
'cls
drawtext0()

Dim Shared As String key,resp
While Key="" And quit=0
	key=LCase(InKey) 
   If GetMouse(mousex2,mousey2,wheel2,buttons2)=0 Then
      	If 1 And buttons2 Then
      		partitionpause=(partitionpause+1)Mod 2
      		If partitionpause=1 Then
      			Draw String (430,75),"PAUSE",RGB(255,0,0)
      		Else
      			Draw String (430,75),"PAUSE",RGB(0,0,100)
      		EndIf
      		Sleep 200
      	EndIf
   EndIf
   If key="m" Then
   	partitionpause=1
	   Cls:Locate 2,1
      Dim As midiincaps mymidiincaps
      ret=midiInGetNumDevs()
      Var nmidi=ret
      If ret<1 Then
         ?"warning : sorry no MIDI input on this system!"
         Beep:Sleep
      Else
         nmidi=min2(30,nmidi)
         Var i=0	
         for i=0 to nmidi-1
             ret=midiInGetDevCaps(i,@mymidiincaps,SizeOf(mymidiincaps))
             If ret=0 Then
             	 ?Str(i)+"="+Trim(mymidiincaps.szPname)
             EndIf
         Next i
      EndIf 
      ?""
	   ?"midiin : enter a value (0.."+Str(nmidi-1)+")"
	   ?"        initial=0  last="+Str(imidi)
	   Input ;resp
	   If resp<>"" Then 
	   	imidi=max2(0,min2(nmidi-1,Val(resp)))
         midiInStop  hDevice
	   	midiinClose hdevice
         imidi=max2(0,min2(nmidi-1,imidi))	
         ret=midiInOpen(@hDevice,imidi, _
                 cast(Uinteger,@MidiInProc), _
                 0, _
                 CALLBACK_FUNCTION)
         If ret Then
	             ?("warning error open midiin("+Str(imidi)+")")
                Beep:Sleep':ImageDestroy partitionimage
                'End
         EndIf
         If ret=0 Then
         	ret=midiInStart(hDevice)
            If ret Then
                midiInClose hDevice
                ? "error can't start MIDI input !"
                Beep:Sleep':ImageDestroy partitionimage
                'End
             EndIf
         EndIf
	   EndIf
	   key=""
	   Cls 
     	drawtext00()
     	partitionpause=0
   EndIf
   If key="c" Then
   	partitionpause=1
   	Cls
   	?""
   	?"midi channel : enter a number 0=all  1...16  last="+Str(ichannel)
   	?""
	   Input ;resp
	   If resp<>"" Then 
	   	ichannel=max2(0,min2(16,Val(resp)))
	   EndIf
	   Sleep 200
	   Cls 
	   drawtext00()
   	partitionpause=0
	   key=""
   EndIf    
	Sleep 100
   If Abs(auxvar)>0.000001 Then Locate 5,100:?"aux="+Str(auxvar)+"          "; 
Wend
midiInStop   hDevice
midiInClose  hDevice
ImageDestroy partitionimage


file=freefile
Open ficini For Output As #file
Print #file,imidi
Print #file,ichannel
Close #file

End













