#Include Once "windows.bi"
#Include Once "GL/gl.bi"
#include Once "GL/glu.bi"

Static Shared As glfloat glparamfloat4(4) 
Static Shared As glint glparamint4(4) 
Function glparam4f(ByVal x As Single,ByVal y As Single,ByVal z As Single,ByVal t As Single) As glfloat Ptr 
	glparamfloat4(0)=x
	glparamfloat4(1)=y
	glparamfloat4(2)=z
	glparamfloat4(3)=t
Return @glparamfloat4(0)	
End Function
Function glparam4i(ByVal x As integer,ByVal y As integer,ByVal z As integer,ByVal t As Integer) As glint Ptr 
	glparamint4(0)=x
	glparamint4(1)=y
	glparamint4(2)=z
	glparamint4(3)=t
Return @glparamint4(0)	
End Function
sub glsphere(ByVal rayon As Double,ByVal nx As uint=20,ByVal ny As uint=20)
   Dim As gluquadric Ptr hquad
   hquad=gluNewQuadric()
   gluSphere hquad,rayon,nx,ny
   gluDeleteQuadric hquad
end sub
Sub gltexsphere(ByVal rayon As Double,ByVal nx As uint=20,ByVal ny As uint=20)
   Dim As gluquadric Ptr hquad
   hquad=gluNewQuadric()
   gluQuadricTexture hquad,GL_TRUE
   gluSphere hquad,rayon,nx,ny
   gluDeleteQuadric hquad
End Sub
Sub glcylindre(ByVal rbase As Double,ByVal rtop As Double,ByVal haut As Double,_ 
	            ByVal nx As uint=20,ByVal ny As uint=20)
   Dim As gluquadric Ptr hquad
   hquad=gluNewQuadric()
   glucylinder hquad,rbase,rtop,haut,nx,ny
   gluDeleteQuadric hquad
end sub
Sub gltexcylindre(ByVal rbase As Double,ByVal rtop As Double,ByVal haut As Double,_ 
	            ByVal nx As uint=20,ByVal ny As uint=20)
   Dim As gluquadric Ptr hquad
   hquad=gluNewQuadric()
   gluQuadricTexture hquad,GL_TRUE
   glucylinder hquad,rbase,rtop,haut,nx,ny
   gluDeleteQuadric hquad
end sub
Sub gldisk(ByVal rint As Double,ByVal rext As Double,ByVal nx As uint=20,ByVal ny As uint=20)
   Dim As gluquadric Ptr hquad
   hquad=gluNewQuadric()
   glnormal3d 0,0,1
   gludisk hquad,rint,rext,nx,ny
   gluDeleteQuadric hquad
end sub
Sub gltexdisk(ByVal rint As Double,ByVal rext As Double,ByVal nx As uint=20,ByVal ny As uint=20)
   Dim As gluquadric Ptr hquad
   hquad=gluNewQuadric()
   glnormal3d 0,0,1
   gluQuadricTexture hquad,GL_TRUE
   gludisk hquad,rint,rext,nx,ny
   gluDeleteQuadric hquad
end sub
Sub gldiskangle(ByVal rint As Double,ByVal rext As Double,_ 
	             ByVal angle1 As Double,ByVal angle2 As Double,_ 
	             ByVal nx As uint=20,ByVal ny As uint=20) 
   Dim As gluquadric Ptr hquad
   hquad=gluNewQuadric()
   glnormal3d 0,0,1
   glupartialdisk hquad,rint,rext,nx,ny,angle1,angle2
   gluDeleteQuadric hquad
end sub
sub gltexdiskangle(ByVal rint As Double,ByVal rext As Double,_ 
	             ByVal angle1 As Double,ByVal angle2 As Double,_ 
	             ByVal nx As uint=20,ByVal ny As uint=20) 
   Dim As gluquadric Ptr hquad
   hquad=gluNewQuadric()
   glnormal3d 0,0,1
   gluQuadricTexture hquad,GL_TRUE
   glupartialdisk hquad,rint,rext,nx,ny,angle1,angle2
   gluDeleteQuadric hquad
end sub
Sub glcarre(ByVal dx As Single)
	glbegin(gl_quads)
	glvertex3f(-dx,-dx,0)
	glvertex3f(dx,-dx,0)
	glvertex3f(dx,dx,0)
	glvertex3f(-dx,dx,0)
	glend()
End Sub
Sub glcarre2(byval x As Single,ByVal y As Single)
Dim As Single x1,x0
x1=x*0.5:x0=0-x1
	glbegin(gl_quads)
	glvertex3f(0,x0,0)
	glvertex3f(0,x1,0)
	glvertex3f(0,x1,y)
	glvertex3f(0,x0,y)
	glend()
End Sub
Sub glcarre3(ByVal dx As Single)
	glbegin(gl_quads)
	glvertex3f(0,-dx,-dx)
	glvertex3f(0,dx,-dx)
	glvertex3f(0,dx,dx)
	glvertex3f(0,-dx,dx)
	glend()
End Sub
Sub gltexcarre(ByVal dx As Single,ByVal tx As Single=1)
	glbegin(gl_quads)
	glTexCoord2f(0,0)
	glvertex3f(-dx,-dx,0)
	gltexcoord2f(tx,0)
	glvertex3f(dx,-dx,0)
	glTexCoord2f(tx,tx)
	glvertex3f(dx,dx,0)
	gltexcoord2f(0,tx)
	glvertex3f(-dx,dx,0)
	glend()
End Sub 
Sub gltexcarrexy(ByVal dx As Single,tx0 As Single=0,ty0 As Single=0,ByVal tx As Single=1)
	glbegin(gl_quads)
	glTexCoord2f(tx0,ty0)
	glvertex3f(-dx,-dx,0)
	gltexcoord2f(tx0+tx,ty0)
	glvertex3f(dx,-dx,0)
	glTexCoord2f(tx0+tx,ty0+tx)
	glvertex3f(dx,dx,0)
	gltexcoord2f(tx0,ty0+tx)
	glvertex3f(-dx,dx,0)
	glend()
End Sub 
Sub gltexcarredtxy(ByVal dx As Single,ByVal dy As Single,ByVal dz As Single,tx0 As Single=0,ty0 As Single=0,ByVal dtx As Single=1,ByVal dty As Single=1)
	glbegin(gl_quads)
	glTexCoord2f(tx0,ty0)
	glvertex3f(0,-dx,0)
	gltexcoord2f(tx0+dtx,ty0)
	glvertex3f(0,dx,0)
	glTexCoord2f(tx0+dtx,ty0+dty)
	glvertex3f(0,dy,dz)
	gltexcoord2f(tx0,ty0+dty)
	glvertex3f(0,-dy,dz)
	glend()
End Sub 
Sub gltexcarre2(byval x As Single,ByVal y As Single,ByVal tx As Single=1)
Dim As Single x1,x0,dtx
x1=x*0.5:x0=0-x1:dtx=0'max(0.0,tx*(y/x-1)*0.5)
	glbegin(gl_quads)
	glTexCoord2f(dtx,0)
	glvertex3f(0,x0,0)
	gltexcoord2f(tx-dtx,0)
	glvertex3f(0,x1,0)
	glTexCoord2f(tx-dtx,tx)
	glvertex3f(0,x1,y)
	gltexcoord2f(dtx,tx)
	glvertex3f(0,x0,y)
	glend()
End Sub
Sub gltexrotcarre2(byval x As Single,ByVal y As Single,ByVal o1 As Single=0,ByVal tx As Single=0.75)
Dim As Single x1,x0,dtx,dty
Dim As Single co1,si1
co1=Cos(o1*3.1416/180):si1=Sin(o1*3.1416/180)
x1=x*0.5:x0=0-x1:dtx=co1*0.5*tx*x/max(0.001,y):dty=si1*0.5*tx
	glbegin(gl_quads)
	glTexCoord2f(0.5-dtx+dty,0.5-dtx-dty)
	glvertex3f(0,x0,0)
	gltexcoord2f(0.5+dtx+dty,0.5-dtx+dty)
	glvertex3f(0,x1,0)
	glTexCoord2f(0.5+dtx-dty,0.5+dtx+dty)
	glvertex3f(0,x1,y)
	gltexcoord2f(0.5-dtx-dty,0.5+dtx-dty)
	glvertex3f(0,x0,y)
	glend()
End Sub
Sub gltexcarre2rot(byval x As Single,ByVal y As Single,ByVal o1 As Single,ByVal tx As Single=1)
Dim As Single x1,x0,y1,y0,co1,si1
co1=Cos(o1*3.1416/180):si1=Sin(o1*3.1416/180)
x1=x*0.5*co1:x0=-x1
y1=x*0.5*si1:y0=-y1
	glbegin(gl_quads)
	glTexCoord2f(0,0)
	glvertex3f(y0,x0,0)
	gltexcoord2f(tx,0)
	glvertex3f(y1,x1,0)
	glTexCoord2f(tx,tx)
	glvertex3f(y1,x1,y)
	gltexcoord2f(0,tx)
	glvertex3f(y0,x0,y)
	glend()
End Sub
sub gltexcarre2dz(byval x As Single,ByVal y As Single,ByVal dz As Single,ByVal tx As Single=1)
Dim As Single x1,x0,y1,y0
x1=x*0.5:x0=0-x1
	glbegin(gl_quads)
	glTexCoord2f(0,0)
	glvertex3f(0,x0,-dz)
	gltexcoord2f(tx,0)
	glvertex3f(0,x1,dz)
	glTexCoord2f(tx,tx)
	glvertex3f(0,x1,y+dz)
	gltexcoord2f(0,tx)
	glvertex3f(0,x0,y-dz)
	glend()
End Sub
Sub gltexcarre3(byval x As Single,ByVal y As Single,ByVal tx As Single=1)
Dim As Single x1,x0,y1,y0
x1=x*0.5:x0=-x1
y1=y*0.5:y0=-y1
	glbegin(gl_quads)
	glTexCoord2f(0,0)
	glvertex3f(0,x0,y0)
	gltexcoord2f(tx,0)
	glvertex3f(0,x1,y0)
	glTexCoord2f(tx,tx)
	glvertex3f(0,x1,y1)
	gltexcoord2f(0,tx)
	glvertex3f(0,x0,y1)
	glend()
End Sub
sub gltexcarre4(byval x As Single,ByVal y As Single,tx As Single=1,kx As Single=1)
Dim As Single x1,x0,y1,y0
x1=x*0.5:x0=-x1
y1=y*0.5:y0=-y1
	glbegin(gl_quads)
	glTexCoord2f(0,0)
	glvertex3f(x0,y0,0)
	gltexcoord2f(tx,0)
	glvertex3f(x1,y0,0)
	glTexCoord2f(tx,tx*0.995*kx)
	glvertex3f(x1,y1,0)
	gltexcoord2f(0,tx*0.995*kx)
	glvertex3f(x0,y1,0)
	glend()
End Sub
sub gltexcarre5(byval x As Single,ByVal y As Single,ByVal tx As Single=1)
Dim As Single x1,x0,y1,y0
x1=x*0.5:x0=-x1
y1=y*0.5:y0=-y1
	glbegin(gl_quads)
	glTexCoord2f(tx,0)
	glvertex3f(x0,y0,0)
	gltexcoord2f(tx,tx)
	glvertex3f(x1,y0,0)
	glTexCoord2f(0,tx)
	glvertex3f(x1,y1,0)
	gltexcoord2f(0,0)
	glvertex3f(x0,y1,0)
	glend()
End Sub
sub gltexface2(byval x As Single,ByVal y As Single,ByVal r As Single,ByVal tx As Single=1,ByVal ty As Single=1)
Dim As Single x1,x0,rx
rx=r
x1=x*0.5:x0=0-x1
	glbegin(gl_quads)
	glTexCoord2f(0,0)
	glvertex3f(-rx,x0,0)
	gltexcoord2f(tx,0)
	glvertex3f(-rx,x1,0)
	glTexCoord2f(tx,ty)
	glvertex3f(-rx,x1,y)
	gltexcoord2f(0,ty)
	glvertex3f(-rx,x0,y)

	glTexCoord2f(0,0)
	glvertex3f(rx,x0,0)
	gltexcoord2f(tx,0)
	glvertex3f(rx,x1,0)
	glTexCoord2f(tx,ty)
	glvertex3f(rx,x1,y)
	gltexcoord2f(0,ty)
	glvertex3f(rx,x0,y)
	
	glTexCoord2f(0,0)
	glvertex3f(-rx,x0,0)
	gltexcoord2f(tx,0)
	glvertex3f(-rx,x1,0)
	glTexCoord2f(tx,ty)
	glvertex3f(rx,x1,y)
	gltexcoord2f(0,ty)
	glvertex3f(rx,x0,y)

	glTexCoord2f(0,0)
	glvertex3f(rx,x0,0)
	gltexcoord2f(tx,0)
	glvertex3f(rx,x1,0)
	glTexCoord2f(tx,ty)
	glvertex3f(-rx,x1,y)
	gltexcoord2f(0,ty)
	glvertex3f(-rx,x0,y)
	glend()
End Sub
Sub gltexquad (ByVal x1 As Single,ByVal y1 As Single,ByVal z1 As Single,_ 
             ByVal x2 As Single,ByVal y2 As Single,ByVal z2 As Single,_
             ByVal x3 As Single,ByVal y3 As Single,ByVal z3 As Single,_
             ByVal x4 As Single,ByVal y4 As Single,ByVal z4 As Single,_ 
             ByVal tx As Single=1,ByVal ty As Single=1,ByVal tx0 As Single=0)
glBegin GL_QUADS
glTexCoord2f tx0,0
glVertex3f x1,y1,z1
glTexCoord2f tx0+tx,0
glVertex3f x2,y2,z2
glTexCoord2f tx0+tx,ty
glVertex3f x3,y3,z3
glTexCoord2f tx0,ty
glVertex3f x4,y4,z4
glEnd
End Sub
Sub gltriangle (ByVal x1 As Single,ByVal y1 As Single,ByVal z1 As Single,_ 
                ByVal x2 As Single,ByVal y2 As Single,ByVal z2 As Single,_
                ByVal x3 As Single,ByVal y3 As Single,ByVal z3 As Single )
glBegin GL_triangles
glVertex3f x1,y1,z1
glVertex3f x2,y2,z2
glVertex3f x3,y3,z3
glend
End Sub
sub gltextriangle (ByVal x1 As Single,ByVal y1 As Single,ByVal z1 As Single,_ 
                ByVal x2 As Single,ByVal y2 As Single,ByVal z2 As Single,_
                ByVal x3 As Single,ByVal y3 As Single,ByVal z3 As Single )
glBegin GL_triangles
glTexCoord2f 0,0
glVertex3f x1,y1,z1
glTexCoord2f 2,4
glVertex3f x2,y2,z2
glTexCoord2f 4,0
glVertex3f x3,y3,z3
glend
End Sub
sub glligne  (ByVal x1 As Single,ByVal y1 As Single,ByVal z1 As Single,_ 
             ByVal x2 As Single,ByVal y2 As Single,ByVal z2 As Single)
glBegin GL_LINES
glVertex3f x1,y1,z1
glvertex3f x2,y2,z2
glEnd
End sub
Type myPoint
    As Single x,y,z
    #define vct Type<myPoint>
    #define dot *
    #define cross ^
End Type

Type Line
    As myPoint v1,v2
End Type

Type plane
    As myPoint v1,v2,v3
End Type

Type triangle As plane


'==========  Some arithmetical operators on 3D myPoints ===============
Operator + (v1 As myPoint,v2 As myPoint) As myPoint
Return vct(v1.x+v2.x,v1.y+v2.y,v1.z+v2.z)
End Operator
Operator -(v1 As myPoint,v2 As myPoint) As myPoint
Return vct(v1.x-v2.x,v1.y-v2.y,v1.z-v2.z)
End Operator
Operator * (f As Single,v1 As myPoint) As myPoint 'scalar*vector
Return vct(f*v1.x,f*v1.y,f*v1.z)
End Operator
Operator * (v1 As myPoint,v2 As myPoint) As Single 'dot product
Return v1.x*v2.x+v1.y*v2.y+v1.z*v2.z
End Operator
Operator ^ (v1 As myPoint,v2 As myPoint) As myPoint 'cross product
Return vct(v1.y*v2.z-v2.y*v1.z,-(v1.x*v2.z-v2.x*v1.z),v1.x*v2.y-v2.x*v1.y)
End Operator

Dim Shared As Double crossx,crossy,crossz
Sub setcross(x1 As Single,y1 As Single,z1 As Single, x2 As Single,y2 As Single,z2 As Single)
	crossx=y1*z2-y2*z1
	crossy=-x1*z2+x2*z1
	crossz=x1*y2-x2*y1
End Sub
Dim Shared As Double normx,normy,normz
Sub setnorm(x1 As Single,y1 As Single,z1 As Single, x2 As Single,y2 As Single,z2 As Single)
	normx=y1*z2-y2*z1
	normy=-x1*z2+x2*z1
	normz=x1*y2-x2*y1
	Var kxyz=1.0/max(0.000001,Sqr(normx*normx+normy*normy+normz*normz))
	normx*=kxyz
	normy*=kxyz
	normz*=kxyz
End Sub

Function length(v As myPoint) As Single
    Return Sqr(v.x*v.x+v.y*v.y+v.z*v.z)
End Function

Function normalize(v As myPoint) As myPoint
    Dim n As Single=length(v)
    If n=0 Then n=1e-20
    Return vct(v.x/n,v.y/n,v.z/n)
End Function

'distane from a myPoint to a plane
                                                  'ip = intersection myPoint
Function planedistance(S As PLANE,p As myPoint,Byref ip As myPoint=vct(0,0,0)) As Single
    Dim As myPoint unitcross=normalize((s.v1-s.v2) cross (S.v2-S.v3))
    Dim As Single dist=unitcross dot (p-s.v1)'pv
    Dim As myPoint ip1=p+dist*unitcross
    Dim As Single d1=length(s.v1-ip1)
    unitcross=-1*unitcross
    Dim As myPoint ip2=p+dist*unitcross
    Dim As Single d2=length(s.v1-ip2)
    If d1 <= d2 Then ip=ip1 Else ip=ip2
    Return dist
End Function


Function mylineto(L As Line,dist As Single) As myPoint 'the myPoint (dist pixels) along the line
    Var a=L.v1,b=L.v2
    Var u=normalize(b-a)
    Return a+dist*u
End Function

'myPoint of intersection of a plane and a line
Function intersect(P As plane,L As Line) As myPoint
    Dim As myPoint ip1,ip2
    Var d1=(planedistance(P,L.v1,ip1)),d2=(planedistance(P,L.v2,ip2))
    If d1<d2 Then Swap d1,d2:Swap ip1,ip2
    Dim As myPoint p1=normalize(ip1-ip2)
    Dim As myPoint p2=normalize(L.v1-L.v2)
    Dim As Single A=Acos(p1 dot p2)'angle between lines
    Dim As Single dst=d1/Tan(A)
    Return mylineto(Type<Line>(ip1,ip2),dst)
End Function

'shadow vertices of T2 on T1 from p
Function shadow(T1 As triangle,T2 As triangle,p As myPoint) As triangle
    Dim As Line L1=Type<Line>(T2.v1,p)
    Dim As Line L2=Type<Line>(T2.v2,p)
    Dim As Line L3=Type<Line>(T2.v3,p)
    Dim As myPoint p1=intersect(T1,L1)
    Dim As myPoint p2=intersect(T1,L2)
    Dim As myPoint p3=intersect(T1,L3)
    Return Type<triangle>(p1,p2,p3)
End Function

Sub drawtriangle(P As triangle,col As Ulong,pt As Long=1)
    Line(P.v1.x,P.v1.y)-(P.v2.x,P.v2.y),col
    Line(P.v2.x,P.v2.y)-(P.v3.x,P.v3.y),col
    Line(P.v3.x,P.v3.y)-(P.v1.x,P.v1.y),col
    Dim As Single cx=(p.v1.x+P.v2.x+P.v3.x)/3,cy=(p.v1.y+P.v2.y+P.v3.y)/3
    If pt Then  Paint (cx,cy),col,col
End Sub


