'pianoscore_chung a program by NGUYEN.Chung (freeware 2019)
Dim Shared As Double auxvar,auxvar2,auxvar3,auxvar4,auxvar5
Dim Shared As String auxtext
#Inclib "TTS_chung_dll"
Declare Sub myTTSinit Cdecl Alias "myTTSinit" () 
Declare Sub myTTSclose Cdecl Alias"myTTSclose" () 
Declare Function myttsspeak0 Cdecl Alias "myTTSspeak" (txt as ZString ptr,flags as Integer=0)As Integer 
Declare Function myTTSstatus Cdecl Alias "myTTSgetstatus" () As ZString Ptr
Declare Sub myttsspeak(text As String)

#Include Once "gui_chung.bi"
#Include Once "gl_chung.bi"
#Include Once "windows.bi"
#include Once "win/mmsystem.bi"
#Include Once "importmidi.bi"
#Include Once "exportmidi.bi"
#Include Once "partition.bi"
#Include Once "mypiano.bi"

'fbedit + freebasic 1.05-win32
Dim Shared As HMIDIout hmidiout
#Undef midioutshortmsg
Sub midiOutShortMsg(UserArg As hmidiout,MidiMsgvalue As Integer)
	If userarg=hmidiout Then mymidiOutShortMsg(0,midimsgvalue)
End Sub 

mypianovol=1
mypianochorus=1.3
mypianoreverb=1.3
mypianotchorus=1.3
mypianotreverb=1.5
mypianokvelo=1.5
mypianoattack=1
mypiano_init()

Sub subpianorev
Dim As Integer i
getcomboindex("win.pianorev",i)
mypianoreverb=max(0,min(3,(i)*0.1))	
guisetfocus("win.graph")
End Sub
Sub subpianocho
Dim As Integer i
getcomboindex("win.pianocho",i)
mypianochorus=max(0,min(2,(i)*0.1))	
guisetfocus("win.graph")
End Sub
Sub subpianotrev
Dim As Integer i
getcomboindex("win.pianotrev",i)
mypianotreverb=max(0,min(2,(i)*0.1))	
guisetfocus("win.graph")
End Sub
Sub subpianotcho
Dim As Integer i
getcomboindex("win.pianotcho",i)
mypianotchorus=max(0,min(2,(i)*0.1))	
guisetfocus("win.graph")
End Sub
Sub subpianokvelo
Dim As Integer i
getcomboindex("win.pianokvelo",i)
mypianokvelo=max(0,min(2,(i)*0.1))	
guisetfocus("win.graph")
End Sub
Sub subpianoatt
Dim As Integer i
getcomboindex("win.pianoatt",i)
mypianoattack=max(0,min(2,(i)*0.1))	
guisetfocus("win.graph")
End Sub
 
Enum SpeechVoiceSpeakFlags
      ' spvoice flags
      SVSFDefault          = &H0000
      SVSFlagsAsync        = &H0001
      SVSFPurgeBeforeSpeak = &H0002
      SVSFIsFilename       = &H0004 ' must be the whole path
      SVSFIsXML            = &H0008
      SVSFIsNotXML         = &H0010
      SVSFPersistXML       = &H0020
End Enum
Sub myttsspeak(text As String)
   Dim As String ilang="409"
   '409 English (United States)
   '809 English (United Kingdom)
   '40C French (Standard)
   '407 German (Standard)
   Var text2="<VOICE Gender=""Female""><lang langid="""+Str(ilang)+""">"+text+"</lang></VOICE>"
	myttsspeak0(text2,SVSFlagsAsync+SVSFPurgeBeforeSpeak)
End Sub
myTTSinit()
myTTSspeak("hello , how are you ?")

Dim Shared As Integer quit=0,i,j,k
Sub guinotice2(ByRef msg As string,ByRef title As String ="notice")
Dim As HWND hwin
'ScreenControl(2, Cast(Integer,hwin)) 'get screen handle
	messagebox(hwin,msg,title,MB_TASKMODAL Or 0)
   Sleep 200
End Sub
Sub subquit
	quit=1
End Sub
'Dim Shared As Integer tpianoonly
Sub subpianoonly
	partitionpause=0
	tplay=0
	If tpianoonly=0 Then
		tpianoonly=1
		printgui("win.pianoonly","piano only")
	ElseIf tpianoonly=1 Then
		tpianoonly=2
		printgui("win.pianoonly","piano wait")
		'partitionpause=1
	Else
		tpianoonly=0
		printgui("win.pianoonly","piano")
	EndIf
guisetfocus("win.graph")	
End Sub
Declare Sub drawzoom()
Sub subzoom
	tzoom=(tzoom+1)Mod 2
	If tzoom=0 Then
		'hidegui("win.graph2")
		myttsspeak("zoom off")
		timedrawnote=Timer 
	Else
		myttsspeak("zoom on")
		drawzoom()
		'showgui("win.graph2")
	EndIf
guisetfocus("win.graph")
End Sub
Sub subtopengl
	topengl=(topengl+1)Mod 2
	Sleep 100
guisetfocus("win.graph")
End Sub
'Dim Shared As Integer mousex,mousey
Sub submovemouse
mousex=guimousex
mousey=guimousey	
End Sub
Sub subleftmouse
mousex=guimousex
mousey=guimousey
guisetfocus("win.graph")
If mousey>320 Or tzoom=1 Then
	Exit Sub 
EndIf
Var iinote20=iinote2
If tplay>=2 Then
	iinote2=lastiinote2
	drawnotes()
	'guinotice "ok"	
EndIf
jjnotemouse=0
drawnotes()
If jjnotemouse>0 Then 
	iinote2=jjnotemouse
	iiplay=iinote2
	timedrawnote=Timer
ElseIf tplay>=2 Then
	iinote2=iiplay
	timedrawnote=Timer
Else
   iinote2=iinote20
   timedrawnote=Timer 	 
EndIf
End Sub
Declare Sub subgoto
Declare Sub submsggoto
Declare Sub subiduree0
Declare Sub subiduree1
Sub subsetstart
iinote1=max2(-1,iinote2-1)
timedrawnote=Timer
guisetfocus("win.graph")
End Sub
Dim Shared As Integer icls
Sub subplay
if	tplay>=1 Then
	tplay=0
	printgui("win.play","play")
	iiplay=iinote2
	enablegui("win.load")
	enablegui("win.loadmidi")
	enablegui("win.record")
   guisetfocus("win.graph")
Else 	
	tplay=2
	printgui("win.play","stop")
	iiplay=iinote1'-1
	disablegui("win.load")
	disablegui("win.loadmidi")
	disablegui("win.record")
   guisetfocus("win.graph")'play")
   icls=99
   drawtext00()
EndIf
Sleep 300
End Sub
Dim Shared As integer wx,wy,depth
Sub subsustain
If tsustain=0 Then
	tsustain=1
	myttsspeak("sustain on")
	Sleep 300
	guiscan 
Else
	Var tt=Timer
	Var i=0
	For i=1 To 60
		Sleep 7
		If Timer>tt+0.3 Then Exit For 
		guiscan
		If tsustain=1 And guitestkey(vk_space)=0 Then
			tsustain=0
		ElseIf tsustain=0 And guitestkey(vk_space) Then
			tsustain=2
       	myttsspeak("sustain on")	
		EndIf		
	Next
	If tsustain=2 Then
		tsustain0=0
		tsustain=1
	Else
		tsustain0=1
      tsustain=0
      myttsspeak("sustain off")
   EndIf     
EndIf
Var s=min(1,wx/1366)
mylocate 6,s*70
Var toct=Str(octave)+"    "
If octave>0 Then toct="+"+toct
If octave=0 Then toct="    " 
If tsustain=1 Then 
   myprint "SUSTAIN"+toct
Else
   myprint "       "+toct
EndIf
Dim As Integer i,j,k
If tsustain<>tsustain0 Or iinotesustain<>iinote2 Then
	tsustain0=tsustain
	iinotesustain=iinote2
	For i=10 To 120
		notesustain(i)=0
		If tsustain=1 Then
			If testaccordnote(iinote2,i)>0 Then
				notesustain(i)=1
			EndIf 
		EndIf
	Next
EndIf
Sleep 50	
End Sub
Sub subforward
	Var i10=10:If tzoom=1 Then i10=7
	iinote2=min2(iinote,iinote2+i10)
	timedrawnote=Timer-1
	resetnoteon()
guisetfocus("win.graph")
End Sub
Sub subbackward
	Var i10=10:If tzoom=1 Then i10=7
	iinote2=min2(iinote,max2(10,iinote2-i10))
	timedrawnote=Timer-1
	resetnoteon()
guisetfocus("win.graph")
End Sub
'Declare Sub playaccord(ii As Integer)
Sub subforward1
	iinote2=min2(iinote,iinote2+1)
	iiplay=iinote2
	playaccord(iinote2)
	timedrawnote=Timer-1
   resetnoteon()
guisetfocus("win.graph")
End Sub
Sub subbackward1
	iinote2=min2(iinote,max2(0,iinote2-1))
	iiplay=iinote2
	playaccord(iinote2)
	timedrawnote=Timer-1 
   resetnoteon()
guisetfocus("win.graph")
End Sub
Sub subforward2
	iinote2=iinote
	timedrawnote=Timer-1
   resetnoteon()
guisetfocus("win.graph")
End Sub
Sub subbackward2
	iinote2=0
	timedrawnote=Timer-1 
   resetnoteon()
guisetfocus("win.graph")
End Sub
Dim Shared As String resp
Sub subreset()
guiconfirm("reset song ?","confirm",resp)
If resp="yes" Then
	iinote=0
	iinote2=0
	For i=0 To nnote
		iaccord(i)=0
		For j=1 To naccord
			note(i,j)=0
			notetime(i,j)=0
		Next
		liaison(i)=0
		duree(i)=1
		duree0(i)=0.25+0.25
	Next
	resetnoteon()
	timedrawnote=Timer 
EndIf
End Sub
Sub subresetgo
	'iinote=0
	'iinote2=0
	For i=iinote2+1 To nnote
		iaccord(i)=0
		For j=1 To naccord
			note(i,j)=0
			notetime(i,j)=0
		Next
		liaison(i)=0
		duree(i)=1
		duree0(i)=0.25+0.25
	Next
	resetnoteon()
	timedrawnote=Timer 	
End Sub
Declare Sub subhelp()
Declare Sub subload()
Declare Sub subsave()
Declare Sub subsavetxt()
Declare Sub subsaverec()
Declare Sub subsaveasmidi()
Declare Sub subloadmidi()
Declare Sub load(fic As String)
Declare Sub save(fic As String)
Dim Shared As Integer tsubload,tsubsave,tsubsaveasmidi,tsubloadmidi,tsubsavetxt,tsubsaverec
Sub mysubload()
tsubload=1
resetnoteon()
guisetfocus("win.graph")
End Sub
Sub mysubsave()
tsubsave=1
resetnoteon()
guisetfocus("win.graph")
End Sub
Sub mysubsavetxt()
tsubsavetxt=1
resetnoteon()
guisetfocus("win.graph")
End Sub
Sub mysubsaverec()
tsubsaverec=1
resetnoteon()
guisetfocus("win.graph")
End Sub
Sub mysubsaveasmidi()
tsubsaveasmidi=1
resetnoteon()
guisetfocus("win.graph")
End Sub
Sub mysubloadmidi()
tsubloadmidi=1
resetnoteon()
guisetfocus("win.graph")
End Sub
Declare Sub loadmyrecord()
Dim Shared As Integer tloadmyrecord
Dim Shared As Double myrecordtime,myrecordtime1               
Sub mysubrecord()
Dim As Integer i
If tstoprecord=0 And (trecord=0 Or tstartrecord=1) Then
	myttsspeak("start record")
	printgui("win.record","stoprec")
	trecord=1
	tplay=0
	disablegui("win.load")
	disablegui("win.save")
	disablegui("win.saveasmidi")
	'subiduree1()
	'timerec0=0'Timer
	'timerec=timerec0
	'timesubrecord0=Timer
	myirecordall=0
	myrecordtime=0
	myrecordtime1=Timer 
	tloadmyrecord=0 
   guisetfocus("win.record")
ElseIf trecord>=1 Then 
	myttsspeak("stop record")
	printgui("win.record","record")
	trecord=0
	tloadmyrecord=1
	'For i=1 To iinote
	'	testalign(i)
	'Next
	enablegui("win.load")
	enablegui("win.save")
	enablegui("win.saveasmidi")
   guisetfocus("win.graph")
EndIf
tstoprecord=0
tstartrecord=0
'timedrawnote=Timer-2 
resetnoteon()
End Sub
Sub subkeyc96
Dim As Integer i
getcomboindex("win.keyc96",i)
c96=max2(96-12,min2(96+12,96-(i-1-12)))	
guisetfocus("win.graph")
End Sub
Sub subtlink
Dim As Integer i
getcomboindex("win.tlink",i)
tlink=max2(0,min2(4,i-1))	
guisetfocus("win.graph")
End Sub
Declare Sub mysublink()
Sub sublink
myttsspeak("link ?")	
guiconfirm("link same chords (once)?","confirm",resp)
If resp="yes" Then
	mysublink
   timedrawnote=timer
EndIf
guisetfocus("win.graph")	
End Sub
Declare Sub setsystestchord()
Declare Sub testsystestchord()
Sub subsetcorrect
guiconfirm("set system correct chords ?","confirm",resp)
If resp="yes" Then
	setsystestchord()
   timedrawnote=timer
EndIf
guisetfocus("win.graph")
End Sub
Sub subcorrect
myttsspeak("correct ?")	
guiconfirm("correct chords ?","confirm",resp)
If resp="yes" Then
	testsystestchord()
   timedrawnote=timer
EndIf
guisetfocus("win.graph")	
End Sub
Sub subt100
Dim As Integer i
getcomboindex("win.t100",i)
t100=max2(40,min2(200,i+39))	
guisetfocus("win.graph")
End Sub 
Dim Shared As Double ktime=1,timeplay
Sub subtt100
Dim As Integer i
getcomboindex("win.tt100",i)
tt100=max2(40,min2(200,i+39))	
ktime=tt100*0.01
timeplay=Timer*ktime
guisetfocus("win.graph")
End Sub
'Dim Shared As Integer autot100
Sub subautot100
If autot100=0 Then
	autot100=1
	setcheckbox("win.autot100")
Else 	
	autot100=0
	unsetcheckbox("win.autot100")
EndIf
Sleep 300
guisetfocus("win.graph")
End Sub
Dim Shared As Integer tloop
Sub subtloop
If tloop=0 Then
	tloop=1
	setcheckbox("win.tloop")
Else 	
	tloop=0
	unsetcheckbox("win.tloop")
EndIf
Sleep 300
guisetfocus("win.graph")
End Sub
Sub subplayshort
tkeyplay=2
guisetfocus("win.graph")
End Sub
Dim Shared As Integer tkeyboard
Sub subkeyboard
If tkeyboard=0 Then
	tkeyboard=1
	printgui("win.keyboard","keyboard as Midi")
	showgui("win.piano")
Else
	tkeyboard=0
	printgui("win.keyboard","keyboard as keys")
	hidegui("win.piano")
EndIf
guisetfocus("win.graph")
End Sub
Sub subdo()
iundo+=1
'notice "iundo="+Str(iundo)
Var fic=ExePath+"\undo\undo"+Str(iundo)+".midiscore"
'notice fic
save(fic)
iundo2=iundo-1
Var fic0=ExePath+"\undo\undo"+Str(iundo-30)+".midiscore"
'notice fic0
If FileExists(fic0) Then
	'notice "delete "+fic0
	Kill(fic0)
EndIf 
fic0=ExePath+"\undo\undo"+Str(iundo+1)+".midiscore"
'notice fic0
If FileExists(fic0) Then
	'notice "delete "+fic0
	Kill(fic0)
EndIf 
guisetfocus("win.graph")
End Sub
Sub subundo()
If iundo<=0 Then guinotice "no more undo !":Exit Sub
Dim As Integer iundo0=iundo
If iundo2=(iundo-1) Then iundo-=1
Var fic=ExePath+"\undo\undo"+Str(iundo)+".midiscore"
'notice fic
If FileExists(fic)=0 Then guinotice "no undo left !":iundo=iundo0:Exit Sub  
iundo2=iundo-1
'notice "iundo="+Str(iundo)
load(fic)
timedrawnote=timer
guisetfocus("win.graph")
End Sub
dim shared as integer iinoteold,iinote2old,iinote1old
Sub subredo()
iundo+=1
Var fic=ExePath+"\undo\undo"+Str(iundo)+".midiscore"
'notice fic
If FileExists(fic)=0 Then guinotice "no redo left !":iundo-=1:Exit Sub
iundo2=iundo-1 
'notice "iundo="+Str(iundo)
load(fic)
iinoteold=iinote
iinote2old=iinote2
iinote1old=iinote1
timedrawnote=timer
guisetfocus("win.graph")
End Sub
Declare Sub savecut(fic As String,ii0 As Integer=0,i1 As Integer=0)
Declare Sub savecopy(fic As String,ii0 As Integer=0,i1 As Integer=0)
Declare Sub loadcopy(fic As String)
Sub subcut()
Var fic=ExePath+"\undo\copy.midiscore"
savecut(fic,iinote1+1,iinote2)
Sleep 300
timedrawnote=timer
guisetfocus("win.graph")
End Sub
Sub subcopy()
Var fic=ExePath+"\undo\copy.midiscore"
savecopy(fic,iinote1+1,iinote2)
Sleep 300
timedrawnote=timer
guisetfocus("win.graph")
End Sub
Sub subpaste()
Var fic=ExePath+"\undo\copy.midiscore"
loadcopy(fic)
Sleep 300
timedrawnote=timer
guisetfocus("win.graph")
End Sub
Dim Shared As Integer volume=110
Sub subvolume
Dim As Integer i
getcomboindex("win.volume",i)
volume=max2(1,min2(127,i))	
guisetfocus("win.graph")
End Sub 

/'
Type STATUSBYTE
  As Ubyte channel:4
  As Ubyte status :4
End Type

Type MIDIMESSAGE
  Union
  Type
  Union
  As STATUSBYTE Byte
  As Ubyte      byte0
  End Union
  As Ubyte      byte1
  As Ubyte      byte2
  As Ubyte      byte3
  End Type
  As Uinteger   value
  End Union
End Type
'/

Dim Shared As String ficload,ficload0
Dim Shared As Integer imidi,ichannel
Dim Shared As Double tchannel(256)
Dim Shared As String ficin
Const As String ficini="midiscore_chung.ini"
Dim Shared As Integer File
file=FreeFile
Open ficini For Input As #file
imidi=0
If Not Eof(file) Then Line Input #file,ficin:imidi=Val(ficin)
ichannel=0
If Not Eof(file) Then Line Input #file,ficin:ichannel=Val(ficin)
minvelo=0
If Not Eof(file) Then Line Input #file,ficin:minvelo=Val(ficin)
iinote=0
If Not Eof(file) Then Line Input #file,ficin:iinote=Val(ficin)
For i=0 To iinote
	iaccord(i)=0
	If Not Eof(file) Then Line Input #file,ficin:iaccord(i)=Val(ficin)
	For j=1 To iaccord(i)
		note(i,j)=0
		If Not Eof(file) Then Line Input #file,ficin:note(i,j)=Val(ficin)
	Next
Next
For i=0 To iinote
	liaison(i)=0
	If Not Eof(file) Then Line Input #file,ficin:liaison(i)=Val(ficin)
Next 
c96=96
If Not Eof(file) Then Line Input #file,ficin:c96=Val(ficin)
iduree=1
If Not Eof(file) Then Line Input #file,ficin:iduree=Val(ficin)
For i=0 To iinote
	duree(i)=1
	If Not Eof(file) Then Line Input #file,ficin:duree(i)=Val(ficin)
Next 
tlink=0
If Not Eof(file) Then Line Input #file,ficin:tlink=Val(ficin)
For i=0 To iinote
	duree0(i)=0.25+duree(i)*0.25
	If Not Eof(file) Then Line Input #file,ficin:duree0(i)=Val(ficin)
Next 
For i=0 To iinote
	For j=1 To iaccord(i)
		notetime(i,j)=0
		If Not Eof(file) Then Line Input #file,ficin:notetime(i,j)=Val(ficin)
	Next
Next
iundo=0
If Not Eof(file) Then Line Input #file,ficin:iundo=Val(ficin)
t100=100
If Not Eof(file) Then Line Input #file,ficin:t100=Val(ficin)
ficload=""
If Not Eof(file) Then Line Input #file,ficin:ficload=Trim(ficin)
volume=110
If Not Eof(file) Then Line Input #file,ficin:volume=Val(ficin)
iinote2=iinote
If Not Eof(file) Then Line Input #file,ficin:iinote2=Val(ficin)
iinote1=0
If Not Eof(file) Then Line Input #file,ficin:iinote1=Val(ficin)
tt100=100
If Not Eof(file) Then Line Input #file,ficin:tt100=Val(ficin)
autot100=0
If Not Eof(file) Then Line Input #file,ficin:autot100=Val(ficin)
topengl=0
If Not Eof(file) Then Line Input #file,ficin:topengl=Val(ficin)
octave=0
If Not Eof(file) Then Line Input #file,ficin:octave=Val(ficin)
tpianoonly=0
If Not Eof(file) Then Line Input #file,ficin:tpianoonly=Val(ficin)
mypianoreverb=1.3
If Not Eof(file) Then Line Input #file,ficin:mypianoreverb=Val(ficin)
mypianochorus=1.3
If Not Eof(file) Then Line Input #file,ficin:mypianochorus=Val(ficin)
mypianotreverb=1.5
If Not Eof(file) Then Line Input #file,ficin:mypianotreverb=Val(ficin)
mypianotchorus=1.3
If Not Eof(file) Then Line Input #file,ficin:mypianotchorus=Val(ficin)
mypianokvelo=1.3
If Not Eof(file) Then Line Input #file,ficin:mypianokvelo=Val(ficin)
mypianoattack=1
If Not Eof(file) Then Line Input #file,ficin:mypianoattack=Val(ficin)
Close #file

Var iinote200=iinote2
Var iinote100=iinote1

Declare Sub testmidikeyboard()
Declare Sub initmidikey()
initmidikey()

'Dim Shared As Integer wx,wy,depth            
ScreenInfo wx,wy,depth
	 	         'Screen 0
	 	         'wx=1024
	 	         'wx=1200
	 	         'wy=680'900'680
	 	         'wy=768'600'680
	 	         'wx=1800
	 	         'guinotice Str(wx)+" "+Str(wy)
	 	         wx=min2(wx,1800)
	 	         wy=min2(wy,900)
	 	         If wy<=680 Then i50=0:dymax-=20 
	 	         Var dx=1018,dy=600
	 	         dx=wx-2:dy=wy-50
	 	         xmax=dx-2
	 	         ymax=407-5-25'dy-30
	 	         Var s=(min(1,wx/1366)-1)*800
	 	         guibackgroundcolor(200,209,200)
               combobox("win.pianocho",@subpianocho,s+950,8,70,400)
               combobox("win.pianorev",@subpianorev,s+950,32,70,400)
               combobox("win.pianotcho",@subpianotcho,s+950+70,8,74,400)
               combobox("win.pianotrev",@subpianotrev,s+950+70,32,74,400)
               combobox("win.pianokvelo",@subpianokvelo,s+950+140,8,80,400)
               combobox("win.pianoatt",@subpianoatt,s+950+140,32,80,400)
               button("win.pianoonly","piano",@subpianoonly,s+858,9,80,22)
               button("win.quit","quit",@subquit,20,ymax+40,60,30)
               button("win.help","help",@subhelp,20,ymax+80,60,20)
               button("win.keyboard","keyboard as keys",@subkeyboard,20,ymax+110,130,30)
               button("win.reset","reset",@subreset,100,ymax+40,60,30)
               button("win.setstart","setstart",@subsetstart,100,ymax+75,60,30)
               button("win.play","play",@subplay,180,ymax+40,60,30)
               button("win.backward","<<",@subbackward,180,ymax+75,28,25)
               button("win.forward",">>",@subforward,180+32,ymax+75,28,25)
               combobox("win.tlink",@subtlink,180,ymax+106,60,400)
               button("win.link","link",@sublink,328,ymax+108,37,20)
               button("win.correct","correct",@subcorrect,468,ymax+110,50,20)
               button("win.setcorrect","set",@subsetcorrect,523,ymax+110,25,20)
               statictext("win.msg","",260,ymax+45,100,20)
               button("win.goto","goto",@subgoto,260,ymax+76,40,23)
               edittext("win.msggoto","",@submsggoto,305,ymax+79,60,20)
               checkbox("win.tloop","loop",@subtloop,260,ymax+106,70,23)
               button("win.record","record",@mysubrecord,380,ymax+80,60,25)
               button("win.saverec","saverec",@mysubsaverec,380,ymax+108,60,23)
               button("win.load","load",@mysubload,380,ymax+40,60,30)
               button("win.save","save",@mysubsave,460,ymax+40,60,30)
               button("win.saveastxt","savetxt",@mysubsavetxt,460,ymax+80,60,25)
               button("win.saveasmidi","saveasMidi",@mysubsaveasmidi,540,ymax+40,90,30)
               button("win.loadmidi","loadMidi",@mysubloadmidi,552,ymax+76,70,25)
               combobox("win.t100",@subt100,623,ymax+77,60,400)
               checkbox("win.autot100","auto",@subautot100,624,ymax+100,120,25)
               combobox("win.keyc96",@subkeyc96,660,ymax+43,70,400)
               button("win.dt0","dt0",@subiduree0,750,ymax+40,30,30)
               button("win.dt1","dt1",@subiduree1,790,ymax+40,30,30)
               button("win.backward1","<",@subbackward1,832,ymax+45,25,25)
               button("win.forward1",">",@subforward1,832+30,ymax+45,25,25)
               button("win.backward2","|<",@subbackward2,832,ymax+76,25,24)
               button("win.forward2",">|",@subforward2,832+30,ymax+76,25,24)
               combobox("win.volume",@subvolume,976,ymax+45,67,400)
               button("win.playshort","playshort",@subplayshort,900,ymax+45,70,25)
               If wx>1100 Then 
                 combobox("win.tt100",@subtt100,976+73,ymax+45,60,400)
                 button("win.tzoom","zoom",@subzoom,976+73,ymax+75,50,25)
                 button("win.topengl","keypiano",@subtopengl,976+73,ymax+105,70,25)
               Else 
                 combobox("win.tt100",@subtt100,930,ymax+45+59,60,400)
                 button("win.tzoom","zoom",@subzoom,930,ymax+75+59,50,25)
                 button("win.topengl","keypiano",@subtopengl,930,ymax+105+59,70,25)
               EndIf 
               button("win.do","do",@subdo,710,ymax+79,29,20)
               button("win.undo","undo",@subundo,740,ymax+79,39,20)
               button("win.redo","redo",@subredo,780,ymax+79,39,20)
               button("win.cut","cut",@subcut,900,ymax+79,29,20)
               button("win.copy","copy",@subcopy,930,ymax+79,36,20)
               button("win.paste","paste",@subpaste,967,ymax+79,42,20)
               ymax+=25
               'graphicbox("win.graph2",1,1,xmax,ymax,"opengl")
               graphicbox("win.graph",1,1,xmax,ymax)
               If wy>=740 Then staticbmp("win.piano","media/piano_keyboard.jpg",1,ymax+105,xmax,dy-ymax-105-45)
               graphicbox("win.graph2",1,ymax+105,xmax,245,"opengl")
               openwindow("win","pianoscore_chung",1,1,dx,dy)
               
               wh=getguigfxbuffer("win.graph")
               wh2=ImageCreate(xmax,ymax,,32)'getguigfxbuffer("win.graph2")
               'hidegui("win.graph2")
               trapclose("win",@subquit)
               trapmovemouse("win.graph",@submovemouse)
               trapleftmouse("win.graph",@subleftmouse)
               Dim As hwnd hwinmsg,hwin,hmsggoto
               hwinmsg=getguih("win.msg")
               hwin=getguih("win")
               hmsggoto=getguih("win.msggoto")
               hidegui("win.piano")
               If autot100=1 Then setcheckbox("win.autot100")
               If tpianoonly=1 Then printgui("win.pianoonly","piano only")
               If tpianoonly=2 Then printgui("win.pianoonly","piano wait")
               
               guistartOpenGL("win.graph2")
               Declare Sub initgl
               Declare Sub drawgloff
               Declare Sub drawgl
               initgl()
               guirefreshopengl
               
               submsggoto()
               
               For i=1 To 29
                 	addcombo("win.pianorev","rev"+Str(i*0.1))
               Next
               selectcomboindex("win.pianorev",Int(mypianoreverb*10.001))

               For i=1 To 20
                 	addcombo("win.pianocho","cho"+Str(i*0.1))
               Next
               selectcomboindex("win.pianocho",Int(mypianochorus*10.001))

               For i=1 To 20
                 	addcombo("win.pianotrev","trev"+Str(i*0.1))
               Next
               selectcomboindex("win.pianotrev",Int(mypianotreverb*10.001))

               For i=1 To 20
                 	addcombo("win.pianotcho","tcho"+Str(i*0.1))
               Next
               selectcomboindex("win.pianotcho",Int(mypianotchorus*10.001))

               For i=1 To 20
                 	addcombo("win.pianokvelo","kvelo"+Str(i*0.1))
               Next
               selectcomboindex("win.pianokvelo",Int(mypianokvelo*10.001))

               For i=1 To 20
                 	addcombo("win.pianoatt","attak"+Str(i*0.1))
               Next
               selectcomboindex("win.pianoatt",Int(mypianoattack*10.001))

               For i=1 To 127
                 	addcombo("win.volume","vol"+Str(i))
               Next
               selectcomboindex("win.volume",volume)

               For i=1 To 12
               	addcombo("win.keyc96","C96+"+Str(13-i))
               Next
               For i=1 To 13
               	addcombo("win.keyc96","C96-"+Str(i-1))
               Next
               selectcomboindex("win.keyc96",96-c96+1+12)

               For i=1 To 111
               	addcombo("win.t100","T"+Str(i+39))
               Next
               selectcomboindex("win.t100",t100-39)

               For i=1 To 111
               	addcombo("win.tt100","T"+Str(i+39))
               Next
               selectcomboindex("win.tt100",tt100-39)
               ktime=tt100*0.01
               timeplay=Timer*ktime

               For i=1 To 4
               	addcombo("win.tlink","link"+Str(i-1))
               Next
               selectcomboindex("win.tlink",tlink+1)

               'ScreenRes dx,dy,depth,1,4
               'ScreenControl(100,wx/2-dx/2,wy/2-24-dy/2) 'set window position
               Color RGB(155, 255, 255), RGB(0, 0, 100)
               partitionimage=bmp_load("media/partition1.bmp")
               partitionimage2=bmp_load("media/partition2.bmp")
               partitionimage3=bmp_load("media/partition3.bmp")
               partitionimage4=bmp_load("media/partition4.bmp")
               partitionimage4red=bmp_load("media/partition4red.bmp")
               partitionimage4red2=bmp_load("media/partition4red2.bmp")
               dieseimage=bmp_load("media/diese.bmp")
               liaisonimage=bmp_load("media/liaison.bmp")
               mycls
               Put wh,(1,dymax+15),partitionimage,PSet
               Put wh,(1,dymax+255+i50),partitionimage,PSet
               partitionx=0:partitiony=0
Sub myaddrecord(midimsg As midimessage,dt0 As Double)
	If myirecordall>=nrecordall Then
		tstoprecord=1:trecord=2:Exit Sub 
	EndIf
	Var dt=dt0-myrecordtime1
	If dt>5 Then dt=5:myrecordtime1=dt0-dt
	myrecordtime+=dt
	myrecordtime1+=dt
	myirecordall+=1
	myrecordtimeall(myirecordall)=myrecordtime
	myrecordmsgall(myirecordall)=midimsg
End Sub
Sub MidiInProc(Byval hDevice   As HMIDIIN, _
               Byval DriverMsg As Uinteger, _   
               Byval UserArg   As HMIDIOUT, _
               Byval MidiMsg0   As MIDIMESSAGE, _   
               Byval Param2    As Uinteger)
  'Locate 0'Cls
  Select Case As Const DriverMsg
    Case MIM_DATA     
      If UserArg Then
         midiOutShortMsg(UserArg,MidiMsg0.value)
         '? "send data to MIDI out time=" & Param2/1000
      Else
         'midiOutShortMsg(0,midiMsg0.value):Exit Sub 
         '? "got MIDI in data time=" & Param2/1000
      End If
      Var midimsg=midimsg0 
      midimsg.byte1=noteoctave(midimsg0.byte1)
      If tpianoonly>=1 Then
      	mymidiOutShortMsg2(0,midimsg.value)
      	Exit Sub 
      EndIf
      If trecord=1 And topengl=1 Then
      	midiOutShortMsg(hmidiout,midimsg.value)
      EndIf
      With MidiMsg
        Select Case As Const .byte.status
          Case &H8
            '? "channel=" & .byte.channel _
            '& " note off key/note=" & .byte1 
              If ichannel=0 Or midimsg.byte.channel=(ichannel-1) Then
              	  noteon(midimsg.byte1)=0
              EndIf
          Case &H9
            If .byte2=0 Then ' if velocity=0
              '? "channel=" & .byte.channel _
              '& " note off key/note=" & .byte1
              If ichannel=0 Or midimsg.byte.channel=(ichannel-1) Then
              	  noteon(midimsg.byte1)=0
              EndIf
            Else
              '? "channel=" & .byte.channel _
              '& " note on  key/note=" & .byte1 _
              '& " velocity=" & .byte2
              'PSet (Timer-t1,MidiMsg.byte1)
              If ichannel=0 Or midimsg.byte.channel=(ichannel-1) Then
              	 If midimsg.byte2>=minvelo Or midimsg.byte1>=c96 Then
              	 	noteon(midimsg.byte1)=2
              	 	If timport=0 Then timenoteon(midimsg.byte1)=Timer 
              	 	velorec=midimsg.byte2
              	 	If trecord=0 Then
              	 		drawnote(midimsg.byte1)
              	 	ElseIf midimsg.byte1<c96 and trecord=1 Then
              	 		myaddrecord(midimsg,Timer)
              	 	EndIf
              	 EndIf
              EndIf
              'tchannel(midimsg.byte.channel+1)=Timer
            End If
          Case &HA:'? "Polyphonic Aftertouch"
        	 Case &HB:'? "Control Mode Change " & .byte1 & "," & .byte2
        		   If UserArg=0 And trecord=0 Then 
        		      mymidiOutShortMsg(0,MidiMsg0.value)
        		   EndIf 
          Case &HC:'? "Program Change "      & .byte1
          Case &HD:'? "Channel Aftertouch"
          Case &HE:'? "Pitch Wheel Control " & .byte1 & "," & .byte2*128
          Case &HF:'? "System Exclusive Message (SysEx)"
          Case Else
            '? "param1=" & Hex(.value,8) & " param2=" & Hex(Param2,8)
      End Select
    End With
    Case MIM_OPEN     : '? "MIDIIN open"
    Case MIM_CLOSE    : '? "MIDIIN close"
    Case MIM_LONGDATA
    Case MIM_ERROR
    Case MIM_LONGERROR
    Case MIM_MOREDATA 
    Case Else: '? "MIDIIN unknow message &H[" & Hex(DriverMsg) & "] !"
  End Select
End Sub


Dim As MMRESULT ret
ret=midiInGetNumDevs()
If ret<1 Then
  'guinotice  "error: sorry no MIDI input on this system!"
  'Beep:Sleep':ImageDestroy partitionimage
  'End
end If
Dim As HMIDIIN hDevice
'imidi=1
ret=midiInOpen(@hDevice,imidi, _
                cast(Uinteger,@MidiInProc), _
                0, _
                CALLBACK_FUNCTION)
If ret Then
  'guinotice  "error can't open MIDI input "+Str(imidi)+" !"
  'Beep:Sleep':ImageDestroy partitionimage
  imidi=0
  ret=midiInOpen(@hDevice,imidi, _
                cast(Uinteger,@MidiInProc), _
                0, _
                CALLBACK_FUNCTION)
  If ret Then
    'guinotice  "error can't open first MIDI input !"
    'Beep:Sleep':ImageDestroy partitionimage
    'End
  EndIf   
EndIf

If hdevice Then 
 ret=midiInStart(hDevice)
 If ret Then
   midiInClose hDevice
   guinotice  "error can't start MIDI input !"
   'Beep:Sleep':ImageDestroy partitionimage
   'End
 EndIf 
EndIf
Sub drawtext0_old()
	Locate 5,10
	?"[M]midiin("+Str(imidi)+")   "
	Locate 5,30
	?"[C]channel("+Str(ichannel)+")  ";
	Locate 5,55
	?"[P]pause  ";
	Locate 5,75
	?"[T][Y]minvelo="+Str(minvelo)+"   ";
End Sub
Sub drawtext0()
	Var s=min(1,wx/1366)
	mylocate 4,s*10
	myprint "[M]midiin("+Str(imidi)+")   "
	mylocate 4,s*30
	myprint "[C]channel("+Str(ichannel)+")  "';
	mylocate 4,s*55
	If tplay>=1 Then
		myprint "[P]stop  "';
	Else 	
		myprint "[P]play  "';
	EndIf
	mylocate 4,s*75
	myprint "[T][Y]minvelo="+Str(minvelo)+"   "';
	mylocate 4,s*100
	myprint "[RETURN]playshort   "';
   mylocate 6,s*70
   Var toct=Str(octave)+"    "
   If octave>0 Then toct="+"+toct
   If octave=0 Then toct="    " 
   If tsustain=1 Then 
      myprint "SUSTAIN"+toct
   Else
      myprint "       "+toct
   EndIf
End Sub
Dim Shared As Integer tplay00
Sub drawtext00()
If tplay>=2 Then testplay()
   'If topengl=1 Then Exit Sub  
	icls+=1:If icls>15 Then icls=0
	If tzoom=1 Or tplay<>tplay00 Then icls=0:tplay00=tplay 
	If tput=0 Or (icls>0 And (tplay>0 Or trecord>0)) Then Exit Sub
	If iiplay>=iinote2 Then mycls()
	drawtext0()
	If iduree=0 Then
		printgui("win.dt0","dT0")
		printgui("win.dt1","dt1")
	Else 	
		printgui("win.dt0","dt0")
		printgui("win.dt1","dT1")
	EndIf
   Var i1=800
   Put wh,(i1,dymax),partitionimage,PSet
   Put wh,(i1,dymax+15),partitionimage,PSet
   'Put wh,(i1,dymax+255+16),partitionimage,PSet
   'Put wh,(i1,dymax+255+i50),partitionimage,PSet
   Put wh,(1,dymax),partitionimage,PSet
   Put wh,(1,dymax+15),partitionimage,PSet
   'Put wh,(1,dymax+255+16),partitionimage,PSet
   'Put wh,(1,dymax+255+i50),partitionimage,PSet
If tplay>=2 Then testplay()
End Sub
Dim Shared As String msgtext,crlf:crlf=Chr(13)+Chr(10)
Sub mycls2
	msgtext=""
End Sub
Sub myprint2(text As String)
	If Len(msgtext)<5000 Then msgtext+=text+crlf
End Sub
Sub subresp
resp=guigettext("win2.resp")
End Sub
Sub prompt(ByRef msg0 As String,ByRef resp0 As String)
Dim As Integer x400 
x400=max2(400,400)'Len(msg0)*10)
statictext("win2.msg","",10,10,x400,350)
edittext("win2.resp","",@subresp,10,360,x400,20)
openwindow("win2","freewebcar_chung",50,50,x400+50,440)
printgui("win2.msg",msg0)
printgui("win2.resp",resp0)
guisetfocus("win2.resp")
While guitestkey(vk_escape)=0 And guitestkey(vk_return)=0
	guiscan
	Sleep 100
Wend
Sleep 100
guiscan
resp=guigettext("win2.resp")
guiclosewindow("win2")
Sleep 200
guiscan 
End Sub
Sub myinput(ByRef resp As String)
	prompt(msgtext,resp)
End Sub
Dim Shared As Integer igoto
Sub submsggoto
igoto=Val(guigettext("win.msggoto"))
printgui("win.msggoto",Str(igoto))	
iinote2=max2(0,min2(iinote,igoto))
timedrawnote=Timer
guisetfocus("win.graph")  
End Sub
Sub subgoto
submsggoto()
'resp=""
'prompt("goto index : enter a number (0.."+Str(iinote)+") last="+Str(iinote2),resp)
'If resp<>"" Then iinote2=max2(0,min2(iinote,Val(resp)))
timedrawnote=Timer
guisetfocus("win.graph")  
End Sub
'Dim Shared As HMIDIout hmidiout
Dim Shared As midimessage mymidimsg_
Dim Shared As Integer midioutmsg,nmidiout,imidiout=0,tokmidi
Dim Shared As midioutcaps midioutcaps1
Dim Shared As String midioutname(30)
Sub initmidioutcombo()
Dim As Integer i,j,k,ret
ret=midioutGetNumDevs()
nmidiout=ret
nmidiout=min2(30,nmidiout)	
addcombo("win.midiout",Str(0)+".midi Mapper out")
If nmidiout>0 Then
 for i=0 to nmidiout-1
 	 midioutname(i+1)="..."
    ret=midioutGetDevCaps(i,@midioutcaps1,SizeOf(midioutcaps1))
    if ret=0 then midioutname(i+1)=Trim(midioutcaps1.szPname)
    addcombo("win.midiout",str(i+1)+"."+midioutname(i+1))
 next i
EndIf  
imidiout=max2(0,min2(nmidiout,imidiout))
End Sub  
Sub openmidiout()
  'Var imidiout=0
  Var i=-1+imidiout	
  Var ret=midioutOpen(@hmidiout,i, _
                    NULL, _ 'Cast(Uinteger,@MidioutProc), _
                    0, _
                    0)'CALLBACK_FUNCTION)
  If ret Then
      guinotice "error can't open MIDI output "+Str(imidiout)+" !"'+Chr(13)+midioutname(imidiout)
      midioutclose hmidiout
      hmidiout=0
      imidiout=0
      i=-1+imidiout
      selectcomboindex("win.midiout",imidiout+1)	
      ret=midioutOpen(@hmidiout,i, _
                    NULL, _ 'Cast(Uinteger,@MidioutProc), _
                    0, _
                    0)'CALLBACK_FUNCTION)
      If ret Then
         guinotice "error can't open MIDI output "+Str(imidiout)+" !"'+Chr(13)+midioutname(imidiout)
         midioutclose hmidiout
         hmidiout=0
      Else
      	tokmidi=1
      EndIf    
  Else
   	tokmidi=1
  Endif     
	
End Sub
Sub closemidiout()
	If tokmidi=1 Then midioutClose hmidiout
End Sub
Dim Shared As Double timemidi_,timenote_(128),dtmidi
Dim Shared As Integer codemidi,velo,nnotemidi,trec
'Declare Sub midioutshortmsg2(midimsg As Integer)
Function testaccordnote(jjnote As Integer,inote As Integer)As Integer
Dim As Integer i 
For i=1 To iaccord(jjnote)
	If note(jjnote,i)=inote Then Return 1
Next
Return 0
End Function
Function compareaccord(jjnote As Integer,kknote As Integer)As Integer
Dim As Integer i,j,k  
If iaccord(jjnote)>iaccord(kknote) Then Return 0
For i=1 To iaccord(jjnote)
	Var test=0
	Var inote=note(jjnote,i)
	For j=1 To iaccord(kknote)
   	If note(kknote,j)=inote Then test=1:Exit For
	Next j
	If test=0 Then Return 0
Next
If iaccord(jjnote)<iaccord(kknote) Then Return 2
Return 1
End Function
dim shared as single avgvelo=70
Function setvelo(velo0 As Integer)As Integer
Var velo=velo0
If velo0<1 Then velo=volume	
If velo>avgvelo Then 
	avgvelo+=(velo-avgvelo)*0.5'0.75
Else
	avgvelo+=(velo-avgvelo)*0.015'0.01
EndIf
Return max2(2,min2(127,velo*min(3.0,(volume+10)/(10+avgvelo))))
End Function
Dim Shared As Single kvelo=1
Sub playnote(note As Integer,tmute As Integer=0)
     codemidi=144
     If velo<1 Then velo=110
	  velo=90+velo*38*((80+127)/127)/(80+velo)
     velo=max2(2,min2(127,Int(volume*kvelo*velo/110)))
     'If velo>1 Then 
        'avgvelo+=(velo-avgvelo)*0.03
        'avgvelo=max(40.0,min(127.0,avgvelo))
   	  'velo=max2(2,min2(127,Int(velo*volume/avgvelo)))'volume=100
     'EndIf
     /'If codemidi=144 And velo>0 Then
   	 If timenote_(note)>=1 Then
         midioutmsg=128+(note Shl 8) 'noteoff
         midiOutShortMsg(hmidiout,midioutmsg)
         'If trec Then midioutshortmsg2(midioutmsg)
 		   Sleep 3
   	 EndIf
   	 timenote_(note)=Timer 
     EndIf
     If (codemidi=144 And velo=0)Or codemidi=128 Then
	   If timenote_(note)>1 Then
	  	  timenote_(note)+=1.1
	  	  Exit Sub 
	   EndIf 
	  EndIf '/
     If tmute=0 Then 
       midioutmsg=codemidi+(note Shl 8)+(velo Shl 16)
       midiOutShortMsg(hmidiout,midioutmsg)
       'If trec then midioutshortmsg2(midioutmsg)
     EndIf 
     timenote_(note)=Timer 
     Sleep 1	
End Sub
Dim Shared As Integer notemute(256),notemute0(256)
Dim Shared As Double  notetimeaccord(256)
Function mtimer() As Double
	Return Timer*ktime
End Function
Sub playaccord(ii As Integer)
Dim As Integer i,j,k,iii,isleep 
For i=1 To 120
	If notemute(i)>0 Then
		notemute(i)+=1
		If notemute(i)>5 Then notemute(i)=0
	EndIf
	notemute0(i)=notemute(i)
Next
If ii>0 Then'And duree(ii)=1 Then
   Var test=compareaccord(ii,ii-1)
   If test=1 Then
		For i=1 To iaccord(ii)
			'playnote(note(ii,i),0)
			notemute(note(ii,i))=999
		Next
		'Exit Sub
   ElseIf test=2 Then  
		For i=1 To iaccord(ii)
			notemute(note(ii,i))=9
		Next
	EndIf
EndIf
For i=1 To iaccord(ii)
	notetimeaccord(i)=notetime(ii,i)
Next
Var dtime=999.0
Var dtime0=Timer'mtimer
For iii=1 To iaccord(ii)
	i=iii:dtime=999.0
	For k=1 To iaccord(ii)
		If dtime>notetimeaccord(k) Then
			dtime=notetimeaccord(k)
			i=k
		EndIf
	Next
	notetimeaccord(i)=9999.9
	'isleep=max2(0,min2(2000,Int((dtime+dtime0-mTimer)*1000)))'+18)))
	isleep=max2(0,min2(2000,Int((dtime+dtime0-Timer)*1000/ktime)))'+18)))
	If isleep>0 Then
		Sleep isleep
	EndIf
	Var tmute=0,i3=0
	If tlink=1 Then i3=3
	If tlink=2 Then i3=99
	If tlink=3 Then i3=9999
	If ii>0 And notemute(note(ii,i))<i3 Then tmute=testaccordnote(ii-1,note(ii,i))
	If tlink>=2 And notemute(note(ii,i))<i3 Then 
  	  For j=2 To tlink
       If tmute=0 And ii>=j Then tmute=testaccordnote(ii-j,note(ii,i))
  	  Next
  	EndIf  
	If tmute=0 Then 
		If notemute(note(ii,i))=999 Then notemute(note(ii,i))=0
	Else
		notemute(note(ii,i))+=tmute'once only
	EndIf
	If Abs(ii-iinote2)<1 Then tmute=0
	velo=velonote(ii,i)
	playnote(note(ii,i),tmute)
Next
End Sub
Sub subiduree0
	myttsspeak("short")
	iduree=0
	duree(iinote2)=iduree
	Sleep 200
timedrawnote=Timer-2
guisetfocus("win.graph")
End Sub
Sub subiduree1
	myttsspeak("long")
	iduree=1
	duree(iinote2)=iduree
	testinsertalign(iinote2)
	Sleep 200
timedrawnote=Timer-2
guisetfocus("win.graph")
End Sub
Sub subtest(n As Integer)
Dim As Integer i,j,k
Var x=0.0
For i=0 To n
	x+=1/(2^(i/12))
Next
	guinotice Str(x)
End Sub
'subtest(100)
'subtest(200)
'subtest(300)
'subtest(500)
Dim Shared As Integer iiplay0,tplay0
Sub drawzoom()
Dim As Integer i,j,k
Dim As Single ii,jj
'If topengl=1 Then Exit Sub 
Var ymax2=Int(ymax\2)
Var xmax3=Int(xmax*0.81)
Var x100=80
For i=1 To x100
	'ii=Int(i*0.6)
	'jj=ymax2+(0-ymax2)*0.6
	For j=1 To ymax-3
		Var pix=Point(Int(i*0.6),Int(ymax2+(j-ymax2)*0.6),wh)
		PSet wh2,(i,j),pix
		'Var pix=Point(ii,Int(jj),wh)
		'jj+=0.6
		'PSet wh2,(i,j),Point(ii,Int(jj),wh)'pix
	Next
Next
For i=x100 To xmax
	'ii=Int(xmax3-(xmax-i)*0.6)
	'jj=ymax2+(0-ymax2)*0.6
	For j=1 To ymax-3
		Var pix=Point(Int(xmax3-(xmax-i)*0.6),Int(ymax2+(j-ymax2)*0.6),wh)
		PSet wh2,(i,j),pix
		'jj+=0.6
		'PSet wh2,(i,j),Point(ii,Int(jj),wh)'pix
	Next
Next
Put wh,(1,1),wh2,PSet
guisetfocus("win.graph")
End Sub
Dim Shared As Integer ttplay
Sub testplay()
Dim As Integer i,j,k 	
If trecord=1 Then
	iiplay=max2(iinote2-20,iiplay)
	Exit Sub 
EndIf
If tplay0>=1 And tplay=0 Then timedrawnote=Timer
tplay0=tplay
If tplay=0 Or ttplay=1 Then Exit Sub 
Var dt05=0.5:If duree(iiplay)=0 Then dt05=0.25
If tlink>0 Or autot100=0 Then dt05=duree0(max2(0,iiplay))
If mtimer<timeplay+dt05 Then Exit Sub
timeplay=timeplay+dt05'max(dt05,(1+duree(max2(0,iiplay)))*0.25*0.75)
timeplay=max(mtimer,timeplay)
If tplay=1 Then iiplay=max2(iiplay,iinote2-30)
iiplay=max2(iinote1,iiplay)  
If iiplay<iinote2 Then
	iiplay+=1
	Var test=0
	If iiplay>0 Then
		If liaison(iiplay-1)=1 And iiplay<>iinote2 Then
			test=1'Exit Sub 
		EndIf
	EndIf
	If test=0 Then playaccord(iiplay)
ElseIf tloop=1 And tplay=2 And iiplay>9 Then
	iiplay=iinote1'-1
Else   	
	iiplay=iinote2
	tplay=0
	printgui("win.play","play")
	enablegui("win.load")
	enablegui("win.loadmidi")
	enablegui("win.record")
EndIf
If tplay>=2 And Abs(iiplay-iiplay0)>9 Then
	iiplay0=iiplay
	Var iinote20=iinote2
	iinote2=iiplay
	For i=1 To 5
		tput=0:If i=5 Then tput=1
		'drawnotes() 
	Next
	iinote2=iinote20
ElseIf tplay>=2 And (iiplay And 1)=0 Then 	
	Var iinote20=iinote2
	ttplay=1
	iinote2=iiplay0
	For i=1 To 1
		tput=0:If i=1 Then tput=1
		drawnotes() 
	Next
	ttplay=0
	iinote2=iinote20
ElseIf tplay=1 Then 	
	For i=1 To 1
		tput=0:If i=1 Then tput=1
		drawnotes() 
	Next
EndIf
End Sub
Function guitestkey9(vki As integer)As Integer
	If tkeyboard=0 Or guitestkey(vk_control) Then Return guitestkey(vki) 
   Return 0
End Function
Sub testplayoff()
Dim As Integer i,j,k 	
If Timer>timemidi+0.05 Then'0.1 Then'0.2
 timemidi=Timer
 'For i=1 To 127
 '	If timenote(i)>1 Then nnote+=1
 'Next
 Var tt=3.0
 If nnotemidi>10 Then tt=2
 If nnotemidi>20 Then tt=1
 If nnotemidi>30 Then tt=0.65
 If nnotemidi>40 Then tt=0.35
 If tasknoteoff=1 Then tasknoteoff=0:tt=0
 Var kreso=0.8+(nnotemidi)/(4+nnotemidi)
 tt*=kreso
 kvelo=(kreso-0.8)*0.2+0.9
 'If imidiout>=0 Then tt*=kdelay*0.01'0.527
 Var delay=0.300
 tt+=delay
 tt*=ktime
 dtmidi=tt
 nnotemidi=0
 For i=1 To 127
 	If timenote_(i)<1 Then Continue For 
 	nnotemidi+=1
 	If timemidi>timenote_(i)+tt Then
      timenote_(i)=0
      'midioutmsg=codemidi+256*note+256*256*velo
      midioutmsg=128+(i Shl 8) 'noteoff
     	midiOutShortMsg(hmidiout,midioutmsg)
      'If trec Then midioutshortmsg2(midioutmsg)
 		Sleep 1
 	EndIf
 Next
EndIf 	
End Sub
'Cls
Line wh,(0,0)-(xmax,ymax),RGB(0,0,100),bf
drawtext00()
guirefreshwindow("win")
'quit=1

openmidiout()

timedrawnote=Timer 
'iinote2=iinote
iinote2=iinote200
iinote1=iinote100
'For i=1 To iinote
'	If duree(i)=1 Then testalign(i)
'Next
For i=1 To 8+2
	'iinote2=iinote
	drawnotes()
Next

'Dim Shared As String key
'While InKey<>"":Sleep 100:Wend
Dim Shared As Double timewindow
iundo2=iundo
 
While quit=0
	guiscan
	If iinote<>iinoteold Or iinote2<>iinote2old Or iinote1<>iinote1old Then
		iinoteold=iinote
		iinote2old=iinote2
		iinote1old=iinote1
		iundo2=iundo
	EndIf
	'key=LCase(guiInKey)'does guiscan 
	If timedrawnote>1 And Timer>timedrawnote+0.5+trecord Then
		timedrawnote=0
		Var i2=2+4
		If iinote<20 Then i2=8+2
		For i=1 To i2
			tput=1:If i<i2 Then tput=0 
			drawnotes()
			tput=1
		Next
      If tzoom=1 Then
         'iinote=iinote2
	      If tplay=0 Then
	      	drawzoom()
	      EndIf
	      'hidegui("win.graph")
	      'showgui("win.graph2")
      Else
	      'hidegui("win.graph2")
	      'showgui("win.graph")
      EndIf
	EndIf
	
	If tstoprecord=1 Or tstartrecord=1 Then mysubrecord()
	If tloadmyrecord=1 Then
		tloadmyrecord=0
		trecord=0
		loadmyrecord()
		trecord=0
	EndIf

  If getactivewindow()=hwin Then  
   If tkeyboard=0 Or guitestkey(vk_control) Then 
   If guitestkey(vk_z) And tplay=0 And guitestkey(vk_control) Then subzoom():Sleep 300:guiscan 	
   If guitestkey(vk_r) And tplay=0 And guitestkey(vk_control)  Then mysubrecord():Sleep 300:guiscan 	
   If guitestkey(vk_p) Then'Or GetMouse(mousex2,mousey2,wheel2,buttons2)=0 Then
      	'If key="p" Then'Or (1 And buttons2) Then
      	   If 1 Then'tplay=0 Then
      		   subplay()
      		   partitionpause=0'1
      	   EndIf
      		If tplay>=1 Then
      			mylocate 4,55
             	myprint "[P]stop  "
      		Else
      			mylocate 4,55
             	myprint "[P]play  "
      		EndIf 	
      		'partitionpause=(partitionpause+1)Mod 2
      		'If partitionpause=1 Then
      		'	Draw String wh,(440,55),"PAUSE",RGB(255,0,0)
      		'Else
      		'	Draw String wh,(440,55),"PAUSE",RGB(0,0,100)
      		'EndIf
      		Sleep 200
         	'key=""
      	'EndIf
   EndIf
   If guitestkey(vk_m) Then
   	partitionpause=1
	   mycls2:mylocate 2,1
      Dim As midiincaps mymidiincaps
      ret=midiInGetNumDevs()
      Var nmidi=ret
      If ret<1 Then
         myprint2 "warning : sorry no MIDI input on this system!"
         Beep:guinotice msgtext'Sleep
      Else
         nmidi=min2(30,nmidi)
         Var i=0	
         for i=0 to nmidi-1
             ret=midiInGetDevCaps(i,@mymidiincaps,SizeOf(mymidiincaps))
             If ret=0 Then
             	 myprint2 Str(i)+"="+Trim(mymidiincaps.szPname)
             EndIf
         Next i
      EndIf 
      myprint2 ""
	   myprint2 "midiin : enter a value (0.."+Str(nmidi-1)+")"
	   myprint2 "        initial=0  last="+Str(imidi)
	   myInput resp';resp
	   If resp<>"" Then 
	   	imidi=max2(0,min2(nmidi-1,Val(resp)))
         midiInStop  hDevice
	   	midiinClose hdevice
         imidi=max2(0,min2(nmidi-1,imidi))	
         ret=midiInOpen(@hDevice,imidi, _
                 cast(Uinteger,@MidiInProc), _
                 0, _
                 CALLBACK_FUNCTION)
         If ret Then
	             myprint2 ("warning error open midiin("+Str(imidi)+")")
                Beep:guinotice msgtext'Sleep':ImageDestroy partitionimage
                'End
         EndIf
         If ret=0 Then
         	ret=midiInStart(hDevice)
            If ret Then
                midiInClose hDevice
                myprint2  "error can't start MIDI input !"
                Beep:guinotice msgtext'Sleep':ImageDestroy partitionimage
                'End
             EndIf
         EndIf
	   EndIf
	   'key=""
	   mycls 
     	drawtext00()
     	partitionpause=0
   	timedrawnote=timer
   EndIf
   If guitestkey(vk_c) Then
   	partitionpause=1
   	mycls2
   	myprint2 ""
   	myprint2 "midi channel : enter a number 0=all  1...16  last="+Str(ichannel)
   	myprint2 ""
	   myInput resp';resp
	   If resp<>"" Then 
	   	ichannel=max2(0,min2(16,Val(resp)))
	   EndIf
	   Sleep 200
	   mycls 
	   drawtext00()
   	partitionpause=0
   	timedrawnote=timer
	   'key=""
   EndIf 
   If guitestkey(vk_t) Then
   	minvelo=max2(0,minvelo-5)
   	drawtext0()
   	timedrawnote=Timer
   	Sleep 300
   	guiscan'While InKey<>"":Wend
   EndIf
   If guitestkey(vk_y) Then
   	minvelo=min2(125,minvelo+5)
   	drawtext0()
   	timedrawnote=Timer
   	Sleep 300
   	guiscan'While InKey<>"":Wend 
   EndIf
   Else
   	testmidikeyboard()
   EndIf'tkeyboard
   If guitestkey(vk_9) Then
     'If getactivewindow()=hwin Then  setsystestchord()
   EndIf 
   If guitestkey(vk_8) Then
     'If getactivewindow()=hwin Then  testsystestchord()
   EndIf 
   If guitestkey(vk_escape) Then quit=1
   If guitestkey(vk_f1) Or guitestkey9(vk_h) Then subhelp()
   If getfocus()<>hmsggoto Then
    If guitestkey9(vk_k) Then subtopengl():Sleep 200	
    If guitestkey(vk_prior) Then drawnote(c96+5):Sleep 300
    If guitestkey(vk_next) Then drawnote(c96+4):Sleep 300
    If guitestkey(vk_up) Or guitestkey(vk_numpad5) Or guitestkey(vk_numpad8) Then drawnote(c96+2):Sleep 300
    If guitestkey(vk_down) Or guitestkey(vk_back) Or guitestkey(vk_numpad2) Then drawnote(c96):Sleep 300
    If guitestkey(vk_left) Or guitestkey(vk_numpad1) Or guitestkey(vk_numpad4) Then
   	If guitestkey(vk_shift) Then
   		subbackward()
   	ElseIf guitestkey(vk_control) Then
   		iinote2=iinote1
   		timedrawnote=Timer
         sleep 200
   	Else 	
   		myttsspeak("previous chord")
   		subbackward1()
   	EndIf
   	'drawnote(c96+4)
   	'drawnote(40)
   	If tzoom=0 Then
   		Sleep 260
   	Else
   		Sleep 160
   	EndIf
    EndIf 	
    If guitestkey(vk_right) Or guitestkey(vk_numpad3) Or guitestkey(vk_numpad6) Then
   	If guitestkey(vk_shift) Then
   		subforward()
   	ElseIf guitestkey(vk_control) Then
   		iinote2=iinote
   		timedrawnote=Timer
         sleep 200
   	Else 
   		myttsspeak("next chord")
   		subforward1()
   	EndIf
   	'drawnote(c96+5)
   	/'drawnote(60)
   	drawnote(68)
   	drawnote(64)
   	drawnote(67)
   	drawnote(70)
   	drawnote(34)
   	drawnote(38)
   	drawnote(40)
   	drawnote(44)'/
   	If tzoom=0 Then
   		Sleep 260
   	Else
   		Sleep 160
   	EndIf
    EndIf 
   EndIf
   If ficload<>ficload0 Then
   	ficload0=ficload
   	printgui("win","pianoscore_chung          "+ficload)
   EndIf
   If tsubload=1 Then
   	tsubload=0
   	subload()
   EndIf
   If tsubsave=1 Then
   	tsubsave=0
   	subsave()
   EndIf
   If tsubsavetxt=1 Then
   	tsubsavetxt=0
   	subsavetxt()
   EndIf
   If tsubsaverec=1 Then
   	tsubsaverec=0
   	subsaverec()
   EndIf
   If tsubsave=1 Then
   	tsubsave=0
   	subsave()
   EndIf
   If tsubsaveasmidi=1 Then
   	tsubsaveasmidi=0
   	subsaveasmidi()
   EndIf
   If tsubloadmidi=1 Then
   	tsubloadmidi=0
   	subloadmidi()
   EndIf
   If tplay=0 Then
   	If iiplay<>iinote2 And iinote2>0 Then
   		tplay=1
   		iiplay=iinote2-1
   	EndIf
   EndIf
   iinote1=max2(-1,min2(iinote2-1,iinote1))
   If (tplay>=1 And guitestkey(vk_space)) Then subplay():Sleep 300:guiscan
   If (tplay=0 And guitestkey(vk_space) And trecord=0) Then subsustain():Sleep 300:guiscan
   If (tplay=0 And guitestkey9(vk_s)) Then tsustain0=0:tsustain=0:subsustain():Sleep 300:guiscan
   If (tplay=0 And guitestkey(vk_numpad0)) Then playaccord(iinote2):Sleep 300:guiscan
   If (tplay=0 And (timeaskplay>1 And Timer>timeaskplay)) Then timeaskplay=0:playaccord(iinote2):Sleep 100:guiscan
   If (tplay=0 And (timeaskplay2>1 And Timer>timeaskplay2+0.3)And nnote>0) Then
      If testnoteoff()=1 Then
      	If Timer>timeaskplay2+0.5 Then timeaskplay2=0
      	tasknoteoff=1:testplayoff() 
      EndIf 	  	
   EndIf
  If tkeyboard=0 Or guitestkey(vk_control) Then 
   If (tplay=0 And (guitestkey(vk_A)Or guitestkey(vk_q))) Then
      octave=0:drawtext0:myttsspeak("octave "+Str(octave)):Sleep 300:guiscan
   EndIf 
   If (tplay=0 And (guitestkey(vk_Z)Or guitestkey(vk_w))) Then
      octave=12:drawtext0:myttsspeak("octave "+Str(octave)):Sleep 300:guiscan
   EndIf 
   If (tplay=0 And guitestkey(vk_e)) Then
      octave=24:drawtext0:myttsspeak("octave "+Str(octave)):Sleep 300:guiscan
   EndIf 
   If (tplay=0 And guitestkey(vk_r)) Then
      octave=36:drawtext0:myttsspeak("octave "+Str(octave)):Sleep 300:guiscan
   EndIf 
  If (tplay=0 And (guitestkey(vk_o) Or guitestkey(vk_numpad9)) And octave<48) Then
      octave+=12:drawtext0:myttsspeak("octave "+Str(octave)):Sleep 300:guiscan
   EndIf 
   If (tplay=0 And (guitestkey(vk_i) Or guitestkey(vk_numpad7)) And octave>-48) Then 
   	octave-=12:drawtext0:myttsspeak("octave "+Str(octave)):Sleep 300:guiscan
   EndIf 	
  EndIf 
  If guitestkey(vk_return) Or tkeyplay>=1 Then
   	'playaccord(iinote)
   	If tplay=0 Or tkeyplay=1 Then
   		tplay=1
   	Else
   		tplay=0
   	EndIf
   	If tplay=1 Then
   		Var i9=9,dt=0.0,ii=iinote2
   		For ii=iinote2 To max2(1,iinote2-30) Step -1
   		   dt+=duree(ii)*0.35+0.25
   		   If dt>10 Then Exit For
   		Next
   		i9=max2(9,iinote2-ii)
   		iiplay=iinote2-i9
   		If tkeyplay=2 Then iiplay=iinote2-35-i9+9
      	printgui("win.play","stop")
   	Else 
       	printgui("win.play","play")
   	EndIf
   	Sleep 300
   	guiscan
   	tkeyplay=0
   	'key=""
   EndIf
  EndIf'getactivewindow 
   If partitionpause=0 Then 
   	testplay()
   EndIf
   testplayoff()
'auxvar=iinote+0.1
'auxvar2=djjnote+0.1
'auxvar4=iinote2
'auxvar5=partitiony
   /'Var i=0
   For i=1 To 16
   	If i<10 Then
   		Locate 5,84+i*2
   	Else 
   		Locate 5,84+20+(i-10)*3
   	EndIf
   	If Timer>tchannel(i)+0.5 Then
         Color RGB(155, 255, 255), RGB(0, 0, 100)
   		?Str(i);
   	Else 
         Color RGB(255, 100, 100), RGB(0, 0, 100)
   		?Str(i);
   	EndIf
   Next
   Color RGB(155, 255, 255), RGB(0, 0, 100)
	'/
	If trecord=0 Then
		If tplay>0 Then
			Sleep 2
		Else
			Sleep 30
		EndIf
      If partitionpause=0 And tplay>0 Then 
   		testplay()
	   	testplayoff()
	   EndIf 	
	Else
		sleep 200
	EndIf
  If Timer>timewindow+0.3+trecord Then
  	timewindow=timer
	'If InStr("abcdefghijklmnopqrstuvwxyz1234567890",key)>0 Then key=""
   Var i100=60*min(1,wx/1366)
   If Abs(auxvar)>0.000001 Then mylocate 1,i100:myprint "aux="+Str(auxvar)+"          "'; 
   If Abs(auxvar2)>0.000001 Then mylocate 2,i100:myprint "aux2="+Str(auxvar2)+"          "'; 
   If Abs(auxvar3)>0.000001 Then mylocate 3,i100:myprint "aux3="+Str(auxvar3)+"          "'; 
   If Abs(auxvar4)>0.000001 Then mylocate 4,i100:myprint "aux4="+Str(auxvar4)+"          "'; 
   If Abs(auxvar5)>0.000001 Then mylocate 5,i100:myprint "aux5="+Str(auxvar5)+"          "'; 
   If auxtext<>"" Then mylocate 6,i100:myprint auxtext+"          "'; 

   If testalign(iinote2) Then mylocate 6,100:myprint "align" 
   'If tplay>0 Then
   If trecord=0 then	printguih(hwinmsg,Str(iiplay)+" / "+Str(iinote)+"      ")
   'Else
   '	printguih(hwinmsg,"                  ")
   'EndIf
  If trecord=1 then
  	  mylocate 20,70
     myprint " RECORDING "+Str(myirecordall)
  EndIf
  'topengl=1
  If topengl=0 Then 
  	 guirefreshwindow("win")
  	 drawgloff()
    guirefreshopenGL
  Else 	
  	 guirefreshwindow("win")
  	 drawgl()
    guirefreshopenGL
  EndIf
  EndIf  
  mypiano_testnote()
  If guitestkey(vk_control) Then 
   _tsustain=1
  Else
   _tsustain=0
  EndIf   
Wend
midiInStop   hDevice
midiInClose  hDevice
closemidiout()
ImageDestroy wh2
ImageDestroy partitionimage
ImageDestroy dieseimage
ImageDestroy partitionimage2
ImageDestroy partitionimage3
ImageDestroy partitionimage4
ImageDestroy partitionimage4red
ImageDestroy partitionimage4red2
ImageDestroy liaisonimage

myTTSclose()
guicloseOpenGL()
mypiano_close()
Sleep 100

file=freefile
Open ficini For Output As #file
Print #file,imidi
Print #file,ichannel
Print #file,minvelo
Print #file,iinote
For i=0 To iinote
   Print #file,iaccord(i)
   For j=1 To iaccord(i)
   	Print #file,note(i,j)
   Next
Next
For i=0 To iinote
   Print #file,liaison(i)
Next 
Print #file,c96
Print #file,iduree
For i=0 To iinote
   Print #file,duree(i)
Next 
Print #file,tlink
For i=0 To iinote
   Print #file,duree0(i)
Next 
For i=0 To iinote
	For j=1 To iaccord(i)
		Print #file,notetime(i,j)
	Next
Next
Print #file,iundo
Print #file,t100
Print #file,ficload
Print #file,volume
Print #file,iinote2
Print #file,iinote1
Print #file,tt100
Print #file,autot100
Print #file,topengl
Print #file,octave
Print #file,tpianoonly
Print #file,mypianoreverb
Print #file,mypianochorus
Print #file,mypianotreverb
Print #file,mypianotchorus
Print #file,mypianokvelo
Print #file,mypianoattack
Close #file


guiclose()
guiquit()

End
Dim Shared As Double timerecord0
Sub midioutshortmsg2(midimsg As Integer)
	If irecord<nrecord Then
		irecord+=1
		recordmsg(irecord).value=midimsg
		recordtime(irecord)=Timer-timerecord0
	EndIf
End Sub
Dim Shared As Integer notemute2(256),notemute20(256)
/'Sub saveasmidi2(fic As String)
Dim As Integer i,j,k,ii,jj,midimsg,codemidi,velo,notemidi 
Dim As Double dt 
For i=1 To iinote
	testalign(i)
Next
dt=0
irecord=0
For i=1 To 120
	notemute(i)=0
	notemute0(i)=0
	notemute2(i)=0
	notemute20(i)=0
Next
Var tmute=0,idt=0
For i=0 To iinote
	If irecord>=nrecord-2*iaccord(i) Then Exit For 
	Var test=0
	If i>=1 And i<=iinote Then 
		If liaison(i-1)=1 Then test=1
	EndIf
	If test=0 Then
	 For j=1 To 120
		If notemute(j)>0 Then
			notemute(j)+=1:If notemute(j)>5 Then notemute(j)=0
		EndIf
	 	notemute0(j)=notemute(j)
	 Next
	 If i>0 Then
	 	 Var test1=compareaccord(i,i-1) 
       If test1=1 Then
	   	For j=1 To iaccord(i)
		   	'playnote(note(i,j),0)
			   notemute(note(i,j))=999
			   notemute0(note(i,j))=999
	   	Next
       ElseIf test1=2 Then  
		   For j=1 To iaccord(i)
			   notemute(note(i,j))=9
			   notemute0(note(i,j))=9
		   Next
       EndIf
	 EndIf
	 For j=1 To iaccord(i)
		If irecord>=nrecord Then Exit For
		tmute=0
		Var i3=3
		If tlink>=1 Then i3=9999
		If i>0 And notemute(note(i,j))<3 Then tmute=testaccordnote(i-1,note(i,j))
   	If tlink>=1 Then 
  	      For k=2 To 1+tlink
            If tmute=0 And i>=k Then tmute=testaccordnote(i-k,note(i,j))
  	      Next
     	EndIf  
		If notemute(note(i,j))=999 Then
			notemute(note(i,j))=0
		'ElseIf duree(i)=1 Then
		'	notemute(note(i,j))=tmute+tmute+notemute0(note(i,j))
		Else 	
			notemute(note(i,j))=tmute+notemute0(note(i,j))
		EndIf
		If tmute=0 Then
		EndIf
		If tmute=1 Then Continue For 
		irecord+=1
		codemidi=144
		velo=110
		notemidi=note(i,j)
      midimsg=codemidi+(notemidi Shl 8)+(velo Shl 16)
      recordmsg(irecord).value=midimsg
		recordtime(irecord)=dt
	 Next
	EndIf 	
	If duree(i)=1 Then
		dt+=0.5
		idt+=2
	Else
		dt+=0.25
		idt+=1
	EndIf
	test=0
	If i>=0 And i<iinote Then 
		If liaison(i)=1 Then test=1
	EndIf
	If test=0 Then 
	 For j=1 To 120
		If notemute2(j)>0 Then
			notemute2(j)+=1:If notemute2(j)>5 Then notemute2(j)=0
		EndIf
	 	notemute20(j)=notemute2(j)
	 Next
	 If i>0 Then
	 	 Var test1=compareaccord(i,i-1) 
       If test1=1 Then
	   	For j=1 To iaccord(i)
		   	'playnote(note(i,j),0)
			   notemute2(note(i,j))=999
			   notemute20(note(i,j))=999
	   	Next
       ElseIf test1=2 Then  
		   For j=1 To iaccord(i)
			   notemute2(note(i,j))=9
			   notemute20(note(i,j))=9
		   Next
       EndIf
	 EndIf
	 For j=1 To iaccord(i)
		If irecord>=nrecord Then Exit For
		tmute=0
	   'If i<iinote And notemute20(note(i,j))=0 Then tmute=testaccordnote(i+1,note(i,j))
		'notemute2(note(i,j))=tmute
		If i<iinote And notemute2(note(i,j))<3 Then tmute=testaccordnote(i+1,note(i,j))
		If notemute2(note(i,j))=999 Then
			notemute2(note(i,j))=0
		'ElseIf duree(i)=1 Then
		'	notemute2(note(i,j))=tmute+tmute+notemute20(note(i,j))
		Else 	
			notemute2(note(i,j))=tmute+notemute20(note(i,j))
		EndIf
		If tmute=0 Then
			'notemute2(note(i,j))=0
		EndIf
		If tmute=1 Then Continue For 
		irecord+=1
		codemidi=128
		velo=0
		notemidi=note(i,j)
      midimsg=codemidi+(notemidi Shl 8)+(velo Shl 16)
      recordmsg(irecord).value=midimsg
		recordtime(irecord)=dt
	 Next
	EndIf  
Next
exportmidi(fic)
'guinotice "irecord = "+Str(irecord)+"  dt= "+Str(dt)
End Sub '/
Dim Shared As Integer mynoteon(256),tmute0(256),tquant
Dim Shared As Double mynoteontime(256)
Sub saveasmidinoquant(fic As String,ttxt As Integer=0)
Dim As Integer i,j,k,ii,jj,midimsg,codemidi,velo,notemidi,iii
Dim As Double dt,dtime
'For i=1 To iinote
'	testalign(i)
'Next
For i=1 To iinote
   'formataccord(i)
Next
dt=0
irecord=0
For i=1 To 120
	mynoteon(i)=0
	mynoteontime(i)=0
Next
Var tmute=0,idt=0
Var i3=-1 'nomute
'If tlink=1 Then i3=2'0.1
'If tlink=2 Then i3=3'1'99
'If tlink=3 Then i3=4'2'9999
'i3=9
'guinotice "link="+Str(tlink)
Var dtt=0.0,kdt=0.0
For i=0 To iinote
	If irecord>=nrecord-2*iaccord(i) Then Exit For 
	Var test=0
	If i>=1 And i<=iinote Then 
		If liaison(i-1)=1 Then test=1
	EndIf
	If test=0 Then
    For k=1 To iaccord(i)
 		  notetimeaccord(k)=notetime(i,k)
 	 Next   
	 'For j=1 To iaccord(i)
    For iii=1 To iaccord(i)
	   j=iii:dtime=999.0
	   For k=1 To iaccord(i)
   		If dtime>notetimeaccord(k) Then
	   		dtime=notetimeaccord(k)
		   	j=k
   		EndIf
	   Next k 	
   	notetimeaccord(j)=9999.9
	   dtime=max(0.0,min(1.0,dtime))
		If irecord>=nrecord-1 Then Exit For
		tmute=0
		notemidi=note(i,j)
		If mynoteon(notemidi)=1 Then 		
		      irecord+=1
		      codemidi=128
		      velo=0
            midimsg=codemidi+(notemidi Shl 8)+(velo Shl 16)
            recordmsg(irecord).value=midimsg
            Var dtime2=dtime
            If tquant=1 Then dtime2=0.005+Int(dtime*4+0.5)*0.25
	      	recordtime(irecord)=dt+dtime2
	 			mynoteon(notemidi)=0
	 			mynoteontime(notemidi)=0
		EndIf
		irecord+=1
		codemidi=144
		velo=velonote(i,j)
		If velo<1 Then velo=110
		velo=90+velo*38*((80+127)/127)/(80+velo)
      velo=max2(2,min2(127,Int(velo*kvelo)))
      midimsg=codemidi+(notemidi Shl 8)+(velo Shl 16)
      recordmsg(irecord).value=midimsg
      Var dtime2=dtime
      If tquant=1 Then dtime2=0.01+Int(dtime*4+0.5)*0.25
		recordtime(irecord)=dt+dtime2
		mynoteon(notemidi)=1
		mynoteontime(notemidi)=dt+dtime
	 Next
	EndIf 	
	If tquant=1 Then
		dt+=Int(duree0(i)*4+0.5)*0.25
		idt+=1
	Else  
	   dt+=duree0(i)
	   idt+=1
	EndIf  

/' If dt>dtt+0.1 Then'0.2
 Var dtt0=dtt	
 For dtt=dtt0 To dt Step 0.1
 Var tt=3.0
 If nnotemidi>10 Then tt=2
 If nnotemidi>20 Then tt=1
 If nnotemidi>30 Then tt=0.65
 If nnotemidi>40 Then tt=0.35
 Var kreso=0.8+(nnotemidi)/(4+nnotemidi)
 tt*=0.8'kreso
 kvelo=(kreso-0.8)*0.2+0.9 
 nnotemidi=0
    'For j=1 To 120
    For j=10 To 110
		If irecord>=nrecord Then Exit For
	 	If mynoteon(j)=1 Then
	 		nnotemidi+=1
	 		If dt>mynoteontime(j)+tt Then'2.135 Then
		      irecord+=1
		      codemidi=128
		      velo=0
	       	notemidi=j
            midimsg=codemidi+(notemidi Shl 8)+(velo Shl 16)
            recordmsg(irecord).value=midimsg
	      	recordtime(irecord)=dtt
	 			mynoteon(notemidi)=0
	 			mynoteontime(notemidi)=0
	 		EndIf
	 	EndIf
    Next
 Next dtt
 dtt=dt
  EndIf
'/
	test=0
	If i>=0 And i<iinote Then 
		If liaison(i)=1 Then test=1
	EndIf
	If test=0 And i<iinote Then 
	 Var ii=i
	 'For j=1 To iaccord(ii)
    /'For k=1 To iaccord(i)
 		  notetimeaccord(k)=notetime(i,k)
    Next   
    For iii=1 To iaccord(i)
	   j=iii:dtime=999.0
	   For k=1 To iaccord(i)
   		If dtime>notetimeaccord(k) Then
	   		dtime=notetimeaccord(k)
		   	j=k
   		EndIf
	   Next k 	
   	notetimeaccord(j)=9999.9
	   dtime=max(0.0,min(1.0,dtime))'/
		/'If irecord>=nrecord Then Exit For
		tmute=0
		notemidi=note(ii,j)
		If mynoteon(notemidi)=0 Then Continue For 
		irecord+=1
		codemidi=128
		velo=0
      midimsg=codemidi+(notemidi Shl 8)+(velo Shl 16)
      recordmsg(irecord).value=midimsg
		recordtime(irecord)=dt
		mynoteon(notemidi)=0
	 	mynoteontime(notemidi)=0
	 Next'/
 Var t01=0.1,dt01=0.1
 If tquant=1 Then t01=0.25:dt01=0.02	 
 If dt>dtt+t01 Then'0.2
 Var dtt0=dtt	
 For dtt=dtt0 To dt Step dt01
 Var tt=3.0
 If nnotemidi>10 Then tt=2
 If nnotemidi>20 Then tt=1
 If nnotemidi>30 Then tt=0.65
 If nnotemidi>40 Then tt=0.35
 Var kreso=0.8+(nnotemidi)/(4+nnotemidi)
 'tt*=0.8'kreso
 Var delay=0.300
 tt+=delay
 kvelo=(kreso-0.8)*0.2+0.9 
 If tquant=1 Then tt=1
 nnotemidi=0
    For j=1 To 120
		If irecord>=nrecord Then Exit For
	 	If mynoteon(j)=1 Then
	 		nnotemidi+=1
	 		If dt>mynoteontime(j)+tt Then'2.135 Then
		      irecord+=1
		      codemidi=128
		      velo=0
	       	notemidi=j
            midimsg=codemidi+(notemidi Shl 8)+(velo Shl 16)
            recordmsg(irecord).value=midimsg
	      	recordtime(irecord)=dtt
	 			mynoteon(notemidi)=0
	 			mynoteontime(notemidi)=0
	 		EndIf
	 	EndIf
    Next
 Next dtt
 dtt=dt
  EndIf
 EndIf 
Next
If tquant=0 Then
	dt+=0.8
Else
	dt+=1
EndIf
Var dt05=duree0(i)
dt=dt-dt05+max(dt05,(1+duree(max2(0,i)))*0.25*0.75)
	 For j=1 To 120 'allnoteoff
		If irecord>=nrecord Then Exit For
	 	If mynoteon(j)=1 Then
	 		'If dt>mynoteontime(j)+1 Then
		      irecord+=1
		      codemidi=128
		      velo=0
	       	notemidi=j
            midimsg=codemidi+(notemidi Shl 8)+(velo Shl 16)
            recordmsg(irecord).value=midimsg
	      	recordtime(irecord)=dt
	 			mynoteon(notemidi)=0
	 			mynoteontime(notemidi)=0
	 		'EndIf
	 	EndIf
	 Next j	
If tt100<>100 Then
	guiconfirm("apply Time scale ? T"+Str(tt100),"confirm",resp)
	If resp="yes" Then
		For i=1 To irecord
   		recordtime(i)=recordtime(i)/ktime
		Next
	EndIf
EndIf
If ttxt=0 Then
	exportmidi(fic)
Else 	
	exportmiditext(fic)
EndIf
'guinotice "irecord = "+Str(irecord)+"  dt= "+Str(dt)
End Sub
Sub saverec(fic As String)
Dim As Integer i,j,k
irecord=myirecordall
recordtime(0)=0
For i=1 To irecord
	recordtime(i)=myrecordtimeall(i)
	recordmsg(i)=myrecordmsgall(i)
Next
exportmidi(fic)
End Sub
Sub saveasmidinoquant0(fic As String,ttxt As Integer=0)
Dim As Integer i,j,k,ii,jj,midimsg,codemidi,velo,notemidi,iii
Dim As Double dt,dtime
'For i=1 To iinote
'	testalign(i)
'Next
For i=1 To iinote
   'formataccord(i)
Next
dt=0
irecord=0
For i=1 To 120
	notemute(i)=0
	notemute0(i)=0
	notemute2(i)=0
	notemute20(i)=0
	mynoteon(i)=0
	mynoteontime(i)=0
Next
Var tmute=0,idt=0
Var i3=-1
If tlink=1 Then i3=1'0.1
If tlink=2 Then i3=2'1'99
If tlink=3 Then i3=3'2'9999
'i3=9
guinotice "link="+Str(tlink)
Var dtt=0.0
For i=0 To iinote
	If irecord>=nrecord-2*iaccord(i) Then Exit For 
	Var test=0
	If i>=1 And i<=iinote Then 
		If liaison(i-1)=1 Then test=1
	EndIf
	If test=0 Then
	 For j=1 To 120
	 	notemute0(j)=notemute(j)
	 	If notemute(j)>=1 Then 
	 		notemute(j)+=1
	 		If notemute(j)>i3 Then notemute(j)=0
	 	EndIf
	 	tmute0(j)=0
	 Next
    For k=1 To iaccord(i)
 		  notetimeaccord(k)=notetime(i,k)
 	 Next   
	 'For j=1 To iaccord(i)
    For iii=1 To iaccord(i)
	   j=iii:dtime=999.0
	   For k=1 To iaccord(i)
   		If dtime>notetimeaccord(k) Then
	   		dtime=notetimeaccord(k)
		   	j=k
   		EndIf
	   Next k 	
   	notetimeaccord(j)=9999.9
	   dtime=max(0.0,min(1.0,dtime))
		If irecord>=nrecord-1 Then Exit For
		tmute=0
		If i>0 And notemute0(note(i,j))<i3 Then tmute=testaccordnote(i-1,note(i,j))
		If duree(i)=1 Then
			notemute(note(i,j))=tmute+tmute+notemute0(note(i,j))
		Else 	
			notemute(note(i,j))=tmute+notemute0(note(i,j))
		EndIf
		tmute0(note(i,j))=tmute
		If tmute=0 Then notemute(note(i,j))=0
		If tmute=1 And (tlink>0 Or 1) Then Continue For 
		notemidi=note(i,j)
		If mynoteon(notemidi)=1 Then 		
		      irecord+=1
		      codemidi=128
		      velo=0
            midimsg=codemidi+(notemidi Shl 8)+(velo Shl 16)
            recordmsg(irecord).value=midimsg
	      	recordtime(irecord)=dt+dtime
	 			mynoteon(notemidi)=0
	 			mynoteontime(notemidi)=0
		EndIf
		irecord+=1
		codemidi=144
		velo=110
      midimsg=codemidi+(notemidi Shl 8)+(velo Shl 16)
      recordmsg(irecord).value=midimsg
		recordtime(irecord)=dt+dtime
		mynoteon(notemidi)=1
		mynoteontime(notemidi)=dt+dtime
	 Next
	EndIf 	
	/'If duree(i)=1 Then
		dt+=0.5
		idt+=2
	Else
		dt+=0.25
		idt+=1
	EndIf'/
	dt+=duree0(i)
	idt+=1

 If dt>dtt+0.1 Then'0.2
 Var dtt0=dtt	
 For dtt=dtt0 To dt Step 0.1
 Var tt=3.0
 If nnotemidi>10 Then tt=2
 If nnotemidi>20 Then tt=1
 If nnotemidi>30 Then tt=0.65
 If nnotemidi>40 Then tt=0.35
 nnotemidi=0
    For j=1 To 120
		If irecord>=nrecord Then Exit For
	 	If mynoteon(j)=1 Then
	 		nnotemidi+=1
	 		If dt>mynoteontime(j)+tt Then'2.135 Then
		      irecord+=1
		      codemidi=128
		      velo=0
	       	notemidi=j
            midimsg=codemidi+(notemidi Shl 8)+(velo Shl 16)
            recordmsg(irecord).value=midimsg
	      	recordtime(irecord)=dtt
	 			mynoteon(notemidi)=0
	 			mynoteontime(notemidi)=0
	 			notemute(notemidi)=0
	 			notemute2(notemidi)=0
	 		EndIf
	 	EndIf
    Next
 Next dtt
 dtt=dt
  EndIf

	test=0
	If i>=0 And i<iinote Then 
		If liaison(i)=1 Then test=1
	EndIf
	If test=0 And i<iinote Then 
	 For j=1 To 120
	 	notemute20(j)=notemute2(j)
	 	notemute2(j)=0 
	 Next'/ 
	 Var ii=i
	 For j=1 To iaccord(ii)
    /'For k=1 To iaccord(i)
 		  notetimeaccord(k)=notetime(i,k)
    Next   
    For iii=1 To iaccord(i)
	   j=iii:dtime=999.0
	   For k=1 To iaccord(i)
   		If dtime>notetimeaccord(k) Then
	   		dtime=notetimeaccord(k)
		   	j=k
   		EndIf
	   Next k 	
   	notetimeaccord(j)=9999.9
	   dtime=max(0.0,min(1.0,dtime))'/
		If irecord>=nrecord Then Exit For
		tmute=0
	   'If i<iinote And notemute20(note(i,j))=0 Then tmute=testaccordnote(i+1,note(i,j))
		'notemute2(note(i,j))=tmute
		If ii>0 And notemute20(note(ii,j))<i3 Then tmute=testaccordnote(ii-1,note(ii,j))
		If duree(ii)=1 Then
			notemute2(note(ii,j))=tmute+tmute+notemute20(note(ii,j))
		Else 	
			notemute2(note(ii,j))=tmute+notemute20(note(ii,j))
		EndIf
		If tmute=0 Then notemute2(note(ii,j))=0
		'If tmute=1 And (tlink>0 Or 1) Then Continue For 
		'/
		If tmute0(note(ii,j))=1 Then Continue For 
		notemidi=note(ii,j)
		If mynoteon(notemidi)=0 Then Continue For 
		irecord+=1
		codemidi=128
		velo=0
      midimsg=codemidi+(notemidi Shl 8)+(velo Shl 16)
      recordmsg(irecord).value=midimsg
		recordtime(irecord)=dt
		mynoteon(notemidi)=0
	 	mynoteontime(notemidi)=0
	 Next'/
 If dt>dtt+0.1 Then'0.2
 Var dtt0=dtt	
 For dtt=dtt0 To dt Step 0.1
 Var tt=3.0
 If nnotemidi>10 Then tt=2
 If nnotemidi>20 Then tt=1
 If nnotemidi>30 Then tt=0.65
 If nnotemidi>40 Then tt=0.35
 nnotemidi=0
    For j=1 To 120
		If irecord>=nrecord Then Exit For
	 	If mynoteon(j)=1 Then
	 		nnotemidi+=1
	 		If dt>mynoteontime(j)+tt Then'2.135 Then
		      irecord+=1
		      codemidi=128
		      velo=0
	       	notemidi=j
            midimsg=codemidi+(notemidi Shl 8)+(velo Shl 16)
            recordmsg(irecord).value=midimsg
	      	recordtime(irecord)=dtt
	 			mynoteon(notemidi)=0
	 			mynoteontime(notemidi)=0
	 			notemute(notemidi)=0
	 			notemute2(notemidi)=0
	 		EndIf
	 	EndIf
    Next
 Next dtt
 dtt=dt
  EndIf
 EndIf 
Next
'dt+=1
Var dt05=duree0(i)
dt=dt-dt05+max(dt05,(1+duree(max2(0,i)))*0.25*0.75)
	 For j=1 To 120
		If irecord>=nrecord Then Exit For
	 	notemute20(j)=notemute2(j)
	 	notemute2(j)=0 
	 	If mynoteon(j)=1 Then
	 		'If dt>mynoteontime(j)+1 Then
		      irecord+=1
		      codemidi=128
		      velo=0
	       	notemidi=j
            midimsg=codemidi+(notemidi Shl 8)+(velo Shl 16)
            recordmsg(irecord).value=midimsg
	      	recordtime(irecord)=dt
	 			mynoteon(notemidi)=0
	 			mynoteontime(notemidi)=0
	 		'EndIf
	 	EndIf
	 Next j	
If ttxt=0 Then
	exportmidi(fic)
Else 	
	exportmiditext(fic)
EndIf
'guinotice "irecord = "+Str(irecord)+"  dt= "+Str(dt)
End Sub
Sub saveasmidilink(fic As String)
Dim As Integer i,j,k,ii,jj,midimsg,codemidi,velo,notemidi 
Dim As Double dt 
For i=1 To iinote
	testinsertalign(i)
Next
For i=1 To iinote
   formataccord(i)
Next
dt=0
irecord=0
For i=1 To 120
	notemute(i)=0
	notemute0(i)=0
	notemute2(i)=0
	notemute20(i)=0
Next
Var tmute=0,idt=0
Var i3=0
If tlink=1 Then i3=3
If tlink=2 Then i3=99
If tlink=3 Then i3=9999
i3=9
For i=0 To iinote
	If irecord>=nrecord-2*iaccord(i) Then Exit For 
	Var test=0
	If i>=1 And i<=iinote Then 
		If liaison(i-1)=1 Then test=1
	EndIf
	If test=0 Then
	 For j=1 To 120
	 	notemute0(j)=notemute(j)
	 	notemute(j)=0 
	 Next
	 For j=1 To iaccord(i)
		If irecord>=nrecord Then Exit For
		tmute=0
		If i>0 And notemute0(note(i,j))<=i3 Then tmute=testaccordnote(i-1,note(i,j))
		If duree(i)=1 Then
			notemute(note(i,j))=tmute+tmute+notemute0(note(i,j))
		Else 	
			notemute(note(i,j))=tmute+notemute0(note(i,j))
		EndIf
		If tmute=0 Then notemute(note(i,j))=0
		If tmute=1 And (tlink>0 Or 1) Then Continue For 
		irecord+=1
		codemidi=144
		velo=110
		notemidi=note(i,j)
      midimsg=codemidi+(notemidi Shl 8)+(velo Shl 16)
      recordmsg(irecord).value=midimsg
		recordtime(irecord)=dt
	 Next
	EndIf 	
	If duree(i)=1 Then
		dt+=0.5
		idt+=2
	Else
		dt+=0.25
		idt+=1
	EndIf
	test=0
	If i>=0 And i<iinote Then 
		If liaison(i)=1 Then test=1
	EndIf
	If test=0 Then 
	 For j=1 To 120
	 	notemute20(j)=notemute2(j)
	 	notemute2(j)=0 
	 Next
	 For j=1 To iaccord(i)
		If irecord>=nrecord Then Exit For
		tmute=0
	   'If i<iinote And notemute20(note(i,j))=0 Then tmute=testaccordnote(i+1,note(i,j))
		'notemute2(note(i,j))=tmute
		If i<iinote And notemute20(note(i,j))<=i3 Then tmute=testaccordnote(i+1,note(i,j))
		If duree(i)=1 Then
			notemute2(note(i,j))=tmute+tmute+notemute20(note(i,j))
		Else 	
			notemute2(note(i,j))=tmute+notemute20(note(i,j))
		EndIf
		If tmute=0 Then notemute2(note(i,j))=0
		If tmute=1 And (tlink>0 Or 1) Then Continue For 
		irecord+=1
		codemidi=128
		velo=0
		notemidi=note(i,j)
      midimsg=codemidi+(notemidi Shl 8)+(velo Shl 16)
      recordmsg(irecord).value=midimsg
		recordtime(irecord)=dt
	 Next
	EndIf  
Next
exportmidi(fic)
'guinotice "irecord = "+Str(irecord)+"  dt= "+Str(dt)
End Sub
Sub saveasmidi(fic As String)
Dim As Integer i,j,k,ii,jj,midimsg,codemidi,velo,notemidi 
Dim As Double dt 
guiconfirm("NO quantize ?","confirm",resp)
If resp="yes" Then 
	saveasmidinoquant(fic)
	Exit Sub 
EndIf

guiconfirm "full quantize ?","confirm",resp
If resp="no" Then
  tquant=1
  saveasmidinoquant(fic)
  tquant=0
  Exit Sub 
EndIf  

For i=1 To iinote
	'testalign(i)
Next
For i=1 To iinote
   'formataccord(i)
Next



dt=0
irecord=0
For i=1 To 120
	notemute(i)=0
	notemute0(i)=0
	notemute2(i)=0
	notemute20(i)=0
Next
Var tmute=0,idt=0
For i=0 To iinote
	If irecord>=nrecord-2*iaccord(i) Then
		guinotice "max nnotes reached !"
		Exit For 
	EndIf
	Var test=0
	If i>=1 And i<=iinote Then 
		If liaison(i-1)=1 Then test=1
	EndIf
	If test=0 Then
	 For j=1 To 120
	 	notemute0(j)=notemute(j)
	 	notemute(j)=0 
	 Next
	 For j=1 To iaccord(i)
		If irecord>=nrecord Then Exit For
		tmute=0
		If i>0 And notemute0(note(i,j))<=3 Then tmute=testaccordnote(i-1,note(i,j))
		If duree(i)=1 Then
			notemute(note(i,j))=tmute+tmute+notemute0(note(i,j))
		Else 	
			notemute(note(i,j))=tmute+notemute0(note(i,j))
		EndIf
		If tmute=0 Then notemute(note(i,j))=0
		'If tmute=1 And tlink>0 Then Continue For 
		irecord+=1
		codemidi=144
		velo=110
		notemidi=note(i,j)
      midimsg=codemidi+(notemidi Shl 8)+(velo Shl 16)
      recordmsg(irecord).value=midimsg
		recordtime(irecord)=dt
	 Next
	EndIf 	
	If duree(i)=1 Then
		dt+=0.5
		idt+=2
	Else
		dt+=0.25
		idt+=1
	EndIf
	test=0
	If i>=0 And i<iinote Then 
		If liaison(i)=1 Then test=1
	EndIf
	If test=0 Then 
	 For j=1 To 120
	 	notemute20(j)=notemute2(j)
	 	notemute2(j)=0 
	 Next
	 For j=1 To iaccord(i)
		If irecord>=nrecord Then Exit For
		tmute=0
	   'If i<iinote And notemute20(note(i,j))=0 Then tmute=testaccordnote(i+1,note(i,j))
		'notemute2(note(i,j))=tmute
		If i<iinote And notemute20(note(i,j))<=3 Then tmute=testaccordnote(i+1,note(i,j))
		If duree(i)=1 Then
			notemute2(note(i,j))=tmute+tmute+notemute20(note(i,j))
		Else 	
			notemute2(note(i,j))=tmute+notemute20(note(i,j))
		EndIf
		If tmute=0 Then notemute2(note(i,j))=0
		'If tmute=1 And tlink>0 Then Continue For 
		irecord+=1
		codemidi=128
		velo=0
		notemidi=note(i,j)
      midimsg=codemidi+(notemidi Shl 8)+(velo Shl 16)
      recordmsg(irecord).value=midimsg
		recordtime(irecord)=dt
	 Next
	EndIf  
Next '/
exportmidi(fic)
'guinotice "irecord = "+Str(irecord)+"  dt= "+Str(dt)
End Sub
Sub saveasmidi_old(fic As String)
Dim As Integer i,j,k,ii,jj,midimsg,codemidi,velo,notemidi 
Dim As Double dt 
guiconfirm("NO quantize ?","confirm",resp)
If resp="yes" Then 
	saveasmidinoquant(fic)
	Exit Sub 
EndIf
For i=1 To iinote
	testinsertalign(i)
Next
For i=1 To iinote
   formataccord(i)
Next
dt=0
irecord=0
For i=1 To 120
	notemute(i)=0
	notemute0(i)=0
	notemute2(i)=0
	notemute20(i)=0
Next
Var tmute=0,idt=0
For i=0 To iinote
	If irecord>=nrecord-2*iaccord(i) Then Exit For 
	Var test=0
	If i>=1 And i<=iinote Then 
		If liaison(i-1)=1 Then test=1
	EndIf
	If test=0 Then
	 For j=1 To 120
	 	notemute0(j)=notemute(j)
	 	notemute(j)=0 
	 Next
	 For j=1 To iaccord(i)
		If irecord>=nrecord Then Exit For
		tmute=0
		If i>0 And notemute0(note(i,j))<=3 Then tmute=testaccordnote(i-1,note(i,j))
		If duree(i)=1 Then
			notemute(note(i,j))=tmute+tmute+notemute0(note(i,j))
		Else 	
			notemute(note(i,j))=tmute+notemute0(note(i,j))
		EndIf
		If tmute=0 Then notemute(note(i,j))=0
		'If tmute=1 And tlink>0 Then Continue For 
		irecord+=1
		codemidi=144
		velo=110
		notemidi=note(i,j)
      midimsg=codemidi+(notemidi Shl 8)+(velo Shl 16)
      recordmsg(irecord).value=midimsg
		recordtime(irecord)=dt
	 Next
	EndIf 	
	If duree(i)=1 Then
		dt+=0.5
		idt+=2
	Else
		dt+=0.25
		idt+=1
	EndIf
	test=0
	If i>=0 And i<iinote Then 
		If liaison(i)=1 Then test=1
	EndIf
	If test=0 Then 
	 For j=1 To 120
	 	notemute20(j)=notemute2(j)
	 	notemute2(j)=0 
	 Next
	 For j=1 To iaccord(i)
		If irecord>=nrecord Then Exit For
		tmute=0
	   'If i<iinote And notemute20(note(i,j))=0 Then tmute=testaccordnote(i+1,note(i,j))
		'notemute2(note(i,j))=tmute
		If i<iinote And notemute20(note(i,j))<=3 Then tmute=testaccordnote(i+1,note(i,j))
		If duree(i)=1 Then
			notemute2(note(i,j))=tmute+tmute+notemute20(note(i,j))
		Else 	
			notemute2(note(i,j))=tmute+notemute20(note(i,j))
		EndIf
		If tmute=0 Then notemute2(note(i,j))=0
		'If tmute=1 And tlink>0 Then Continue For 
		irecord+=1
		codemidi=128
		velo=0
		notemidi=note(i,j)
      midimsg=codemidi+(notemidi Shl 8)+(velo Shl 16)
      recordmsg(irecord).value=midimsg
		recordtime(irecord)=dt
	 Next
	EndIf  
Next
exportmidi(fic)
'guinotice "irecord = "+Str(irecord)+"  dt= "+Str(dt)
End Sub
Dim Shared As MIDIMESSAGE recordmsg2(nrecord),noteonmsg,noteoffmsg
Dim Shared As Double recordtime2(nrecord)
Dim Shared As Integer irecord2,noteaccord(100),noteaccord2(100),tnoteaccord(100),tnoteaccord2(100)
Sub resetaccord()
Dim As Integer i
For i=0 To 100
  	noteaccord(i)=0
   tnoteaccord(i)=0
Next
End Sub
Sub resetaccord2()
Dim As Integer i
For i=0 To 100
	noteaccord2(i)=0
	tnoteaccord2(i)=0
Next
End Sub
Sub resetaccordtest()
Dim As Integer i
For i=0 To 100
	If tnoteaccord(i)>0.1 Then
		tnoteaccord(i)-=1
	Else 	
   	noteaccord(i)=0
	   tnoteaccord(i)=0
	EndIf    
Next
End Sub
Sub addaccord(inote As Integer)
Dim As Integer i,j,k
For i=1 To 100
	If noteaccord(i)=inote Then
		tnoteaccord(i)=tlink
		Exit Sub
	EndIf
Next
For i=1 To 100
	If noteaccord(i)=0 Then
		tnoteaccord(i)=tlink
		noteaccord(i)=inote
		Exit Sub 
	EndIf
Next
End Sub
Sub addaccord2(inote As Integer)
Dim As Integer i,j,k
For i=1 To 100
	If noteaccord2(i)=inote Then
		tnoteaccord2(i)=tlink
		Exit Sub
	EndIf
Next
For i=1 To 100
	If noteaccord2(i)=0 Then
		tnoteaccord2(i)=tlink
		noteaccord2(i)=inote
		Exit Sub 
	EndIf
Next
End Sub
Sub removeaccord(inote As Integer)
Dim As Integer i,j,k
For i=1 To 100
	If noteaccord(i)=inote Then
		tnoteaccord(i)=0
		noteaccord(i)=0':Exit Sub
	EndIf
Next
End Sub
Sub removeaccord2(inote As Integer)
Dim As Integer i,j,k
For i=1 To 100
	If noteaccord2(i)=inote Then
		tnoteaccord2(i)=0
		noteaccord2(i)=0':Exit Sub
	EndIf
Next
End Sub
Function nnoteaccord()As Integer
Dim As Integer i,j,k
For i=1 To 100
	If noteaccord(i)>0 Then j+=1
Next
Return j
End Function
Function nnoteaccord2()As Integer
Dim As Integer i,j,k
For i=1 To 100
	If noteaccord2(i)>0 Then j+=1
Next
Return j
End Function
Sub subquantizerectime()
Dim As Integer i,j,k
Var timerec0=recordtime(0)
recordtime2(0)=0
Var t=0.0,dt=0.0
For i=1 To irecord
   dt=recordtime(i)-recordtime(i-1)
   If dt<0.1 Then
   	t+=0
   ElseIf dt<0.251 Then
   	t+=0.25
   ElseIf dt<0.51 Then
   	t+=0.5
   ElseIf dt<0.76 Then
   	t+=0.75
   ElseIf dt<1.1 Then
   	t+=1
   ElseIf dt<1.6 Then
   	t+=1.5
   Else 	
   	t+=2
   EndIf
	recordtime2(i)=t
	recordmsg2(i)=recordmsg(i)
Next
For i=0 To irecord
	recordtime(i)=recordtime2(i)
Next
End Sub 
Sub subquantizerec()
Dim As Integer i,j,k
subquantizerectime():Exit Sub 
guinotice "link="+Str(tlink)
irecord2=0
Var timerec0=recordtime(0)
Var timerec=0.0
timerec0=0
Var timeaccord=timerec  
Var timerec2=timerec
Var auxmsg=256*256*256-1
Var canalout=0,veloout=120
Var note=1
noteonmsg.value=144+canalout+note*256+veloout*256*256
noteoffmsg.value=128+canalout+note*256+0*256*256
recordtime2(0)=0
timerec2=0
resetaccord()
resetaccord2()
For i=1 To irecord
	  timerec=recordtime(i)-recordtime(0)
     Var midimsg=recordmsg(i).value And auxmsg
     Var canal=recordmsg(i).byte.channel
     If canal=9 Then Continue For 'drums
     Var code=midimsg and 255
     Var code240=code and 240
     if code240<>144 and code240<>128 then Continue For'noteon noteoff
     Var velo=(midimsg Shr 16)And 255
     Var note=(midimsg Shr 8)And 255
     'Var note=int((midimsg-velo*256*256)/256)
   If irecord2>nrecord-500 Then Exit For 
   If timerec>timeaccord+0.1 Then'And code240=144 And velo>1 Then
   	timeaccord=timerec
   	For j=1 To 100
   		If noteaccord2(j)>0 Then
   			'noteoffmsg.byte2=noteaccord2(j)
            noteoffmsg.value=128+canalout+noteaccord2(j)*256+0*256*256
   			irecord2+=1
   			recordtime2(irecord2)=timerec2-0.105
   			recordmsg2(irecord2)=noteoffmsg
   		EndIf
   	Next
   	For j=1 To 100
   		noteaccord2(j)=noteaccord(j)
   	Next
   	For j=1 To 100
   		If noteaccord(j)>0 Then
   			'noteonmsg.byte2=noteaccord(j)
            noteonmsg.value=144+canalout+noteaccord(j)*256+veloout*256*256
   			irecord2+=1
   			recordtime2(irecord2)=timerec2
   			recordmsg2(irecord2)=noteonmsg
   		EndIf
   	Next
   	timerec2+=0.5*min2(6,max2(1,Int((timerec-timerec0)*2)))
   	timerec0=timerec
   	If tlink=0 Then 
   	   resetaccord()
   	Else    	
   		resetaccordtest()
   	EndIf
      If code240=128 Or (code240=144 And velo<0.1) Then
      	removeaccord(note)
      ElseIf code240=144 Then
   	   addaccord(note)
      EndIf
   Else 
      If code240=128 Or (code240=144 And velo<0.1) Then
      	removeaccord(note)
      ElseIf code240=144 Then
      	timeaccord=min(timerec,timeaccord+2)
      	addaccord(note)
      EndIf
   EndIf
Next
If irecord2<nrecord-300 Then
   	timerec2+=0.5
   	For j=1 To 100
   		If noteaccord2(j)>0 Then
   			'noteoffmsg.byte2=noteaccord2(j)
            noteoffmsg.value=128+canalout+noteaccord2(j)*256+0*256*256
   			irecord2+=1
   			recordtime2(irecord2)=timerec2-0.105
   			recordmsg2(irecord2)=noteoffmsg
   		EndIf
   	Next	
   	For j=1 To 100
   		noteaccord2(j)=noteaccord(j)
   	Next
   	For j=1 To 100
   		If noteaccord(j)>0 Then
   			'noteonmsg.byte2=noteaccord(j)
            noteonmsg.value=144+canalout+noteaccord(j)*256+veloout*256*256
   			irecord2+=1
   			recordtime2(irecord2)=timerec2
   			recordmsg2(irecord2)=noteonmsg
   		EndIf
   	Next
   	timerec2+=0.5
   	For j=1 To 100
   		If noteaccord2(j)>0 Then
   			'noteoffmsg.byte2=noteaccord2(j)
            noteoffmsg.value=128+canalout+noteaccord2(j)*256+0*256*256
   			irecord2+=1
   			recordtime2(irecord2)=timerec2-0.05
   			recordmsg2(irecord2)=noteoffmsg
   		EndIf
   	Next	
EndIf
'guinotice Str(recordmsg(1).byte2)
guinotice "irecord2="+Str(irecord2)+"  "+Str(recordtime2(irecord2)-recordtime2(0))
irecord=min2(irecord2,nrecord)
For i=0 To irecord
	recordtime(i)=recordtime2(i)
	recordmsg(i)=recordmsg2(i)	
Next
End Sub
Sub loadmyrecord()
Dim As Integer i,j,k 
If myirecordall<1 Then
	guinotice "no midirec data !"
   timedrawnote=Timer 	
	Exit Sub
EndIf
	   'subreset()
		'disablegui("win.loadmidi")
		'loadmidi(fic)
		'enablegui("win.loadmidi")
		'iundo2=iundo
'importmidi(fic)
irecord=myirecordall
recordtime(0)=0
For i=1 To irecord
	recordtime(i)=myrecordtimeall(i)
	recordmsg(i)=myrecordmsgall(i)
Next
guiconfirm("quantize midi ?","confirm",resp)
If resp="yes" Then
   subquantizerec()	
EndIf
'guinotice "myirecord = "+Str(myirecordall)
'Sleep 500
'subiduree0() 'test align
'subiduree1() 'test align
Var tlink0=tlink
'If tlink=0 And autot100=1 Then tlink=1 
Var iinote00=iinote
Var iinote200=iinote2
Var ii=0,nn=40
If iinote<>iinote2 Or autot100=0 Then
	If autot100=1 Then guiconfirm("warning : auto works only at end of song","confirm",resp)
	nn=1
EndIf
Var nerror0=0'999999
Var tauto=170,tok=0
For ii=1 To nn
 iinote=iinote00
 iinote2=iinote200
 If iinote=iinote2 And autot100=1 Then subresetgo()
 timerec0=recordtime(0)
 timerec=timerec0
 Var auxmsg=256*256*256-1
 timport=1
 resetnoteon()
 Var avgvelo=100.0
 nerror=0
 For i=1 To irecord
     Var midimsg=recordmsg(i).value And auxmsg
     Var canal=recordmsg(i).byte.channel
     If canal=9 Then Continue For 'drums
     Var code=midimsg and 255
     Var code240=code and 240
     if code240=144 or code240=128 then 'noteon noteoff
        Var velo=int(midimsg/(256*256))
        If velo>0 And velo<minvelo Then Continue for
        Var note=int((midimsg-velo*256*256)/256)
        If velo>1 And code240=144 Then avgvelo+=(velo-avgvelo)*0.03
        If (code240=144 And velo=0) Or code240=128 Then
        	  noteon(note)=0'max2(0,noteon(note)-1)
        ElseIf code240=144 Then'And velo>=minvelo*avgvelo/100.0 Then
        	  noteon(note)=1+tlink'2'max2(1,noteon(note)+1)
        	  If tlink=0 And autot100=1 Then noteon(note)=4'2'8
        	  'timenoteon(note)=recordtime(i)*t100*0.01
        EndIf
     	  If code240<>144 And code240<>128 Then Continue For 
        If code240=144 And velo>0 Then 
        	  If nn=1 Then
        	  	 timenoteon(note)=recordtime(i)+(t100*0.01-1)*7
        	  Else 	 
        	  	 timenoteon(note)=recordtime(i)+(tauto*0.01-1)*7
        	  EndIf
        	  velorec=velo
           addrecord(recordtime(i),note)'insert , use reset to erase
        EndIf
     EndIf
 Next
 'guinotice Str(nerror)+" / "+Str(tauto)
 If tok=1 Then
 	Exit For 
 ElseIf nerror<nerror0 And nerror<0.1 Then'irecord/25 Then
 	tok=1:tauto-=1
 	'If tlink=0 And autot100=1 Then Exit For 
 ElseIf nerror>irecord/25 Then
 	tauto+=1
 	If tauto>290 Then Exit For 
 Else
 	tauto-=3
 	If tauto<10 Then Exit For 
 EndIf
 nerror0=nerror
Next ii
tlink=tlink0
If nn=1 Then
	guinotice "nskip="+Str(nerror)+"  Tauto="+Str(t100)
Else 	
	guinotice "nskip="+Str(nerror)+"  Tauto="+Str(tauto)
	printgui("win.autot100","auto "+Str(tauto)+"   ")
EndIf
timport=0
iundo2=iundo
End Sub
Dim Shared As Integer ifolderrecord 
Dim Shared As midimessage folderrecordmsg(nrecord)
Dim Shared As Double folderrecordtime(nrecord)
Sub importmidifolder(fic As String)
Dim As Integer i,j,k
Var folder=Left(fic,max2(InStrRev(fic,"\"),InStrRev(fic,"/")))
guinotice "folder="+folder
Var fici=Dir(folder+"*.mid")
'guinotice fici
ifolderrecord=0
For i=1 To 99
	If fici="" Then Exit For 
   importmidi(folder+fici)
   If irecord>0 Then
   	Var tt=folderrecordtime(ifolderrecord)
   	For j=1 To irecord
   		If ifolderrecord>=nrecord-1 Then Exit For,For 
   		ifolderrecord+=1
   		folderrecordmsg(ifolderrecord)=recordmsg(j)
   		folderrecordtime(ifolderrecord)=tt+recordtime(j)-recordtime(0)
   	Next
   EndIf
   fici=Dir()
Next
guinotice Str(i)+" files"
For i=1 To ifolderrecord
	recordmsg(i)=folderrecordmsg(i)
	recordtime(i)=folderrecordtime(i)
Next
irecord=ifolderrecord 
guinotice "time= "+Str(recordtime(0))+"  "+Str(recordtime(irecord))
End Sub
Sub loadmidi(fic As String,tfolder As Integer=0)
Dim As Integer i,j,k 
If tfolder=0 Then 
   importmidi(fic)
Else
	importmidifolder(fic)
EndIf   
guinotice "irecord = "+Str(irecord)
If irecord<1 Then
	guinotice "no midi data !"
   timedrawnote=Timer 	
	Exit Sub
EndIf
Var i2000=1000
guiconfirm("no quantize midi ?","confirm",resp)
If resp<>"yes" Then
   subquantizerec()
   'i2000=999999	
EndIf
If iinote<>iinote2 Or autot100=0 Or tfolder=1 Or 1 Then
	i2000=999999
EndIf
Var tlink0=tlink
'If tlink=0 And autot100=1 Then tlink=1 
Var irecord0=irecord,iiloop=0
Var nnall=1+Int(irecord/(i2000-100))
Var i0=0,iirecord=irecord,iiaskexit=0
'guinotice Str(i2000)+" "+Str(irecord)
For iiloop=1 To nnall
'guinotice Str(i0)+" "+Str(iiaskexit)+" "+Str(iinote)
If iiloop>1 Then i0+=i2000
If iiaskexit>1 Then i0=iiaskexit
If i0>irecord Then Exit For 
iirecord=i0+i2000-1
If iirecord>irecord Then iirecord=irecord 	
Var iinote00=iinote
Var iinote200=iinote2
Var ii=0,nn=40
If iinote<>iinote2 Or autot100=0 Then
	If autot100=1 Then guiconfirm("warning : auto works only at end of song","confirm",resp)
	nn=1
EndIf
Var nerror0=0'999999
Var tauto=170,tok=0
iiaskexit=0
Var iaskexit=0
For ii=1 To nn
 iinote=iinote00
 iinote2=iinote200
 If iinote=iinote2 And autot100=1 Then subresetgo()
 timerec0=recordtime(i0)
 timerec=timerec0
 Var auxmsg=256*256*256-1
 timport=1
 resetnoteon()
 Var avgvelo=100.0
 iaskexit=0
 nerror=0
 For i=i0+1 To iirecord
     Var midimsg=recordmsg(i).value And auxmsg
     Var canal=recordmsg(i).byte.channel
     If canal=9 Then Continue For 'drums
     Var code=midimsg and 255
     Var code240=code and 240
     if code240=144 or code240=128 then 'noteon noteoff
        Var velo=int(midimsg/(256*256))
        If velo>0 And velo<minvelo Then Continue for
        Var note=int((midimsg-velo*256*256)/256)
        If velo>1 And code240=144 Then avgvelo+=(velo-avgvelo)*0.03
        If (code240=144 And velo=0) Or code240=128 Then
        	  noteon(note)=0'max2(0,noteon(note)-1)
        	  If i>iirecord-100 And i2000<99999 And i0<(irecord-i2000) Then
        	  	  If recordtime(i)>recordtime(i-1)+0.23 Then
        	  	  	  iaskexit=i-1
        	  	  	  Exit For 
        	  	  EndIf
        	  EndIf
        ElseIf code240=144 Then'And velo>=minvelo*avgvelo/100.0 Then
        	  noteon(note)=1+tlink'2'max2(1,noteon(note)+1)
        	  If tlink=0 And autot100=1 Then noteon(note)=4'2'8
        	  'timenoteon(note)=recordtime(i)*t100*0.01
        EndIf
     	  If code240<>144 And code240<>128 Then Continue For 
        If code240=144 And velo>0 Then 
        	  If nn=1 Then
        	  	 timenoteon(note)=recordtime(i)+(t100*0.01-1)*7
        	  Else 	 
        	  	 timenoteon(note)=recordtime(i)+(tauto*0.01-1)*7
        	  EndIf
        	  velorec=velo
        	  'testremovenote(recordtime(i))
           addrecord(recordtime(i),note)'insert , use reset to erase
        	  'testremovenote(recordtime(i))
        EndIf
     EndIf
 Next
 timport=0
 iinote2=iinote
 iinote1=0
 'guinotice Str(nerror)+" / "+Str(tauto)
 If tok=1 Then
 	Exit For 
 ElseIf nerror<nerror0 And nerror<0.1 Then'irecord/25 Then
 	tok=1:tauto-=1
 	'If tlink=0 And autot100=1 Then Exit For 
 ElseIf nerror>(iirecord-i0)/25 Then'irecord/25 Then
 	tauto+=1
 	If tauto>290 Then Exit For 
 Else
 	tauto-=3
 	If tauto<10 Then Exit For 
 EndIf
 nerror0=nerror
Next ii
If iaskexit>1 Then iiaskexit=iaskexit 
If nn=1 And iirecord>=irecord Then
	guinotice "nskip="+Str(nerror)+"  Tauto="+Str(t100)
ElseIf iirecord>=irecord Then'Or iiaskexit>1 Then  	
	guinotice "nskip="+Str(nerror)+"  Tauto="+Str(tauto)
	printgui("win.autot100","auto "+Str(tauto)+"   ")
EndIf
'guinotice Str(iinote)
Next iiloop
Var test=0
For i=1 To iinote
	If testalign(i)=1 Then test=1:Exit For 
Next
If test=1 Then 
 guiconfirm("align ?","confirm",resp)
 If resp="yes" Then  
  'auxvar4=0
  For i=1 To iinote
	 If testshortalign(i)=1 Then 
	   'auxvar4+=1
	   'Exit For
    EndIf 	  
  Next
 EndIf  
EndIf 
tlink=tlink0
End Sub
Sub subloadmidi
Dim As String fic,dir0
Dim As Integer ret 
dir0=CurDir
Var dir1=ExePath+"\midi\"  
If FileExists(ficload) And Right(ficload,4)=".mid" Then
   dir1=Left(ficload,InStrRev(ficload,"\"))
EndIf    
ChDir(dir1)   
fic=filedialog("load midi",dir1+"*.mid")
'fic=filedialog("load midi",ExePath+"\midi\"+"*.mid")
fic=Trim(fic)
ret=ChDir(dir0)
'ficload=""
If fic="" Then Exit Sub
If Right(fic,4)=".mid" Then
	'If LCase(Left(fic,Len(ExePath)))=LCase(ExePath) Then
	'	fic=Right(fic,Len(fic)-Len(ExePath)-1)
	'EndIf
	'guiconfirm("savemidi as "+fic+" ?","confirm",resp)
	If FileExists(fic) Then'resp="yes" Then
	   Var tfolder=0
	   guiconfirm("loadmidi "+fic+" ? (no=>folder)","confirm",resp)
	   If resp<>"yes" Then
   	   guiconfirm("loadmidi folder ?","confirm",resp)
   	   If resp<>"yes" Then Exit Sub 
   	   tfolder=1
	   EndIf
	   subreset()
		disablegui("win.loadmidi") 
	   loadmidi(fic,tfolder)
		enablegui("win.loadmidi")
		iundo2=iundo
		If quit=0 Then
			'ficload=fic
			guinotice fic+" loaded !"
			ficload=fic
		Else
			'ficload=""
		EndIf
	Else
		guinotice fic+" not found !"
	EndIf 	
EndIf
ret=ChDir(dir0)
guisetfocus("win.graph")
Sleep 300
timedrawnote=Timer 	
guiscan
End Sub
Sub subsaveasmidi
Dim As String fic,dir0
Dim As Integer ret 
dir0=CurDir
ChDir(ExePath+"\midi\")  
fic=filedialog("save as midi",ExePath+"\midi\"+"*.mid")
fic=Trim(fic)
ret=ChDir(dir0)
'ficload=""
If fic="" Then Exit sub
If InStr(fic,".")<1 Then fic=fic+".mid"
If Right(fic,4)=".mid" Then
	'If LCase(Left(fic,Len(ExePath)))=LCase(ExePath) Then
	'	fic=Right(fic,Len(fic)-Len(ExePath)-1)
	'EndIf
	guiconfirm("savemidi as "+fic+" ?","confirm",resp)
	If resp="yes" Then
		disablegui("win.saveasmidi")
		saveasmidi(fic)
		enablegui("win.saveasmidi")
		If quit=0 Then
			ficload=fic
			guinotice fic+" saved !"
		Else
			'ficload=""
		EndIf
	EndIf 	
EndIf
ret=ChDir(dir0)
guisetfocus("win.graph")
Sleep 300	
guiscan
End Sub
Sub subsaverec
Dim As String fic,dir0
Dim As Integer ret
If myirecordall<1 Then 
	guinotice "no midi record to save !"
   guisetfocus("win.graph")
	Exit Sub 
Else 
	guiconfirm("save record data as midi ? (lossless)","confirm",resp)
	If resp<>"yes" Then
      guisetfocus("win.graph")
	   Exit Sub 		
	EndIf
EndIf
dir0=CurDir
ChDir(ExePath+"\midi\")  
fic=filedialog("save record as midi",ExePath+"\midi\"+"*.mid")
fic=Trim(fic)
ret=ChDir(dir0)
'ficload=""
If fic="" Then Exit sub
If InStr(fic,".")<1 Then fic=fic+".mid"
If Right(fic,4)=".mid" Then
	'If LCase(Left(fic,Len(ExePath)))=LCase(ExePath) Then
	'	fic=Right(fic,Len(fic)-Len(ExePath)-1)
	'EndIf
	guiconfirm("savemidi as "+fic+" ?","confirm",resp)
	If resp="yes" Then
		disablegui("win.saveasmidi")
		disablegui("win.saverec")
		saverec(fic)
		enablegui("win.saveasmidi")
		enablegui("win.saverec")
		If quit=0 Then
			'ficload=fic
			guinotice fic+" saved !"
		Else
			'ficload=""
		EndIf
	EndIf 	
EndIf
ret=ChDir(dir0)
guisetfocus("win.graph")
Sleep 300	
guiscan
End Sub
Sub save(fic As String)
Dim As Integer i,j,k
file=freefile
Open fic For Output As #file
Print #file,iinote
For i=0 To iinote
   Print #file,iaccord(i)
   For j=1 To iaccord(i)
   	Print #file,note(i,j)
   Next
Next
For i=0 To iinote
   Print #file,liaison(i)
Next 
For i=0 To iinote
   Print #file,duree(i)
Next 
For i=0 To iinote
   Print #file,duree0(i)
Next 
For i=0 To iinote
   For j=1 To iaccord(i)
   	Print #file,notetime(i,j)
   Next
Next
Print #file,iinote2
Print #file,djjnote
For i=0 To iinote
   For j=1 To iaccord(i)
   	Print #file,velonote(i,j)
   Next
Next
Print #file,iinote1
Close #file
End Sub
Sub savecopy(fic As String,ii0 As Integer=0,i1 As Integer=0)
Dim As Integer i,j,k,iiinote,i0
iiinote=i1
If i1=0 Then iiinote=iinote2
i0=ii0
If ii0<=0 Then i0=1
file=freefile
Open fic For Output As #file
Print #file,iiinote-i0+1
For i=i0 To iiinote
   Print #file,iaccord(i)
   For j=1 To iaccord(i)
   	Print #file,note(i,j)
   Next
Next
For i=i0 To iiinote
   Print #file,liaison(i)
Next 
For i=i0 To iiinote
   Print #file,duree(i)
Next 
For i=i0 To iiinote
   Print #file,duree0(i)
Next 
For i=i0 To iiinote
   For j=1 To iaccord(i)
   	Print #file,notetime(i,j)
   Next
Next
'Print #file,iinote2
'Print #file,djjnote
For i=i0 To iiinote
   For j=1 To iaccord(i)
   	Print #file,velonote(i,j)
   Next
Next
Close #file
End Sub
Sub savecut(fic As String,ii0 As Integer=0,i1 As Integer=0)
Dim As Integer i,j,k,iiinote,i0
savecopy(fic,ii0,i1)
iiinote=i1
If i1=0 Then iiinote=iinote2
i0=ii0
If ii0<=0 Then i0=1
      iiinote=iiinote-i0+1
      If iiinote<1 Or iiinote>iinote Then Exit Sub 
   	iinote-=iiinote
   	'If iinote20<=iinote2 Then iinote2+=1
   	'iinote20+=1
   	If i0<=iinote Then
   	   For i=i0 To iinote
   	   	If i>0 Then liaison(i-1)=liaison(i+iiinote-1)
   	   	copyaccord(i,i+iiinote)
   	   	duree(i)=duree(i+iiinote)
   	   	duree0(i)=duree0(i+iiinote)
   	   Next
   	EndIf
   	iinote2=max2(0,i0-1)
   	iinote1=iinote2-1
End Sub
Sub load(fic As String)
Dim As Integer i,j,k 	
file=FreeFile
Open fic For Input As #file
iinote=0
If Not Eof(file) Then Line Input #file,ficin:iinote=Val(ficin)
For i=0 To iinote
	iaccord(i)=0
	If Not Eof(file) Then Line Input #file,ficin:iaccord(i)=Val(ficin)
	For j=1 To iaccord(i)
		note(i,j)=0
		If Not Eof(file) Then Line Input #file,ficin:note(i,j)=Val(ficin)
	Next
Next
For i=0 To iinote
	liaison(i)=0
	If Not Eof(file) Then Line Input #file,ficin:liaison(i)=Val(ficin)
Next 
For i=0 To iinote
	duree(i)=1
	If Not Eof(file) Then Line Input #file,ficin:duree(i)=Val(ficin)
Next 
For i=0 To iinote
	duree0(i)=0.25+duree(i)*0.25
	If Not Eof(file) Then Line Input #file,ficin:duree0(i)=Val(ficin)
Next 
For i=0 To iinote
	For j=1 To iaccord(i)
		notetime(i,j)=0
		If Not Eof(file) Then Line Input #file,ficin:notetime(i,j)=Val(ficin)
	Next
Next
iinote2=iinote
If Not Eof(file) Then Line Input #file,ficin:iinote2=Val(ficin)
djjnote=0
If Not Eof(file) Then Line Input #file,ficin:djjnote=Val(ficin)
For i=0 To iinote
	For j=1 To iaccord(i)
		velonote(i,j)=0
		If Not Eof(file) Then Line Input #file,ficin:velonote(i,j)=Val(ficin)
	Next
Next
iinote1=0
If Not Eof(file) Then Line Input #file,ficin:iinote1=Val(ficin)
Close #file
'iinote2=iinote
'djjnote=03
End Sub
Dim shared As Byte testchord(18000,naccord),auxaccord(naccord)
Dim Shared As Integer ntestchord,iaccordtest(18000),testaccord(18000),iinotetest,kaccordtest(nnote)
Sub savesystestchord
Dim As Integer i,j,k,ii
Var fic="SYS_testchord.txt"
file=freefile
Open fic For Output As #file
Print #file,ntestchord
For i=1 To ntestchord
   Print #file,iaccordtest(i)
   For ii=1 To iaccordtest(i)
       Print #file,testchord(i,ii)   	
   Next
Next
Print #file,iinotetest
For i=1 To iinotetest
   Print #file,kaccordtest(i)
Next  
Close #file
guinotice fic+" saved !"
End Sub  
Sub loadsystestchord
Dim As Integer i,j,k,ii
Var fic="SYS_testchord.txt"
file=freefile
Open fic For Input As #file
ntestchord=0
If Not Eof(file) Then Line Input #file,ficin:ntestchord=Val(ficin)
For i=1 To ntestchord
   iaccordtest(i)=0
   If Not Eof(file) Then Line Input #file,ficin:iaccordtest(i)=Val(ficin)
   For ii=1 To iaccordtest(i)
       testchord(i,ii)=0
       If Not Eof(file) Then Line Input #file,ficin:testchord(i,ii)=Val(ficin)
   Next
Next    
iinotetest=0
If Not Eof(file) Then Line Input #file,ficin:iinotetest=Val(ficin)
For i=1 To iinotetest
   kaccordtest(i)=0
   If Not Eof(file) Then Line Input #file,ficin:kaccordtest(i)=Val(ficin)
Next 
Close #file 
guinotice "ntestchord="+Str(ntestchord)+"/"+Str(iinotetest) 	
End Sub
Sub setsystestchord()
guinotice "set current midiscore as systestchord"
Dim As Integer i,j,k,ii,jj,kk,n
guiconfirm("savesystestchord ? "+Str(iinote),"confirm",resp)
If resp<>"yes" Then Exit Sub 
For i=1 To 18000
	iaccordtest(i)=0
	For j=1 To naccord
   	testchord(i,j)=0
	Next
	testaccord(i)=0
Next
Var i2=2
i2=Int(iinote/3000)'min find
ntestchord=0
For n=0 To 11
For i=1 To iinote
	Var test=0
	For j=1 To ntestchord
		Var testii=0
		If iaccord(i)<>iaccordtest(j) Then Continue For  
		For ii=1 To iaccord(i)
			Var nii=(n+note(i,ii)) Mod 12,testjj=0
			For jj=1 To iaccordtest(j)
				If (testchord(j,jj) Mod 12)=nii Then testjj=1:Exit For 
			Next
			If testjj=0 Then testii=1:Exit For  
		Next
		If testii=0 Then
		   test+=1:If test>i2 Then Exit For
		EndIf       
	Next
	If test<=0+i2 Then 
		ntestchord+=1
		testaccord(ntestchord)=test
		iaccordtest(ntestchord)=iaccord(i)
		For ii=1 To iaccord(i)
			testchord(ntestchord,ii)=n+note(i,ii)
			If testchord(ntestchord,ii)>108 Then testchord(ntestchord,ii)-=12
		Next
		If ntestchord>=18000 Or ntestchord>=iinote Then Exit For 
	EndIf
Next i
If ntestchord>=18000 Then Exit For 
Next n
i=0
For j=1 To ntestchord
	If testaccord(j)>=i2 Then
		i+=1
		iaccordtest(i)=iaccordtest(j)
		For jj=1 To iaccordtest(j)
			testchord(i,jj)=testchord(j,jj)
		Next
		testaccord(i)=testaccord(j)
	EndIf
Next
ntestchord=i
guinotice Str(ntestchord)
iinotetest=iinote
ii=0
For i=1 To iinote
	kaccordtest(i)=0
	For j=1 To ntestchord
		If iaccord(i)<>iaccordtest(j) Then Continue For  
		Var test=0
		For jj=1 To iaccord(i)
			Var test2=0
			For kk=1 To iaccordtest(j) 
   			If ((note(i,jj) Mod 12)=(testchord(j,kk)Mod 12)) Then test2=1:Exit For
			Next kk
			If test2=0 Then test=1:Exit For 
		Next jj
		If test=0 Then
			ii+=1
			kaccordtest(i)=j
			Exit For 
		EndIf 
	Next j
Next i
guinotice "iinotetest="+Str(ii)+"/"+Str(iinotetest)
savesystestchord()	
End Sub
Dim Shared As Integer tinitsystestchord
Sub testsystestchord()
Dim As Integer i,j,k,ii,jj,kk,n,nn,nnj,p,pp,pj,ppp,ppp0
If tinitsystestchord=0 Then
	tinitsystestchord=1
	loadsystestchord()
EndIf
guiconfirm("testsystestchord ? "+Str(iinote),"confirm",resp)
If resp<>"yes" Then Exit Sub
Var jchord=0
Var jchord0=0 
For i=1 To iinote
	Var test=0
	If liaison(i-1)=0 Then jchord0=jchord
	jchord=0
	p=0
	pj=0
	ppp0=9999
	Var testnn=0
	Var testjchord0=0
	For j=1 To ntestchord
		Var testii=0
		pp=0:ppp=0 
		Var testjchord=0
		For ii=1 To iaccord(i)
			Var nii=note(i,ii) Mod 12
			Var testjj=0
			For jj=1 To iaccordtest(j)
				If (testchord(j,jj) Mod 12)=nii Then ppp+=testchord(j,jj)-note(i,ii):testjj=1':Exit For 
			Next
			If testjj=0 Then testii=1 Else pp+=1
		Next
		Var testj=0
		If p<=pp And jchord0>0 Then
			For ii=2 To iinotetest 
				If j=kaccordtest(ii) Then
					If jchord0=kaccordtest(ii-1) Then
						testj=1
						testjchord+=1
						'Exit For 
					EndIf
				EndIf
			Next
			If testj=0 Then pp=max2(1,min2(6,pp-2)) 
		EndIf
	   If p<pp Then
			p=pp:pj=j:ppp0=ppp:testnn=testj:testjchord0=testjchord
	   ElseIf p=pp And pp>0 Then
			If testjchord0<testjchord And iaccordtest(j)<=iaccordtest(pj) Then
				p=pp:pj=j:ppp0=ppp:testjchord0=testjchord:nnj+=1
			ElseIf iaccordtest(j)<iaccordtest(pj) Then
				p=pp:pj=j:ppp0=ppp:testjchord0=testjchord
			ElseIf Abs(ppp0)>Abs(ppp) Then
				p=pp:pj=j:ppp0=ppp:testjchord0=testjchord
			EndIf
	   EndIf  
	   auxvar=nnj
	   auxvar2=testjchord0
		If testii=0 Then test=1:Exit For    
	Next
	If iinotetest>0 Then jchord=pj
	If test=0 And pj>0 Then 
		n+=1
		If jchord0>0 And testnn=1 Then nn+=1
		Var iaccordi=0
		For ii=1 To iaccord(i)
			Var testjj=0
			Var nii=note(i,ii) Mod 12
			For jj=1 To iaccordtest(pj)
				If nii=(testchord(pj,jj) Mod 12) Then 
					iaccordi+=1
      			note(i,iaccordi)=note(i,ii)
		      	velonote(i,iaccordi)=velonote(i,ii)
			      notetime(i,iaccordi)=notetime(i,ii)
			      Exit For 					
				EndIf
			Next jj
		Next ii
		iaccord(i)=iaccordi
		For jj=1 To iaccordtest(pj)
			If iaccordi>=naccord Then Exit For
			Var testii=0
			Var njj=testchord(pj,jj) Mod 12
			For ii=1 To iaccordi 
				If njj=(note(i,ii) Mod 12) Then testii=1:Exit For 
			Next
			If testii=0 Then
				iaccordi+=1
     			note(i,iaccordi)=testchord(pj,jj)
	      	velonote(i,iaccordi)=velonote(i,1)
		      notetime(i,iaccordi)=0				
			EndIf
		Next jj
		iaccord(i)=iaccordi
		/'iaccord(i)=iaccordtest(pj)
		For ii=1 To iaccord(i)
			note(i,ii)=testchord(pj,ii)
			velonote(i,ii)=velonote(i,1)
			notetime(i,ii)=0
		Next'/ 
	EndIf
Next
guinotice "changed="+Str(n)+"/"+Str(nn)+" / "+Str(ntestchord)	
End Sub
Sub loadcopy(fic As String)
Dim As Integer i,j,k,iiinote,i0
file=FreeFile
Open fic For Input As #file
iiinote=0
If Not Eof(file) Then Line Input #file,ficin:iiinote=Val(ficin)
Close #file
If iiinote<1 Then Exit Sub 
   Var iinote20=iinote2+iiinote  
   If iinote20>1 And iinote20<nnote And iinote+iiinote<nnote  Then
   	iinote+=iiinote
   	'If iinote20<=iinote2 Then iinote2+=1
   	'iinote20+=1
   	If iinote20<iinote Then
   	   For i=iinote To iinote20+1 Step -1
   	   	liaison(i-1)=liaison(i-iiinote-1)
   	   	copyaccord(i,i-iiinote)
   	   	duree(i)=duree(i-iiinote)
   	   	duree0(i)=duree0(i-iiinote)
   	   Next
   	EndIf 	
   EndIf 	
file=FreeFile
Open fic For Input As #file
iiinote=0
If Not Eof(file) Then Line Input #file,ficin:iiinote=Val(ficin)
iiinote=iinote2+iiinote
i0=iinote2+1
For i=i0 To iiinote
	iaccord(i)=0
	If Not Eof(file) Then Line Input #file,ficin:iaccord(i)=Val(ficin)
	For j=1 To iaccord(i)
		note(i,j)=0
		If Not Eof(file) Then Line Input #file,ficin:note(i,j)=Val(ficin)
	Next
Next
For i=i0 To iiinote
	liaison(i)=0
	If Not Eof(file) Then Line Input #file,ficin:liaison(i)=Val(ficin)
Next 
For i=i0 To iiinote
	duree(i)=1
	If Not Eof(file) Then Line Input #file,ficin:duree(i)=Val(ficin)
Next 
For i=i0 To iiinote
	duree0(i)=0.25+duree(i)*0.25
	If Not Eof(file) Then Line Input #file,ficin:duree0(i)=Val(ficin)
Next 
For i=i0 To iiinote
	For j=1 To iaccord(i)
		notetime(i,j)=0
		If Not Eof(file) Then Line Input #file,ficin:notetime(i,j)=Val(ficin)
	Next
Next
iinote2=iiinote
'If Not Eof(file) Then Line Input #file,ficin:iinote2=Val(ficin)
'djjnote=0
'If Not Eof(file) Then Line Input #file,ficin:djjnote=Val(ficin)
For i=i0 To iiinote
	For j=1 To iaccord(i)
		velonote(i,j)=0
		If Not Eof(file) Then Line Input #file,ficin:velonote(i,j)=Val(ficin)
	Next
Next
Close #file
'iinote2=iinote
'djjnote=0
End Sub
Sub mysublink()
Dim As Integer i,j,k
'guinotice Str(iinote1)+"  "+Str(iinote2)
For i=iinote1 To iinote2-2
	If liaison(i)=0 Then 
	  Var test=compareaccord(i+1,i)
	  If test=1 Or (test=2 And liaison(i+1)=0) Then
   	  Var test2=compareaccord(i+2,i)
   	  If test2=0 Then Continue For 
	  	  If test=2 And liaison(i+1)=0 Then
	  	     copyaccordnote(i,i+1)
	  	     'For k=i+1 To min2(iinote2-1,i+10)
	  	     '	   If liaison(k)<>1 Then Exit For 
	  	     '	   copyaccordnote(i,k+1)
	  	     'Next
	  	  EndIf 
	  	  liaison(i)=1
	  	  i+=1
	  	  j+=1
	  EndIf
	EndIf
Next
myttsspeak(Str(j)+" links added")
guinotice Str(j)+" links added"
End Sub
Sub subsave
Dim As String fic,dir0
Dim As Integer ret 
dir0=CurDir
ChDir(ExePath+"\save\")  
fic=filedialog("save",ExePath+"\save\"+"*.midiscore")
fic=Trim(fic)
ret=ChDir(dir0)
'ficload=""
If fic="" Then Exit sub
If InStr(fic,".")<1 Then fic=fic+".midiscore"
If Right(fic,10)=".midiscore" Then
	'If LCase(Left(fic,Len(ExePath)))=LCase(ExePath) Then
	'	fic=Right(fic,Len(fic)-Len(ExePath)-1)
	'EndIf
	guiconfirm("save as "+fic+" ?","confirm",resp)
	If resp="yes" Then
		disablegui("win.save")
		save(fic)
		enablegui("win.save")
		If quit=0 Then
			ficload=fic
			guinotice fic+" saved !"
		Else
			'ficload=""
		EndIf
	EndIf 	
EndIf
ret=ChDir(dir0)
guisetfocus("win.graph")
Sleep 300	
End Sub
Sub subload
Dim As String fic,dir0
Dim As Integer ret,i 
dir0=CurDir
ChDir(ExePath+"\save\")  
fic=filedialog("load",ExePath+"\save\"+"*.midiscore")
fic=Trim(fic)
ret=ChDir(dir0)
'ficload=""
If Right(fic,10)=".midiscore" Then
	If LCase(Left(fic,Len(ExePath)))=LCase(ExePath) Then
		fic=Right(fic,Len(fic)-Len(ExePath)-1)
	EndIf
	If FileExists(fic) Then
		disablegui("win.load")
		load(fic)
      iinote2=iinote
      djjnote=0
		enablegui("win.load")
		iundo2=iundo
		'auxvar=Timer-time1
		If quit=0 Then
			'ficload=fic
			guinotice fic+" loaded !"
			ficload=fic
			For i=1 To 8+2
				drawnotes()
			Next
		Else
			'ficload=""
		EndIf
	Else
		guinotice fic+" not found !"
	EndIf
   timedrawnote=timer
EndIf
ret=ChDir(dir0)
guisetfocus("win.graph")
Sleep 300
End Sub
Sub savetxt(fic As String)
	saveasmidinoquant(fic,1)
End Sub
Sub subsavetxt
Dim As String fic,dir0
Dim As Integer ret 
dir0=CurDir
ChDir(ExePath+"\save\")  
fic=filedialog("save txt",ExePath+"\txt\"+"*.txt")
fic=Trim(fic)
ret=ChDir(dir0)
'ficload=""
If fic="" Then Exit sub
If InStr(fic,".")<1 Then fic=fic+".txt"
If Right(fic,4)=".txt" Then
	'If LCase(Left(fic,Len(ExePath)))=LCase(ExePath) Then
	'	fic=Right(fic,Len(fic)-Len(ExePath)-1)
	'EndIf
	guiconfirm("savetxt as "+fic+" ?","confirm",resp)
	If resp="yes" Then
		disablegui("win.savetxt")
		savetxt(fic)
		enablegui("win.savetxt")
		If quit=0 Then
			'ficload=fic
			guinotice fic+" saved !"
		Else
			'ficload=""
		EndIf
	EndIf 	
EndIf
ret=ChDir(dir0)
guisetfocus("win.graph")
Sleep 300	
End Sub
Sub subhelp()
Var msg="edit incoming notes on score like screen from the choozen midi input port"+crlf+crlf
msg+="midikeys (piano)"+crlf+crlf
msg+="key 96  (do,C) => back chord (delete)            / arrow down, delete back"+crlf+crlf
msg+="key 96+2 (r)  => add next chord (insert)        / arrow up"+crlf+crlf
msg+="key 96+1  (do#) => play notes short           / return"+crlf+crlf
msg+="key 96+3  (r#) => play notes "+crlf+crlf
'msg+="key 96+3  (r#) => record realtime ( other key>=96 => stop record )"+crlf+crlf
msg+="key 96+4  (mi)  => edit prev chord          / pagedown , left (+shift)"+crlf+crlf
msg+="key 96+5  (fa)  => edit next chord          / pageup , right (+shift)"+crlf+crlf
msg+="key 96+6  (fa#) => short notes ( dt0 )            "+crlf+crlf
msg+="key 96+7  (sol) => long notes  ( dt1 )            "+crlf+crlf
msg+="+ pc keyboard arrow + shift,ctrl "+crlf+crlf
msg+="other keys < 96 => sets current chord 	"+crlf+crlf
msg+="link0 nomute "+crlf
msg+="link1 mute same notes as -1 pos if not all same"+crlf
msg+="link2 mute same notes as -2 pos"+crlf
msg+="link3 mute same notes as -3 pos"+crlf+crlf
msg+="goto or mouse click on score while playing => jump to pos"+crlf+crlf
msg+="P => play  /  R => record   /  Z => zoom  / K => keypiano"+crlf+crlf
msg+="Space / double space / S => sustain update"+crlf+crlf
msg+="I/O  AQ,ZW,E,R => octave down,up"+crlf+crlf
msg+="if pc keyboard as midi is activated , press [CTRL]+key to bypass"+crlf 
guinotice msg
End Sub
'Const As String   abc="1234567890azertyuiopqsdfghjklwxcvbn"
'Const As String abcqw="1234567890qwertyuiopasdfghjklzxcvbn"
Const As String abcaz="1!2!34!5!6!78!9!0a!z!e!rt!y!ui!o!p!qs!d!fg!h!j!kl!w!xc!v!b!nm"
Const As String abcqw="1!2!34!5!6!78!9!0q!w!e!rt!y!ui!o!p!as!d!fg!h!j!kl!z!xc!v!b!nm"
Dim Shared As String abc
Function getpianokey(cc As String,tshift As Integer=0)As Integer
If abc="" Then
	abc=abcaz
	If FileExists("qwerty.txt") Then abc=abcqw
EndIf
If cc="!" Then Return 0
Var c1=60-12-12
Var i=InStr(abc,cc)
If i>0 Then
	If tshift=0 Then Return i-1+c1
	If Mid(abc,i+1,1)="!" Then Return i+c1
EndIf
Return 0
End Function
Dim shared As Integer nmidikey,midikey(256),midikeynote(256),tmidikeyon(256),asctovk(256)
Dim Shared As Integer nmidikey1,midikey1(256),midikeynote1(256),tmidikeyon1(256)
Sub initmidikey()
Dim As Integer i,j,k
Dim As String cc  
asctovk(Asc("1"))=vk_1
asctovk(Asc("2"))=vk_2
asctovk(Asc("3"))=vk_3
asctovk(Asc("4"))=vk_4
asctovk(Asc("5"))=vk_5
asctovk(Asc("6"))=vk_6
asctovk(Asc("7"))=vk_7
asctovk(Asc("8"))=vk_8
asctovk(Asc("9"))=vk_9
asctovk(Asc("0"))=vk_0
asctovk(Asc("a"))=vk_a
asctovk(Asc("b"))=vk_b
asctovk(Asc("c"))=vk_c
asctovk(Asc("d"))=vk_d
asctovk(Asc("e"))=vk_e
asctovk(Asc("f"))=vk_f
asctovk(Asc("g"))=vk_g
asctovk(Asc("h"))=vk_h
asctovk(Asc("i"))=vk_i
asctovk(Asc("j"))=vk_j
asctovk(Asc("k"))=vk_k
asctovk(Asc("l"))=vk_l
asctovk(Asc("m"))=vk_m
asctovk(Asc("n"))=vk_n
asctovk(Asc("o"))=vk_o
asctovk(Asc("p"))=vk_p
asctovk(Asc("q"))=vk_q
asctovk(Asc("r"))=vk_r
asctovk(Asc("s"))=vk_s
asctovk(Asc("t"))=vk_t
asctovk(Asc("u"))=vk_u
asctovk(Asc("v"))=vk_v
asctovk(Asc("w"))=vk_w
asctovk(Asc("x"))=vk_x
asctovk(Asc("y"))=vk_y
asctovk(Asc("z"))=vk_z
asctovk(Asc("a"))=vk_q
asctovk(Asc("z"))=vk_w
asctovk(Asc("e"))=vk_e
asctovk(Asc("r"))=vk_r
asctovk(Asc("t"))=vk_t
asctovk(Asc("y"))=vk_y
asctovk(Asc("q"))=vk_a
asctovk(Asc("w"))=vk_z
asctovk(Asc("e"))=vk_e
asctovk(Asc("r"))=vk_r
asctovk(Asc("t"))=vk_t
asctovk(Asc("y"))=vk_y
nmidikey=0
For i=1 To Len(abcaz)
	cc=Mid(abcaz,i,1)
	j=getpianokey(cc,0)
	If j>0 Then
		nmidikey+=1
		midikey(nmidikey)=asctovk(Asc(cc))
		midikeynote(nmidikey)=j
	EndIf
Next
nmidikey1=0
For i=1 To Len(abcaz)
	cc=Mid(abcaz,i,1)
	j=getpianokey(cc,1)
	If j>0 Then
		nmidikey1+=1
		midikey1(nmidikey1)=asctovk(Asc(cc))
		midikeynote1(nmidikey1)=j
	EndIf
Next
'guinotice "nmidikey= "+Str(nmidikey)+" "+Str(nmidikey1)
End Sub
Dim Shared As Integer tshift0
Sub testmidikeyboard()
Dim As Integer i,j,k 
If tkeyboard=0 Or guitestkey(vk_control) Then Exit Sub 
If guitestkey(vk_shift)=0 Then 
  For i=1 To nmidikey
	   If guitestkey(midikey(i))Then
	   	If tmidikeyon(i)=0 Then
	   		drawnote(midikeynote(i))
   	   	tmidikeyon(i)=1
   	   	If midikeynote(i)<c96 Then playnote(midikeynote(i))
   	   EndIf 	
	   Else	
	   	tmidikeyon(i)=0
	   EndIf
  Next
  If tshift0=1 Then
     tshift0=0
	  For i=1 To nmidikey1
   	 tmidikeyon1(i)=0
	  Next
  EndIf
Else
  For i=1 To nmidikey1
	   If guitestkey(midikey1(i))Then
	   	If tmidikeyon1(i)=0 Then
	   		drawnote(midikeynote1(i))
   	   	tmidikeyon1(i)=1
   	   	If midikeynote1(i)<c96 Then playnote(midikeynote1(i))
	   	EndIf 	
	   Else	
	   	tmidikeyon1(i)=0
	   EndIf
  Next
  If tshift0=0 Then
     tshift0=1
	  For i=1 To nmidikey
   	 tmidikeyon(i)=0
	  Next
  EndIf
EndIf   
End Sub
Dim Shared As Single xmax2,ymax2
Dim Shared As Single cursorx,cursory,cursorz
Sub glplacecursor(ByVal x As Single,ByVal y As Single,ByVal z As Single=-40)
   glLoadIdentity()
   cursorx=(-0.31+23.7*(-1+2*x/xmax)*(xmax/ymax)*(520/700))
   cursory=-0.25+17.1*(1-2*y/ymax)
   cursorz=z
   glTranslatef (cursorx,cursory,cursorz)
End Sub 
Sub gldrawtext0(ByRef text As String,ByVal x As Single,ByVal y As Single,ByVal scale As Single=1.0)
   glLoadIdentity()
   gldisable(gl_texture_2d)
   'glTranslatef (22*(-1+2*x/xmax)*(xmax/ymax)*(520/700),17*(1-2*y/ymax),-38)
   glTranslatef ((-0.31+23.7*(-1+2*x/xmax)*(xmax/ymax)*(520/700)),-0.25+17.1*(1-2*y/ymax),-40)
   glscalef(scale,scale,scale)
   guigltext(text)
End Sub 
Sub gldrawtext(ByRef text As String,ByVal x As Single,ByVal y As Single,ByVal scale As Single=1.0)
   glLoadIdentity()
   glenable(gl_texture_2d)
   glbindtexture(gl_texture_2d,myguifont256text)
   'glTranslatef (22*(-1+2*x/xmax)*(xmax/ymax)*(520/700),17*(1-2*y/ymax),-38)
   glTranslatef ((-0.31+23.7*(-1+2*x/xmax)*(xmax/ymax)*(520/700)),-0.25+17.1*(1-2*y/ymax),-40)
   glscalef(scale*1.1,scale,scale)
   'glscalef(scale,scale,scale)
   myguigltext(text)
   gldisable(gl_texture_2d)
End Sub
Sub gldrawtext3D(ByRef text As String,ByVal scale As Single=5.0)
    glbindtexture(gl_texture_2d,myguifont256text)
    glpushmatrix
    glrotatef(90,0,0,1)
    glrotatef(90,1,0,0)
    glscalef(scale,scale,scale)
    myguigltext(text)
    glpopmatrix	
End Sub
Dim Shared As double time0,time1,time2,time3,nframe,fps=9,kfps=1,kfps2,dtime2,maxfps=100,kfps4,tfps,fpsmoy
Dim Shared As double tfps2=0.01
Sub setfps()
           	time3=time2
           	time2=Timer
           	dtime2=1.0/max(10.0,min(200.0,maxfps))-0.0015
           	'If time2<(time3+25) Then Sleep (time3+30-time2)'20'30
           	If time2<(time3+dtime2) Then
           		If time2<time3 Then time2=time3 'if midnight
           		Sleep Int((time3+dtime2+0.001-time2)*1000)'20'30
           	   time2=time3+dtime2+0.001
           	EndIf
           	If (time2-time3)<0.2 Then
           		tfps2=0.85*tfps2+0.15*min(1.0,(time2-time3))
           	Else 	
           		tfps2=0.2*tfps2+0.8*min(2.0,(time2-time3))
           	EndIf
           	fps=1.0/max(0.001,tfps2)
           	kfps=min(10.0,30/fps)
           	'kfps2=min(2.0,25/fps)
           	kfps2=max(0.1,min(2.0,25*(time2-time3)))
           	kfps4=min(1.0,kfps/2.5) 
           	If fps<3 Then
           		fpsmoy+=(fps-fpsmoy)*0.8
           	ElseIf fps<5 Then
           		fpsmoy+=(fps-fpsmoy)*0.4
           	ElseIf fps<10 Then
           		fpsmoy+=(fps-fpsmoy)*0.2
           	Else 
           		fpsmoy+=(fps-fpsmoy)*0.1		
           	EndIf
End Sub
Dim Shared As uint keypianotext,whitetext
Sub initgl	
	glMatrixMode GL_PROJECTION
	glLoadIdentity
	'              anglevue    xmax/ymax   mxmin,mxmax
	'gluPerspective   47.0,     xmax*1.0/ymax,  1.0, 20000.0
	'gluPerspective   48.0,    xmax/ymax,  2.0, gldistmax*25
	'gluPerspective   48.0,    xmax/ymax,  1.0, 20000.0
	gluPerspective   48.0,    xmax/ymax,  0.2, 4000.0
	glMatrixMode GL_MODELVIEW
	glLoadIdentity
	
	'subprojection(1)
	
	glShadeModel GL_SMOOTH
	glClearColor 0.5, 0.5, 1.0, 1.0
	
	gldisable gl_lighting
	'glenable gl_lighting
	glenable gl_light0
	glenable gl_normalize
	
   glEnable GL_COLOR_MATERIAL
   glColorMaterial GL_FRONT_and_back,GL_DIFFUSE
   'glcolormaterial GL_FRONT_AND_BACK,GL_AMBIENT_AND_DIFFUSE

	glClearDepth 1.0
	glEnable GL_DEPTH_TEST
	glDepthFunc GL_LEQUAL
	glHint GL_PERSPECTIVE_CORRECTION_HINT, GL_NICEST'GL_FASTEST'GL_DONT_CARE'GL_NICEST


keypianotext=guiloadtexture("media/keypiano.jpg")
whitetext=guiloadtexture("media/white.jpg")

xmax2=xmax/2
ymax2=ymax/2

End Sub
Dim Shared As Double timedrawgl',timenotegl(256)
Sub drawgloff 
Dim As Integer i,j,k
    For i=1 To 6
    	For j=0 To 11
    		Var inote=j+i*12+12
    		timenotegl(inote)=max(timenote_(inote),timenotegl(inote))
    	   If timenotegl(inote)>timedrawgl-0.45 Then
    	     timedrawgl=min(Timer,timenotegl(inote)) 
    	   EndIf   	
    	Next 
    Next	
    glClearColor 0.10, 0.10, 0.10, 1.0      	
	 glClear GL_COLOR_BUFFER_BIT or GL_DEPTH_BUFFER_BIT
End Sub
Dim Shared As Double tcleargl,tplaywait
Dim Shared As Integer iplaygl,iplaywait
Sub drawgl
Dim As Integer i,j,k
       
    glClearColor 0.50, 0.50, 1.0, 1.0      	
	 glClear GL_COLOR_BUFFER_BIT or GL_DEPTH_BUFFER_BIT

    glLoadIdentity
    
    Var sc=(wy-500)/(768-500)
    sc=min(1.0,sc*sc)
    Var partitionpause2=0
    For i=1 To 6
    	gldisable gl_depth_test
    	glenable gl_texture_2D
      glbindtexture(gl_texture_2D,keypianotext)
      glpushmatrix
      If i=1 Then
      	glcolor3f(1,0.9,0.9)
      Else 
      	glcolor3F(1,1,1)
      EndIf
    	glplacecursor (i-0.485)*xmax/6,(ymax2-45)*sc,-40.2
      Var k1=xmax/1362
      glscalef(k1,(0.8+0.4)*sc,1)
      gltexcarre(40*1.488/6)
      glscalef(1,1.1/(0.8+0.4),1)
      glcolor3f(0,1,1)
      gldrawtext(Str(i),(i-0.915)*xmax/6.03,(ymax2+70)*sc,2.5)
    	glenable gl_texture_2D
    	Var ii=(i-0.915)*xmax/6,jj=ymax2+55
    	Var tclear=0
    	If iplaygl<>iiplay Then
    		iplaygl=iiplay:tcleargl=Timer  
    	EndIf
    	If Timer<tcleargl+0.001 Then tclear=1 
    	For j=0 To 11
    		Var inote=j+i*12+12+12
    		Var test=0
    		timenotegl(inote)=max(timenote_(inote),timenotegl(inote))
    		If noteon(inote)>=1 And inote<c96 Then timenotegl(inote)=max(timer,timenotegl(inote))
   	   If timenotegl(inote)>timedrawgl-0.3 Then 
    	      test=1 
    	   EndIf
    	   If test=1 Then 
    	     If inote<c96 Then timedrawgl=min(Timer,timenotegl(inote)) 	
    	     If j=1 Or j=3 Or j=6 Or j=8 Or j=10 Then
    	    	 glbindtexture gl_texture_2D,whitetext
    	    	 glcolor3f(1,0.15,0.15)
    	    	 If tclear=1 Then glcolor3f(1,0.50,0.25) 'glcolor3f(1,0.35,0.15) 
    	    	 If tnotewait(inote)>Timer+90 Then glcolor3f(0.5,0.850,0.425) 'glcolor3f(1,0.35,0.15) 
    	    	 glpushmatrix
    	    	 glplacecursor(ii,(jj-70-50)*sc,-40.1)
    	    	 glscalef(k1,2,1)
    	    	 gltexcarre(0.6)
    	    	 glpopmatrix
    	     Else
    	    	 glbindtexture gl_texture_2D,whitetext
    	    	 glcolor3f(1,0.15,0.15)
    	    	 If tclear=1 Then glcolor3f(1,0.50,0.15) 
    	    	 If tnotewait(inote)>Timer+90 Then glcolor3f(0.5,0.850,0.325) 'glcolor3f(1,0.35,0.15) 
    	    	 glpushmatrix
    	    	 glplacecursor(ii,(jj-20)*sc,-40.1)
    	    	 glscalef(k1,2.38,1)
    	    	 gltexcarre(0.9)
    	    	 glpopmatrix 
    	     EndIf
    	     If inote>=36 And inote<=36+12*6-1 And inote<c96 Then
    	     	 If tclear=0 Then
    	     	 	If tnotewait(inote)<Timer-5 Then
    	     	 		'tnotewait(inote)=max(Timer-6,tnotewait(inote))
    	     	 		partitionpause2=1
    	     	 	EndIf
    	     	 EndIf
    	     EndIf
    	    EndIf 
    	    ii+=xmax/(13*6)
    	    If j=1 Then ii-=xmax*0.001
    	    If j=3 Then ii-=xmax*0.002
    	    If j=4 Then ii+=xmax*0.01
    	    If j=6 Then ii-=xmax*0.002
    	    If j=8 Then ii-=xmax*0.002
    	    If j=10 Then ii-=xmax*0.001
    	Next
      glpopmatrix
    Next i
    If tpianoonly=2 Then 
     If tplay>0.5 And iiplay<iinote2 Then
    	If iiplay>0 And partitionpause=1 And partitionpause2=0 And Timer>tplaywait+1 Then
       	auxvar2=liaison(iiplay)+0.1
    	   If liaison(iiplay)>0.9 Then iiplay=min2(iinote2,iiplay+1)
    	   If liaison(iiplay)>0.9 Then iiplay=min2(iinote2,iiplay+1)
    	   If liaison(iiplay)>0.9 Then iiplay=min2(iinote2,iiplay+1)
    	   iplaywait=iiplay
    	   If iiplay>=iinote2 Then subplay()
     		For i=1 To 128
        		tnotewait(i)=Timer-9
     		Next
     		tplaywait=Timer 
    	EndIf
    	partitionpause=partitionpause2
    	If partitionpause=0 And Timer>tplaywait+1 Then
    		iplaywait=min2(iiplay,iplaywait)
    	   'If liaison(iplaywait)>0.9 Then iplaywait=min2(iinote2,iplaywait+1)
    	   'If liaison(iplaywait)>0.9 Then iplaywait=min2(iinote2,iplaywait+1)
    		iplaywait=min2(iinote2,iplaywait+1)
    		iiplay=iplaywait
    	ElseIf iplaywait>0 Then  
    		iiplay=iplaywait
    	EndIf
     Else 
    	iplaywait=iinote2
    	'iiplay=iplaywait
     EndIf
   EndIf   
 
End Sub














