'midiscore_chung a program by NGUYEN.Chung (freeware 2018)
Dim Shared As Double auxvar,auxvar2,auxvar3,auxvar4
Dim Shared As String auxtext
#Include Once "gui_chung.bi"
#Include Once "windows.bi"
#include Once "win/mmsystem.bi"
#Include Once "partition.bi"

Dim Shared As Integer quit=0
Sub guinotice2(ByRef msg As string,ByRef title As String ="notice")
Dim As HWND hwin
'ScreenControl(2, Cast(Integer,hwin)) 'get screen handle
	messagebox(hwin,msg,title,MB_TASKMODAL Or 0)
   Sleep 200
End Sub
Sub subquit
	quit=1
End Sub
Dim Shared As Integer mousex,mousey
Sub submovemouse
mousex=guimousex
mousey=guimousey	
End Sub

Type STATUSBYTE
  As Ubyte channel:4
  As Ubyte status :4
End Type

Type MIDIMESSAGE
  Union
  Type
  Union
  As STATUSBYTE Byte
  As Ubyte      byte0
  End Union
  As Ubyte      byte1
  As Ubyte      byte2
  As Ubyte      byte3
  End Type
  As Uinteger   value
  End Union
End Type

Dim Shared As Integer imidi,ichannel,minvelo
Dim Shared As Double tchannel(256)
Dim Shared As String ficin
Const As String ficini="midiscore_chung.ini"
Dim Shared As Integer File
file=FreeFile
Open ficini For Input As #file
imidi=0
If Not Eof(file) Then Line Input #file,ficin:imidi=Val(ficin)
ichannel=0
If Not Eof(file) Then Line Input #file,ficin:ichannel=Val(ficin)
minvelo=0
If Not Eof(file) Then Line Input #file,ficin:minvelo=Val(ficin)
Close #file


Dim Shared As Integer wx,wy,depth            
ScreenInfo wx,wy,depth
	 	         'Screen 0
	 	         'wx=1024
	 	         'wy=680
	 	         If wy<680 Then i50=0:dymax-=20 
	 	         Var dx=1018,dy=600
	 	         dx=wx-2:dy=wy-50
	 	         xmax=dx-2
	 	         ymax=dy-30
               graphicbox("win.graph",1,1,xmax,ymax)
               openwindow("win","midiscore_chung",1,1,dx,dy)
               
               wh=getguigfxbuffer("win.graph")
               trapclose("win",@subquit)
               trapmovemouse("win.graph",@submovemouse)
               
               'ScreenRes dx,dy,depth,1,4
               'ScreenControl(100,wx/2-dx/2,wy/2-24-dy/2) 'set window position
               Color RGB(155, 255, 255), RGB(0, 0, 100)
               partitionimage=bmp_load("media/partition1.bmp")
               partitionimage2=bmp_load("media/partition2.bmp")
               partitionimage3=bmp_load("media/partition3.bmp")
               partitionimage4=bmp_load("media/partition4.bmp")
               dieseimage=bmp_load("media/diese.bmp")
               mycls
               Put wh,(1,dymax+15),partitionimage,PSet
               Put wh,(1,dymax+255+i50),partitionimage,PSet
               partitionx=0:partitiony=0

Sub MidiInProc(Byval hDevice   As HMIDIIN, _
               Byval DriverMsg As Uinteger, _   
               Byval UserArg   As HMIDIOUT, _
               Byval MidiMsg   As MIDIMESSAGE, _   
               Byval Param2    As Uinteger)
  'Locate 0'Cls
  Select Case As Const DriverMsg
    Case MIM_DATA     
      If UserArg Then
         midiOutShortMsg(UserArg,MidiMsg.value)
         '? "send data to MIDI out time=" & Param2/1000
      Else
         '? "got MIDI in data time=" & Param2/1000
      End If
      
      With MidiMsg
        Select Case As Const .byte.status
          Case &H8
            '? "channel=" & .byte.channel _
            '& " note off key/note=" & .byte1 
          Case &H9
            If .byte2=0 Then ' if velocity=0
              '? "channel=" & .byte.channel _
              '& " note off key/note=" & .byte1
            Else
              '? "channel=" & .byte.channel _
              '& " note on  key/note=" & .byte1 _
              '& " velocity=" & .byte2
              'PSet (Timer-t1,MidiMsg.byte1)
              If ichannel=0 Or midimsg.byte.channel=(ichannel-1) Then
              	 If midimsg.byte2>=minvelo Then drawnote(midimsg.byte1)
              EndIf
              'tchannel(midimsg.byte.channel+1)=Timer
            End If
          Case &HA:'? "Polyphonic Aftertouch"
          Case &HB:'? "Control Mode Change " & .byte1 & "," & .byte2
          Case &HC:'? "Program Change "      & .byte1
          Case &HD:'? "Channel Aftertouch"
          Case &HE:'? "Pitch Wheel Control " & .byte1 & "," & .byte2*128
          Case &HF:'? "System Exclusive Message (SysEx)"
          Case Else
            '? "param1=" & Hex(.value,8) & " param2=" & Hex(Param2,8)
      End Select
    End With
    Case MIM_OPEN     : '? "MIDIIN open"
    Case MIM_CLOSE    : '? "MIDIIN close"
    Case MIM_LONGDATA
    Case MIM_ERROR
    Case MIM_LONGERROR
    Case MIM_MOREDATA 
    Case Else: '? "MIDIIN unknow message &H[" & Hex(DriverMsg) & "] !"
  End Select
End Sub


Dim As MMRESULT ret
ret=midiInGetNumDevs()
If ret<1 Then
  myprint  "error: sorry no MIDI input on this system!"
  Beep:Sleep':ImageDestroy partitionimage
  'End
end If
Dim As HMIDIIN hDevice
'imidi=1
ret=midiInOpen(@hDevice,imidi, _
                cast(Uinteger,@MidiInProc), _
                0, _
                CALLBACK_FUNCTION)
If ret Then
  myprint  "error can't open MIDI input "+Str(imidi)+" !"
  Beep:Sleep':ImageDestroy partitionimage
  imidi=0
  ret=midiInOpen(@hDevice,imidi, _
                cast(Uinteger,@MidiInProc), _
                0, _
                CALLBACK_FUNCTION)
  If ret Then
    myprint  "error can't open first MIDI input !"
    Beep:Sleep':ImageDestroy partitionimage
    'End
  EndIf   
EndIf

If hdevice Then 
 ret=midiInStart(hDevice)
 If ret Then
   midiInClose hDevice
   myprint  "error can't start MIDI input !"
   Beep:Sleep':ImageDestroy partitionimage
   'End
 EndIf 
EndIf
Sub drawtext0_old()
	Locate 5,10
	?"[M]midiin("+Str(imidi)+")   "
	Locate 5,30
	?"[C]channel("+Str(ichannel)+")  ";
	Locate 5,55
	?"[P]pause  ";
	Locate 5,75
	?"[R][T]minvelo="+Str(minvelo)+"   ";
End Sub
Sub drawtext0()
	mylocate 4,10
	myprint "[M]midiin("+Str(imidi)+")   "
	mylocate 4,30
	myprint "[C]channel("+Str(ichannel)+")  "';
	mylocate 4,55
	myprint "[P]pause  "';
	mylocate 4,75
	myprint "[R][T]minvelo="+Str(minvelo)+"   "';
End Sub
Sub drawtext00()
	drawtext0()
   Var i1=600
   Put wh,(i1,dymax),partitionimage,PSet
   Put wh,(i1,dymax+15),partitionimage,PSet
   Put wh,(i1,dymax+255+16),partitionimage,PSet
   Put wh,(i1,dymax+255+i50),partitionimage,PSet
   Put wh,(1,dymax),partitionimage,PSet
   Put wh,(1,dymax+15),partitionimage,PSet
   Put wh,(1,dymax+255+16),partitionimage,PSet
   Put wh,(1,dymax+255+i50),partitionimage,PSet
End Sub
Dim Shared As String resp,msgtext,crlf:crlf=Chr(13)+Chr(10)
Sub mycls2
	msgtext=""
End Sub
Sub myprint2(text As String)
	If Len(msgtext)<5000 Then msgtext+=text+crlf
End Sub
Sub subresp
resp=guigettext("win2.resp")
End Sub
Sub prompt(ByRef msg0 As String,ByRef resp0 As String)
Dim As Integer x400 
x400=max2(400,400)'Len(msg0)*10)
statictext("win2.msg","",10,10,x400,350)
edittext("win2.resp","",@subresp,10,360,x400,20)
openwindow("win2","freewebcar_chung",50,50,x400+50,440)
printgui("win2.msg",msg0)
printgui("win2.resp",resp0)
guisetfocus("win2.resp")
While guitestkey(vk_escape)=0 And guitestkey(vk_return)=0
	guiscan
	Sleep 100
Wend
Sleep 100
guiscan
resp=guigettext("win2.resp")
guiclosewindow("win2")
Sleep 200
guiscan 
End Sub
Sub myinput(ByRef resp As String)
	prompt(msgtext,resp)
End Sub

'Cls
Line wh,(0,0)-(xmax,ymax),RGB(0,0,100),bf
drawtext00()
guirefreshwindow("win")
'quit=1

Dim Shared As String key
'While InKey<>"":Sleep 100:Wend 
While Key="" And quit=0
	key=LCase(guiInKey)'does guiscan 
	If timedrawnote>1 And Timer>timedrawnote+0.5 Then
		timedrawnote=0
		drawnotes()
	EndIf
   If key="p" Then'Or GetMouse(mousex2,mousey2,wheel2,buttons2)=0 Then
      	If key="p" Then'Or (1 And buttons2) Then
      		partitionpause=(partitionpause+1)Mod 2
      		If partitionpause=1 Then
      			Draw String wh,(440,55),"PAUSE",RGB(255,0,0)
      		Else
      			Draw String wh,(440,55),"PAUSE",RGB(0,0,100)
      		EndIf
      		Sleep 200
         	key=""
      	EndIf
   EndIf
   If key="m" Then
   	partitionpause=1
	   mycls2:mylocate 2,1
      Dim As midiincaps mymidiincaps
      ret=midiInGetNumDevs()
      Var nmidi=ret
      If ret<1 Then
         myprint2 "warning : sorry no MIDI input on this system!"
         Beep:guinotice msgtext'Sleep
      Else
         nmidi=min2(30,nmidi)
         Var i=0	
         for i=0 to nmidi-1
             ret=midiInGetDevCaps(i,@mymidiincaps,SizeOf(mymidiincaps))
             If ret=0 Then
             	 myprint2 Str(i)+"="+Trim(mymidiincaps.szPname)
             EndIf
         Next i
      EndIf 
      myprint2 ""
	   myprint2 "midiin : enter a value (0.."+Str(nmidi-1)+")"
	   myprint2 "        initial=0  last="+Str(imidi)
	   myInput resp';resp
	   If resp<>"" Then 
	   	imidi=max2(0,min2(nmidi-1,Val(resp)))
         midiInStop  hDevice
	   	midiinClose hdevice
         imidi=max2(0,min2(nmidi-1,imidi))	
         ret=midiInOpen(@hDevice,imidi, _
                 cast(Uinteger,@MidiInProc), _
                 0, _
                 CALLBACK_FUNCTION)
         If ret Then
	             myprint2 ("warning error open midiin("+Str(imidi)+")")
                Beep:guinotice msgtext'Sleep':ImageDestroy partitionimage
                'End
         EndIf
         If ret=0 Then
         	ret=midiInStart(hDevice)
            If ret Then
                midiInClose hDevice
                myprint2  "error can't start MIDI input !"
                Beep:guinotice msgtext'Sleep':ImageDestroy partitionimage
                'End
             EndIf
         EndIf
	   EndIf
	   key=""
	   mycls 
     	drawtext00()
     	partitionpause=0
   EndIf
   If key="c" Then
   	partitionpause=1
   	mycls2
   	myprint2 ""
   	myprint2 "midi channel : enter a number 0=all  1...16  last="+Str(ichannel)
   	myprint2 ""
	   myInput resp';resp
	   If resp<>"" Then 
	   	ichannel=max2(0,min2(16,Val(resp)))
	   EndIf
	   Sleep 200
	   mycls 
	   drawtext00()
   	partitionpause=0
	   key=""
   EndIf 
   If key="r" Then
   	minvelo=max2(0,minvelo-5)
   	drawtext0()
   	Sleep 300
   	guiscan'While InKey<>"":Wend
   EndIf
   If key="t" Then
   	minvelo=min2(125,minvelo+5)
   	drawtext0()
   	Sleep 300
   	guiscan'While InKey<>"":Wend 
   EndIf
   /'Var i=0
   For i=1 To 16
   	If i<10 Then
   		Locate 5,84+i*2
   	Else 
   		Locate 5,84+20+(i-10)*3
   	EndIf
   	If Timer>tchannel(i)+0.5 Then
         Color RGB(155, 255, 255), RGB(0, 0, 100)
   		?Str(i);
   	Else 
         Color RGB(255, 100, 100), RGB(0, 0, 100)
   		?Str(i);
   	EndIf
   Next
   Color RGB(155, 255, 255), RGB(0, 0, 100)
	'/
	If guitestkey(vk_up) Then auxvar2+=1
	If guitestkey(vk_down) Then auxvar2-=1
	Sleep 100
	If InStr("abcdefghijklmnopqrstuvwxyz1234567890",key)>0 Then key=""
   If Abs(auxvar)>0.000001 Then mylocate 1,100:myprint "aux="+Str(auxvar)+"          "'; 
   If Abs(auxvar2)>0.000001 Then mylocate 2,100:myprint "aux2="+Str(auxvar2)+"          "'; 
   If Abs(auxvar3)>0.000001 Then mylocate 3,100:myprint "aux3="+Str(auxvar3)+"          "'; 
   If Abs(auxvar4)>0.000001 Then mylocate 4,100:myprint "aux4="+Str(auxvar4)+"          "'; 
   If auxtext<>"" Then mylocate 5,100:myprint auxtext+"          "'; 

   guirefreshwindow("win")

Wend
midiInStop   hDevice
midiInClose  hDevice
ImageDestroy partitionimage
ImageDestroy dieseimage
ImageDestroy partitionimage2
ImageDestroy partitionimage3
ImageDestroy partitionimage4


file=freefile
Open ficini For Output As #file
Print #file,imidi
Print #file,ichannel
Print #file,minvelo
Close #file


guiclose()
guiquit()

End













